package de.associativememorypicture.control;

import java.awt.Color;
import java.awt.Container;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;

import de.associativememorypicture.system.Globals;
import n4e.core.controls.AWTextField;
import n4e.core.tool.Tool4Throwable;

/**
 * The <CODE>Value</CODE> class for values of the layers.
 * description: AssociativeMemoryPicture
 * copyright: (c) 2017 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.
 * @author thomas kaffka, cologne , germany.
 * @version 09.02.2017 14:31:59
 * @since 0.1
 */
public class Value {

	private AWTextField tfField;
	private int value;
	
	/**
	 * The constructor <CODE>Value</CODE> creates a new instance(object)
	 * of the class.
	 * @param c the container.
	 * @param x the x coordinate.
	 * @param y the y coordinate.
	 * @param width the width of the control.
	 * @param height the height of the control.
	 * @since 0.1
	 */
	public Value(Container c, int x, int y, int width, int height) {
		
		tfField = new AWTextField();
		tfField.setBounds(x, y, width, height);
		tfField.setEditable(false);
		
		tfField.addMouseListener(new java.awt.event.MouseListener() {
			public void mouseClicked(MouseEvent e) {
				try {
					if (e.getButton() == 1) { // left button.
						if (value == 0) {
							value = 1;
						} else if (value < 0) {
							value = 1;
						} else if (value > 0) {
							value = -1;
						}
						setValue(value);
					}
				} catch (Exception ex) {
					Globals.t4d.showException(Tool4Throwable.getCallStackOut(ex));
				}
			}
			public void mouseEntered(MouseEvent e) {}
			public void mouseExited(MouseEvent e) {}
			public void mousePressed(MouseEvent e) {}
			public void mouseReleased(MouseEvent e) {}
    	});

		c.add(tfField);
	}
	
	/**
	 * The method <CODE>setValue</CODE> sets the value an the value of the text field.
	 * @param val the value.
	 */
	public void setValue(int val) {
		value = val;
		Color color = Color.WHITE;
		if (value > 0) {
			color = Color.GREEN;
		} if (value < 0) {
			color = Color.YELLOW;
		}
		tfField.setBackground(color);
	}

	/**
	 * The method <CODE>getValue</CODE> returns the value.
	 */
	public int getValue() {
		return value;
	}

	/**
	 * The method <CODE>getTextField</CODE> returns the text field.
	 */
	public AWTextField getTextField() {
		return tfField;
	}

}
