package de.associativememorypicture.tool;

import n4e.core.tool.Tool4DbMessages;

/**
 * The <CODE>Tool4AMMessage</CODE> class  provides messages for the application.
 * <P><B>title: AssociativeMemoryPicture</B></P>
 * <P>description: AssociativeMemoryPicture</P>
 * <P>copyright: (c) 2017 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , cologne , germany.
 * @version 09.02.2017 08:41:18
 * @since 1.0
 */

public class Tool4AMMessage {

    private String language_code = null;

    /**
	 * The constructor <CODE>Tool4AMMessage</CODE> creates a new instance(object) of the class.
	 * @param language_code the language code.
	 * @since 1.0
	 */
	public Tool4AMMessage(String language_code) {
        this.language_code = language_code;
	}

    /**
     * The method <CODE>getMessages</CODE> gets the messages of the language.
     * @return the message object.
     * @since 1.0
   */
    public Tool4DbMessages getMessages() {
        Tool4DbMessages mess = null;
        if (language_code.equals("de")) {
            mess = new Tool4AMMessages_de();
        } else if (language_code.equals("en")) {
            mess = new Tool4AMMessages_en();
        }
        return mess;
    }
}

