package n4e.expertanddecision.dbaccess;

/**
* <p>title: n4e application</p>
* <p>description: expertanddecision</p>
* <p>copyright: copyright (c) 2006-2011 by thomas kaffka; mba; all rights reserved.</p>
* <p>company: n.n.</p>
* @author thomas kaffka, mba.
* @version Fri May 01 16:26:19 CEST 2015
*/

import java.sql.*;
import java.text.*;
import java.util.*;
import java.math.*;
import java.rmi.server.UID;
import java.util.zip.*;
import java.io.*;
import java.nio.*;
import java.security.*;

import n4e.core.database.*;
import n4e.core.dbaccess.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.core.list.*;



/**
 * The <CODE>DbAccessKeyWord</CODE> class reads fields and put to data sink of KeyWord table in database.
 * @author Dipl.-Kfm. Thomas Kaffka
 * @version Fri May 01 16:26:19 CEST 2015
 * @since 1.0
*/
public class DbAccessKeyWord extends DbAccess {



    // individual database fields
  private String name = ""; // Schluesselname
  private String old_name = ""; // (old value of) Schluesselname
  private String name2 = ""; // Schluesselname
  private String old_name2 = ""; // (old value of) Schluesselname
  private String name3 = ""; // Schluesselname
  private String old_name3 = ""; // (old value of) Schluesselname
  private String name4 = ""; // Schluesselname
  private String old_name4 = ""; // (old value of) Schluesselname
  private String name5 = ""; // Schluesselname
  private String old_name5 = ""; // (old value of) Schluesselname
  private int canchangename = 0; // Schluesselname aenderbar
  private int old_canchangename = 0; // (old value of) Schluesselname aenderbar
  private String description = ""; // Beschreibung
  private String old_description = ""; // (old value of) Beschreibung
  private String description2 = ""; // Beschreibung
  private String old_description2 = ""; // (old value of) Beschreibung
  private String description3 = ""; // Beschreibung
  private String old_description3 = ""; // (old value of) Beschreibung
  private String description4 = ""; // Beschreibung
  private String old_description4 = ""; // (old value of) Beschreibung
  private String description5 = ""; // Beschreibung
  private String old_description5 = ""; // (old value of) Beschreibung
  private String parameter1 = ""; // Parameter 1
  private String old_parameter1 = ""; // (old value of) Parameter 1
  private String parameter2 = ""; // Parameter 2
  private String old_parameter2 = ""; // (old value of) Parameter 2
  private String parameter3 = ""; // Parameter 3
  private String old_parameter3 = ""; // (old value of) Parameter 3
  private String parameter4 = ""; // Parameter 4
  private String old_parameter4 = ""; // (old value of) Parameter 4
  private String parameter5 = ""; // Parameter 5
  private String old_parameter5 = ""; // (old value of) Parameter 5
  private int candelete = 0; // vom Admin loeschbar
  private int old_candelete = 0; // (old value of) vom Admin loeschbar
  private DbAccessKeySet myDbAccessKeySet = null ; // KeySet
  private DbAccessKeySet old_myDbAccessKeySet = null ; // (old value of) KeySet


  // sets and gets of individual table fields
  public void setName(String input){name = input;}
  public String getName(){return name;}
  public void setName2(String input){name2 = input;}
  public String getName2(){return name2;}
  public void setName3(String input){name3 = input;}
  public String getName3(){return name3;}
  public void setName4(String input){name4 = input;}
  public String getName4(){return name4;}
  public void setName5(String input){name5 = input;}
  public String getName5(){return name5;}
  public void setCanchangename(int input){canchangename = input;}
  public int getCanchangename(){return canchangename;}
  public void setDescription(String input){description = input;}
  public String getDescription(){return description;}
  public void setDescription2(String input){description2 = input;}
  public String getDescription2(){return description2;}
  public void setDescription3(String input){description3 = input;}
  public String getDescription3(){return description3;}
  public void setDescription4(String input){description4 = input;}
  public String getDescription4(){return description4;}
  public void setDescription5(String input){description5 = input;}
  public String getDescription5(){return description5;}
  public void setParameter1(String input){parameter1 = input;}
  public String getParameter1(){return parameter1;}
  public void setParameter2(String input){parameter2 = input;}
  public String getParameter2(){return parameter2;}
  public void setParameter3(String input){parameter3 = input;}
  public String getParameter3(){return parameter3;}
  public void setParameter4(String input){parameter4 = input;}
  public String getParameter4(){return parameter4;}
  public void setParameter5(String input){parameter5 = input;}
  public String getParameter5(){return parameter5;}
  public void setCandelete(int input){candelete = input;}
  public int getCandelete(){return candelete;}
  public void setMyDbAccessKeySet(DbAccessKeySet input){myDbAccessKeySet = input;}
  public DbAccessKeySet getMyDbAccessKeySet(){return myDbAccessKeySet;}


  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object.
   * @since 1.0
  */
  public DbAccessKeyWord(){
      setWorkFields();
  }

  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object.
   * @param sysUser the system user.
   * @since 1.0
  */
  public DbAccessKeyWord(List4SysUser sysUser){
    setSystemUser(sysUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }
  }

  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object.
   * @param pUser the user object.
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeyWord(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    initiate(pUser, uniqueid , fieldlist , privfkey , publfkey , null, true);

  }

  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object.
   * @param conn the database connection.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeyWord(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , null, true);

  }

  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object with additional sqlwhere.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeyWord(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd) throws Exception {

    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd, true);

  }

  /**
   * The constructor <CODE>DbAccessKeyWord</CODE> initialized the object with additional sqlwhere.
   * @param conn the database connection.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeyWord(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd, true);

  }

  /**
   * The method <CODE>initiate</CODE> initializes the object with additional sqlwhere.
   * @param pUser the user object.
   * @param uniqueid the unique key.
   * @param fieldlist List of fields to load.
   * @param privfkey List of privfkeys to load.
   * @param publfkey List of publfkeys to load.
   * @param sqlAdd additional where clause.
   * @param read_with_client read with use of the clientid.
   * @exception Exception.
   * @since 1.0
  */
  public void initiate(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd , boolean read_with_client) throws Exception {

    this.read_with_client = read_with_client;
    setSystemUser(pUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;

    privateforeignkeytable.put("idkeyset","KeySet|null");



    success = loadFromTable(uniqueid , fieldlist , privfkey , publfkey , sqlAdd);
  }

  /**
   * The method <CODE>setWorkFields</CODE> sets the work fiels to current values.
   * @since 1.0
  */
  public void setWorkFields() {
      dbtablename = "KeyWord"; // name of own database table
      if (sysUser != null) {
          databasename = sysUser.getClientDbsystemforeclient(); // name of own database
          myDatabaseConnectionSet = DatabaseManager.getDatabaseConnectionSet(databasename);
          setProtocol(dbtablename);
      }
      tblnameofprivk = ",KeySet,"; // list of table names of private foreign keys
      tblnameofpublvk = ","; // list of table names of public foreign keys
      keynameofpublvk = ","; // list of key names of table names of
      tblnameofownerfield = ","; // list of names of table names of public foreign keys owner key
      indivTableFields = ",name,name2,name3,name4,name5,canchangename,description,description2,description3,description4,description5,parameter1,parameter2,parameter3,parameter4,parameter5,candelete,"; // list of inidividual table fields
      privateforeignkey = ";idkeyset;"; // list of private foreign key fields
      publicforeignkey = ";"; // list of public foreign key fields
  }

  /**
   * The method <CODE>loadFromTable</CODE> gets tabledata from database with fieldcheck.
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean loadFromTable(String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd ) throws Exception {

    errCode = 0;
    errMess = "";

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;
    hasdata = false;
    // create connection to defined database system
    if (this.myconn) {
        this.conn = myDatabaseConnectionSet.conn();
    }
    DatabaseSQLResultSet resSet = new DatabaseSQLResultSet(databasename , conn);



    // handle fields to load
    String sqlFieldlist = "";
    String sqlPrivfkey = "";

    // build sql field list
    if (fieldlist != null && fieldlist.equals("all")) {
      sqlFieldlist = indivTableFields.substring(1);
    } else { // make individual fieldlist
      if (fieldlist != null) {
        sqlFieldlist = fieldlist;
      } else {
        sqlFieldlist = "";
      }
    }

    // build sql field list of private foreign keys
    if (privfkey != null && privfkey.equals("all")) {
      sqlPrivfkey = privateforeignkey.substring(1);
    } else { // make individual fieldlist
      if (privfkey != null) {
          int pos = privfkey.indexOf("(");
          if (pos >= 0) {
            StringTokenizer stok = new StringTokenizer(privfkey , ";"); // public foreign keys separated by ;
            while (stok.hasMoreTokens()) { // for each public foreign key
                String xfield = stok.nextToken();
                pos = xfield.indexOf("(");
                if (pos >= 0) {
                    sqlPrivfkey += "," + xfield.substring(0, pos);
                } else {
                    sqlPrivfkey += "," + xfield;
                }
            }
            sqlPrivfkey = sqlPrivfkey.substring(1);
          } else {
            sqlPrivfkey = t4st.replaceToken(privfkey , ";" , ",");
          }
      } else {
        sqlPrivfkey = "";
      }
    }

    StringTokenizer stok = null;

    String workingSqlFieldlist = stdTableFields + sqlFieldlist;
    if (workingSqlFieldlist.endsWith(",")) {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?sqlPrivfkey:"")+",";
    } else {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?","+sqlPrivfkey:"")+",";
    }


    int len = workingSqlFieldlist.length();
    workingSqlFieldlist = workingSqlFieldlist.substring(1,len-1);
    if (workingSqlFieldlist.endsWith(",")) {
      len = workingSqlFieldlist.length();
      workingSqlFieldlist = workingSqlFieldlist.substring(0,len-1);
    }

    resetFields();

    // grip into data sink
    if (uniqueid == null && sqlAdd == null) {
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
        errCode = ERROR_0001;
        errMess = t4m.getMessage("msg0001", null);
        return false;
    }

    String client_temp = client;
    if (!read_with_client) {
        client = null;
    }

    String where1 = ((client!=null&&client.length()>0)?("client='"+client+"'"):"");
    String where2 = ((uniqueid!=null&&uniqueid.length()>0)?("uniqueid='"+ uniqueid +"'"):"");
    String where3 = ((sqlAdd!=null&&sqlAdd.length()>0)?sqlAdd:"");
    String where = "";
    if (where1.length()==0 && where2.length()==0 && where3.length()==0) { // 000
      where = "";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()==0) { // 100
      where = " WHERE (" + where1 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()==0) { // 010
      where = " WHERE (" + where2 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()==0) { // 110
      where = " WHERE (" + where1 + ") AND (" + where2 + ")";
    } else if (where1.length()==0 && where2.length()==0 && where3.length()>0) { // 001
      where = " WHERE (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()>0) { // 101
      where = " WHERE (" + where1 + ") AND (" + where3 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()>0) { // 011
      where = " WHERE (" + where2 + ") AND (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()>0) { // 111
      where = " WHERE (" + where1 + ") AND (" + where2 + ") AND (" + where3 + ")";
    }

    String sqlStatement = "SELECT " + workingSqlFieldlist + " FROM KeyWord " + where;
    conn.connectionlog("DbAccessKeyWord","sql statement", sqlStatement);
    ResultSet result = resSet.getResultSet(sqlStatement);
    if (result.next() && (result.isFirst() && result.isLast())) {
      hasdata = true;
      // get standard fields
      setUniqueid(result.getString(1));
      setVersion(result.getLong(2));
      long temp_timestamp = result.getLong(3);
      java.util.Date temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setCreated(temp_date);
      setCreator(result.getString(4));
      temp_timestamp = result.getLong(5);
      temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setChanged(temp_date);
      setChangedfrom(result.getString(6));
      setInuse(result.getInt(7));
      setClient(result.getString(8));

      //get individual fields
      int i = 9;
      workingSqlFieldlist = sqlFieldlist + (sqlPrivfkey.length()>0?","+sqlPrivfkey:""); // only individuals.
      stok = new StringTokenizer(workingSqlFieldlist ,",");
      while (stok.hasMoreTokens()) {
        String xfield = stok.nextToken();
        if (false) {}
          // dummy
          else if (xfield.equals("name")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName(value);old_name = value;}
          else if (xfield.equals("name2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName2(value);old_name2 = value;}
          else if (xfield.equals("name3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName3(value);old_name3 = value;}
          else if (xfield.equals("name4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName4(value);old_name4 = value;}
          else if (xfield.equals("name5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName5(value);old_name5 = value;}
          else if (xfield.equals("canchangename")) {int value = result.getInt(i);setCanchangename(value);old_canchangename = value;}
          else if (xfield.equals("description")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription(value);old_description = value;}
          else if (xfield.equals("description2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription2(value);old_description2 = value;}
          else if (xfield.equals("description3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription3(value);old_description3 = value;}
          else if (xfield.equals("description4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription4(value);old_description4 = value;}
          else if (xfield.equals("description5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription5(value);old_description5 = value;}
          else if (xfield.equals("parameter1")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setParameter1(value);old_parameter1 = value;}
          else if (xfield.equals("parameter2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setParameter2(value);old_parameter2 = value;}
          else if (xfield.equals("parameter3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setParameter3(value);old_parameter3 = value;}
          else if (xfield.equals("parameter4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setParameter4(value);old_parameter4 = value;}
          else if (xfield.equals("parameter5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setParameter5(value);old_parameter5 = value;}
          else if (xfield.equals("candelete")) {int value = result.getInt(i);setCandelete(value);old_candelete = value;}
          else if (xfield.equals("idkeyset")) {}

        i++;
      }

      //get individual privateforeignkeys
      if (privfkey != null && privfkey.length()>0) {
        String pffieldlist = "";
        if (privfkey.equals("all")) { // load all private foreign key objects with field list 'all'
          privfkey = privateforeignkey.substring(1);
        }
        stok = new StringTokenizer(privfkey , ";"); // private foreign keys separated by ;
        while (stok.hasMoreTokens()) { // for each private foreign key
          String xfield = stok.nextToken();
          if (xfield == null || xfield.length() == 0) continue;
          if (xfield.indexOf("(") > -1) { // private foreign key with field list
            StringTokenizer stfield = new StringTokenizer(xfield ,"(");
            if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (pffieldlist.endsWith(")")) {
              pffieldlist = pffieldlist.substring(0, pffieldlist.length()-1);
            }
          } else {
            pffieldlist = "all";
          }
          if (false) {}
            else if (xfield.equals("idkeyset")) {
              DbAccessKeySet tempIdkeyset = new DbAccessKeySet(conn , sysUser , result.getString("idkeyset") , pffieldlist , null , null);
              if (tempIdkeyset.errCode == -17) {
                setMyDbAccessKeySet(null);
                old_myDbAccessKeySet = null;
              } else if (tempIdkeyset.errCode == 0) {
                setMyDbAccessKeySet(tempIdkeyset);
                old_myDbAccessKeySet = tempIdkeyset;
              } else  if (tempIdkeyset.errCode != ERROR_0001) {
                errCode = tempIdkeyset.errCode;
                errMess = tempIdkeyset.errMess;
              }
            }

          }
        }

     } else { // no data found
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
       errCode = ERROR_0002;
       errMess = t4m.getMessage("msg0002", null);
       return false;
     }

    //get individual publicforeignkeys
    if (publfkey != null && publfkey.length() > 0) {
      String pffieldlist = "";
      if (publfkey.equals("all")) { // load all public foreign key objects with field list 'all'
        publfkey = publicforeignkey.substring(1);
      }
      DatabaseDatasetLoader dsl = new DatabaseDatasetLoader(this.conn);
      stok = new StringTokenizer(publfkey , ";"); // public foreign keys separated by ;
       while (stok.hasMoreTokens()) { // for each public foreign key
        String xfield = stok.nextToken();
        if (xfield == null || xfield.length() == 0) continue;
        StringTokenizer stfield = null;
        if (xfield.indexOf("(") > -1) { // public foreign key with field list
          stfield = new StringTokenizer(xfield , "(");
          if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
          if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
          if (pffieldlist.endsWith(")")) {
            pffieldlist = pffieldlist.substring(0, pffieldlist.length() - 1);
          }
        } else {
          pffieldlist = "all";
        }
        String orderby = null;
        if (pffieldlist.indexOf("|") > -1) { // order by feilds available.
            stfield = new StringTokenizer(pffieldlist ,"|");
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (stfield.hasMoreTokens()) orderby = stfield.nextToken();
        }
        String pfTableName = (String) publicforeignkeytable.get(xfield);
        String pfkeyfield = "";
        StringTokenizer staccess = new StringTokenizer(pfTableName , "|");
        if (staccess.hasMoreTokens()) pfTableName = staccess.nextToken();
        if (staccess.hasMoreTokens()) pfkeyfield = staccess.nextToken();
        String sql = pfkeyfield + " = '" + result.getString("uniqueid") + "'";
        ArrayList keyList = dsl.getDataSet(sysUser , pfTableName , pffieldlist , null , null , sql , orderby , "expertanddecision");
        if (false) {}

      }
    }

    if (!read_with_client) {
        client = client_temp;
    }

    resSet.closeResultSet();
    resSet = null;
    if (this.myconn) {
        myDatabaseConnectionSet.connClose(conn);
    }



    return true;
  }

  /**
   * The method <CODE>putToSink</CODE> stores the data to database (data sink).
   * @param conn Connection to Database, if null => make own connection
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putToSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;

    // get connection
    boolean ownconn = false;
    if (conn == null) {
      conn = myDatabaseConnectionSet.conn();
      conn.setAutoCommit(false);
      ownconn = true;
    }

    initializeStandardFields();

    try {
        if (hasdata) {
          ok = putCurrentDataToSink(conn);
        } else {
          ok = putNewDataToSink(conn);
        }
    } catch (Exception ex) {
        String message = ex.getMessage();
        if (message != null) {
            // check if duplicate data in an unique key.
            // 'duplicate' unique index of mysql.
            // 'unique constraint or index violation' unique index of hsqldb.
            if (message.toLowerCase().indexOf("duplicate") >= 0 ||
                 message.toLowerCase().indexOf("unique constraint or index violation") >= 0) {
              errCode = ERROR_0104;
              errMess = t4m.getMessage("msg0104", null);
              ok = false;
            } else {
                conn.getDatabaseSystem().writeLine2Log(Tool4Throwable.getCallStackOut(ex));
                conn.getDatabaseSystem().flushLog();
                conn.rollback();
                System.out.println(Tool4Throwable.getMessage4Log("see log of database system: " + conn.getDatabaseSystem().getSystemName()));
                throw new Exception(ex);
            }
        } else {
            conn.getDatabaseSystem().writeLine2Log(Tool4Throwable.getCallStackOut(ex));
            conn.getDatabaseSystem().flushLog();
            conn.rollback();
            System.out.println(Tool4Throwable.getMessage4Log("see log of database system: " + conn.getDatabaseSystem().getSystemName()));
            throw new Exception(ex);
        }
    }

    if (ownconn) {
      if (ok) {
        conn.commit();
      } else {
        conn.rollback();
      }
      myDatabaseConnectionSet.connClose(conn);
    }

    return ok;
  }

  /**
   * The method <CODE>putNewDataToSink</CODE> executes an sql insert.
   * @param conn the database connection.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putNewDataToSink(DatabaseConnection conn) throws Exception {
    return putNewDataToSink(conn , new Boolean(true));
  }

  /**
   * The method <CODE>putNewDataToSink</CODE> executes an sql insert.
   * @param conn the database connection.
   * @param dotrigger, do the trigger.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putNewDataToSink(DatabaseConnection conn , Boolean dotrigger) throws Exception {
    boolean ok = true;



    // identify fields to insert
    String insertFieldlist = "";
    String insertValuelist = "";
    if (name != null && name.length()>0) {
        insertFieldlist += ",name";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name)+"'";
    }
    if (name2 != null && name2.length()>0) {
        insertFieldlist += ",name2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name2)+"'";
    }
    if (name3 != null && name3.length()>0) {
        insertFieldlist += ",name3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name3)+"'";
    }
    if (name4 != null && name4.length()>0) {
        insertFieldlist += ",name4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name4)+"'";
    }
    if (name5 != null && name5.length()>0) {
        insertFieldlist += ",name5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name5)+"'";
    }
    insertFieldlist += ",canchangename";
    insertValuelist += ","+Integer.toString(canchangename)+"";
    if (description != null && description.length()>0) {
        insertFieldlist += ",description";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description)+"'";
    }
    if (description2 != null && description2.length()>0) {
        insertFieldlist += ",description2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description2)+"'";
    }
    if (description3 != null && description3.length()>0) {
        insertFieldlist += ",description3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description3)+"'";
    }
    if (description4 != null && description4.length()>0) {
        insertFieldlist += ",description4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description4)+"'";
    }
    if (description5 != null && description5.length()>0) {
        insertFieldlist += ",description5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description5)+"'";
    }
    if (parameter1 != null && parameter1.length()>0) {
        insertFieldlist += ",parameter1";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(parameter1)+"'";
    }
    if (parameter2 != null && parameter2.length()>0) {
        insertFieldlist += ",parameter2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(parameter2)+"'";
    }
    if (parameter3 != null && parameter3.length()>0) {
        insertFieldlist += ",parameter3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(parameter3)+"'";
    }
    if (parameter4 != null && parameter4.length()>0) {
        insertFieldlist += ",parameter4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(parameter4)+"'";
    }
    if (parameter5 != null && parameter5.length()>0) {
        insertFieldlist += ",parameter5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(parameter5)+"'";
    }
    insertFieldlist += ",candelete";
    insertValuelist += ","+Integer.toString(candelete)+"";
    if (myDbAccessKeySet != null) {
        insertFieldlist += ",idkeyset";
        insertValuelist += ",'"+myDbAccessKeySet.getUniqueid()+"'";
    }


    // test before store
    DbAccessCheckKeyWord test = new DbAccessCheckKeyWord(t4m);
    if (!test.checkData(this , true , insertFieldlist + ",")) {
      errCode = test.errCode;
      errMess = test.errMess;
      return false;
    }

    String sqlTest = insertFieldlist + ",";
    String temp_changed = "null";
    java.util.Date temp_changed_date = getChanged();
    if (temp_changed_date != null) {
        temp_changed = Long.toString(temp_changed_date.getTime());
    }
    String temp_changedfrom = getChangedfrom();
    if (temp_changedfrom == null) {
        temp_changedfrom = "null";
    } else {
        temp_changedfrom = "'" + temp_changedfrom + "'";
    }

    if (insertFieldlist.length() > 0) {
      String insertFields = "uniqueid,version,created,creator,changed,changedfrom,inuse,client" + (insertFieldlist.length()>0?insertFieldlist:"");
      String valueFields = "'"+ uniqueid +"',"+Long.toString(version)+","+Long.toString(created.getTime())+",'"+ creator +"',"+temp_changed+","+temp_changedfrom+","+Integer.toString(inuse)+",'"+getClient()+"'"+ (insertValuelist.length()>0?insertValuelist:"");
      String sqlStatement = "INSERT INTO KeyWord ("+insertFields+") VALUES ("+valueFields+")";
      conn.connectionlog("DbAccessKeyWord","sql statement", sqlStatement);
      setKeyWordsAsUsed(conn);
      PreparedStatement ps = conn.prepareStatement(sqlStatement);
      int psndx = 0;

      ps.execute();
      ps.close();
    }



    if (ok) {
        errCode = MSG_0006;
        errMess = t4m.getMessage("msg0006", null);
    }
    return ok;
  }

  /**
   * The method <CODE>putCurrentDataToSink</CODE> executes an sql update.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putCurrentDataToSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;



    // identify fields to update
    String sqlStatement = "UPDATE KeyWord SET version="+Long.toString(version)+",changed="+Long.toString(changed.getTime())+",changedfrom='"+changedfrom +"',inuse="+Integer.toString(inuse)+"";
    String updateFieldlist = "";
    if (hasChanged("name")) {updateFieldlist += ",name"; sqlStatement += (name==null?",name=null":",name='"+t4st.replaceCharsWithSQL(name)+"'");}
    if (hasChanged("name2")) {updateFieldlist += ",name2"; sqlStatement += (name2==null?",name2=null":",name2='"+t4st.replaceCharsWithSQL(name2)+"'");}
    if (hasChanged("name3")) {updateFieldlist += ",name3"; sqlStatement += (name3==null?",name3=null":",name3='"+t4st.replaceCharsWithSQL(name3)+"'");}
    if (hasChanged("name4")) {updateFieldlist += ",name4"; sqlStatement += (name4==null?",name4=null":",name4='"+t4st.replaceCharsWithSQL(name4)+"'");}
    if (hasChanged("name5")) {updateFieldlist += ",name5"; sqlStatement += (name5==null?",name5=null":",name5='"+t4st.replaceCharsWithSQL(name5)+"'");}
    if (hasChanged("canchangename")) {updateFieldlist += ",canchangename";sqlStatement+=",canchangename="+Integer.toString(canchangename)+"";}
    if (hasChanged("description")) {updateFieldlist += ",description"; sqlStatement += (description==null?",description=null":",description='"+t4st.replaceCharsWithSQL(description)+"'");}
    if (hasChanged("description2")) {updateFieldlist += ",description2"; sqlStatement += (description2==null?",description2=null":",description2='"+t4st.replaceCharsWithSQL(description2)+"'");}
    if (hasChanged("description3")) {updateFieldlist += ",description3"; sqlStatement += (description3==null?",description3=null":",description3='"+t4st.replaceCharsWithSQL(description3)+"'");}
    if (hasChanged("description4")) {updateFieldlist += ",description4"; sqlStatement += (description4==null?",description4=null":",description4='"+t4st.replaceCharsWithSQL(description4)+"'");}
    if (hasChanged("description5")) {updateFieldlist += ",description5"; sqlStatement += (description5==null?",description5=null":",description5='"+t4st.replaceCharsWithSQL(description5)+"'");}
    if (hasChanged("parameter1")) {updateFieldlist += ",parameter1"; sqlStatement += (parameter1==null?",parameter1=null":",parameter1='"+t4st.replaceCharsWithSQL(parameter1)+"'");}
    if (hasChanged("parameter2")) {updateFieldlist += ",parameter2"; sqlStatement += (parameter2==null?",parameter2=null":",parameter2='"+t4st.replaceCharsWithSQL(parameter2)+"'");}
    if (hasChanged("parameter3")) {updateFieldlist += ",parameter3"; sqlStatement += (parameter3==null?",parameter3=null":",parameter3='"+t4st.replaceCharsWithSQL(parameter3)+"'");}
    if (hasChanged("parameter4")) {updateFieldlist += ",parameter4"; sqlStatement += (parameter4==null?",parameter4=null":",parameter4='"+t4st.replaceCharsWithSQL(parameter4)+"'");}
    if (hasChanged("parameter5")) {updateFieldlist += ",parameter5"; sqlStatement += (parameter5==null?",parameter5=null":",parameter5='"+t4st.replaceCharsWithSQL(parameter5)+"'");}
    if (hasChanged("candelete")) {updateFieldlist += ",candelete";sqlStatement+=",candelete="+Integer.toString(candelete)+"";}
    if (hasChanged("idkeyset")) {updateFieldlist += ",idkeyset";sqlStatement+=",idkeyset="+(myDbAccessKeySet==null?"null":"'"+myDbAccessKeySet.getUniqueid()+"'");}


    // test before store
    DbAccessCheckKeyWord test = new DbAccessCheckKeyWord(t4m);
    if (!test.checkData(this , false , updateFieldlist + ",")) {
      errCode = test.errCode;
      errMess = test.errMess;
      return false;
    }

    if (updateFieldlist.length() > 0) {
      sqlStatement+=" WHERE uniqueid='"+ uniqueid +"'";
      conn.connectionlog("DbAccessKeyWord","sql statement", sqlStatement );
      setKeyWordsAsUsed(conn);
      PreparedStatement ps = conn.prepareStatement(sqlStatement);
      int psndx = 0;

      int count = ps.executeUpdate();
      ps.close();
      if (count == 0) {
        ok = false;
        errCode = ERROR_0003;
        errMess = t4m.getMessage("msg0003", null);
      }
    }



    if (ok) {
        errCode = MSG_0007;
        errMess = t4m.getMessage("msg0007", null);
    }
    return ok;
  }

  /**
   * The method <CODE>deleteInSink</CODE> deletes the data in database (data sink).
   * @param conn Connection to Database, if null => make own connection
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean deleteInSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;

    // test before delete
    if (!hasdata) {
      errCode = ERROR_0004;
      errMess = t4m.getMessage("msg0004", null);
      return false;
    }
    if (uniqueid == null || (uniqueid != null && uniqueid.length() == 0)) {
      errCode = ERROR_0005;
      errMess = t4m.getMessage("msg0005", null);
      return false;
    }

    // get connection
    boolean ownconn = false;
    if (conn == null) {
      conn = myDatabaseConnectionSet.conn();
      conn.setAutoCommit(false);
      ownconn = true;
    }



    // delete publicforeignkeys
    ArrayList report_delete = new ArrayList();
    if (publfkey4load != null && publfkey4load.length()>1) {
      String pffieldlist = "";
      String publfkey = publfkey4load;
      DatabaseDatasetLoader dsl = new DatabaseDatasetLoader();
      StringTokenizer stok = new StringTokenizer(publfkey ,";"); // public foreign keys separated by ;
      while (stok.hasMoreTokens()) { // for each public foreign key
        String xfield = stok.nextToken();
        String pfTableName = (String) publicforeignkeytable.get(xfield);
        String pfkeyfield = "";
        StringTokenizer staccess = new StringTokenizer(pfTableName ,"|");
        if (staccess.hasMoreTokens()) pfTableName = staccess.nextToken();
        if (staccess.hasMoreTokens()) pfkeyfield = staccess.nextToken();
        String sql = pfkeyfield + " = '"+uniqueid+"'";
        ArrayList keyList = dsl.getDataSet(sysUser , pfTableName , null , null , null , sql , null , "expertanddecision");
        int daclen = keyList.size();
        for (int dacndx=0;dacndx<daclen;dacndx++) {
          if (false) {}

        }
      }
    }

    String sqlStatement = "DELETE FROM KeyWord WHERE uniqueid='" + uniqueid + "'";
    conn.connectionlog("DbAccessKeyWord","sql statement", sqlStatement );

    Statement  s = conn.createStatement();
    s.execute(sqlStatement);
    s.close();

    if (ownconn) {
      if (ok) {
        reportDelete(report_delete);
        conn.commit();
      } else {
        conn.rollback();
      }
      myDatabaseConnectionSet.connClose(conn);
    }



    errCode = MSG_0008;
    errMess = t4m.getMessage("msg0008", null);
    return ok;
  }

  /**
   * The method <CODE>reportDelete</CODE> report the deleted data.
   * @param report_delete the list of the associated sentences.
   * @exception Exception.
   * @since 1.0
   */
  private void reportDelete(ArrayList report_delete) throws Exception {
      if (!protocol) {
          return;
      }
  
      // report the deletion of all associated sentences.
      if (report_delete != null && report_delete.size() > 0) {
          int len = report_delete.size();
          for (int ndx=0;ndx<len;ndx++) {
              String sentence = (String) report_delete.get(ndx);
              String tablename = "";
              String tableuid = "";
              StringTokenizer st = new StringTokenizer(sentence, "|");
              if (st.hasMoreTokens()) {
                  tablename = st.nextToken();
              }
              if (st.hasMoreTokens()) {
                  tableuid = st.nextToken();
              }
              putProtocolToSink(tablename, tableuid);
          }
      }
  
      // report the deletion of the main sentence.
      putProtocolToSink(dbtablename, uniqueid);
  
  }

  /**
   * The method <CODE>putProtocolToSink</CODE> saves the report protocol.
   * @param tablename the name of the table.
   * @param tableuid the uniqueid of the sentence.
   * @exception Exception.
   * @since 1.0
   */
  private void putProtocolToSink(String tablename, String tableuid) throws Exception {
  
      DbAccessProtocol xprotocol = new DbAccessProtocol(new List4SysUser(null, sysUser.getUserUniqueid(),
                        sysUser.getUserUserid(), sysUser.getUserName(), sysUser.getUserLanguageCode(), 1, null, null, null,
                        sysUser.getClientUniqueid(), null, null, null, sysUser.getClientDbsystemforen4e(), null), null, "all", null, null);
  
      if (tablename.length() > 30) {
          tablename = tablename.substring(0, 30);
      }
      xprotocol.setName(tablename);
      xprotocol.setProtocoltype("dec20d6:1244d75eb11:-8000"); // delete sentence.
      xprotocol.setActiondate(new java.util.Date());
      xprotocol.setTableuid(tableuid);
      String the_user = sysUser.getUserUserid();
      if (the_user.length() > 35) {
          the_user = the_user.substring(0, 35);
      }
      xprotocol.setShorttext(the_user);
  
      // create a fingerprint of the deletion data.
      String pattern4fingerprint = xprotocol.getName() + xprotocol.getProtocoltype()
              + Long.toString(xprotocol.getActiondate().getTime()) + xprotocol.getShorttext()
              + xprotocol.getTableuid();
  
      MessageDigest md = MessageDigest.getInstance("SHA");
      byte digest[] = md.digest(pattern4fingerprint.getBytes());
      String key = "";
      int len = digest.length;
      for (int i=0;i<len;i++) {
          key += Integer.toHexString(digest[i]&0xff);
      }
      xprotocol.setText(key);
  
      xprotocol.putToSink(null);
  
  }

  /**
   * The method <CODE>initializeStandardFields</CODE> sets standard fiels to initial value.
   * @since 1.0
  */
  private void initializeStandardFields() {
    if (hasdata) { // update existing data set
      version++;
      changed = new java.util.Date();
      changedfrom = sysUser.getUserUniqueid();
      inuse = 0;
    } else { // insert new data set
      uniqueid = uniqueid==null||uniqueid.trim().length()==0?new UID().toString():uniqueid;
      version = 0;
      created = new java.util.Date();
      creator = sysUser.getUserUniqueid();
      changed = null;
      changedfrom = null;
      inuse = 0;
    }
  }

  /**
   * The method <CODE>resetFields</CODE> sets fields to initvalue.
   * @exception Exception
   * @since 1.0
  */
  private void resetFields() throws Exception {
    uniqueid = null;
    version = 0;
    created = null;
    creator = null;
    changed = null;
    changedfrom = null;
    inuse = 0;
    name = null;
    old_name = null;
    name2 = null;
    old_name2 = null;
    name3 = null;
    old_name3 = null;
    name4 = null;
    old_name4 = null;
    name5 = null;
    old_name5 = null;
    canchangename = 0;
    old_canchangename = 0;
    description = null;
    old_description = null;
    description2 = null;
    old_description2 = null;
    description3 = null;
    old_description3 = null;
    description4 = null;
    old_description4 = null;
    description5 = null;
    old_description5 = null;
    parameter1 = null;
    old_parameter1 = null;
    parameter2 = null;
    old_parameter2 = null;
    parameter3 = null;
    old_parameter3 = null;
    parameter4 = null;
    old_parameter4 = null;
    parameter5 = null;
    old_parameter5 = null;
    candelete = 0;
    old_candelete = 0;
    myDbAccessKeySet = null;
    old_myDbAccessKeySet = null;

  }

  /**
   * The method <CODE>getDefData</CODE> returns data concerning a table field.
   * @param fieldname the name of table field
   * @param datatype type of data to return
   * @return def data
   * @exception Exception
   * @since 1.0
  */
  public String getDefData(String fieldname , String datatype) throws Exception {
    if (datatype.equals("label")) {
      if (false) {}
      else if (fieldname.equals("name")) {return getTranslationText(6);}
      else if (fieldname.equals("name2")) {return getTranslationText(6);}
      else if (fieldname.equals("name3")) {return getTranslationText(6);}
      else if (fieldname.equals("name4")) {return getTranslationText(6);}
      else if (fieldname.equals("name5")) {return getTranslationText(6);}
      else if (fieldname.equals("canchangename")) {return getTranslationText(18);}
      else if (fieldname.equals("description")) {return getTranslationText(2);}
      else if (fieldname.equals("description2")) {return getTranslationText(2);}
      else if (fieldname.equals("description3")) {return getTranslationText(2);}
      else if (fieldname.equals("description4")) {return getTranslationText(2);}
      else if (fieldname.equals("description5")) {return getTranslationText(2);}
      else if (fieldname.equals("parameter1")) {return getTranslationText(19);}
      else if (fieldname.equals("parameter2")) {return getTranslationText(20);}
      else if (fieldname.equals("parameter3")) {return getTranslationText(21);}
      else if (fieldname.equals("parameter4")) {return getTranslationText(22);}
      else if (fieldname.equals("parameter5")) {return getTranslationText(23);}
      else if (fieldname.equals("candelete")) {return getTranslationText(24);}

//       return dbtablename + fieldname;
    } else if (datatype.equals("type")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "char";}
      else if (fieldname.equals("name2")) {return "char";}
      else if (fieldname.equals("name3")) {return "char";}
      else if (fieldname.equals("name4")) {return "char";}
      else if (fieldname.equals("name5")) {return "char";}
      else if (fieldname.equals("canchangename")) {return "flag";}
      else if (fieldname.equals("description")) {return "char";}
      else if (fieldname.equals("description2")) {return "char";}
      else if (fieldname.equals("description3")) {return "char";}
      else if (fieldname.equals("description4")) {return "char";}
      else if (fieldname.equals("description5")) {return "char";}
      else if (fieldname.equals("parameter1")) {return "char";}
      else if (fieldname.equals("parameter2")) {return "char";}
      else if (fieldname.equals("parameter3")) {return "char";}
      else if (fieldname.equals("parameter4")) {return "char";}
      else if (fieldname.equals("parameter5")) {return "char";}
      else if (fieldname.equals("candelete")) {return "flag";}
      else if (fieldname.equals("idkeyset")) {return "privateforeignkey";}

    } else if (datatype.equals("length")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "32";}
      else if (fieldname.equals("name2")) {return "32";}
      else if (fieldname.equals("name3")) {return "32";}
      else if (fieldname.equals("name4")) {return "32";}
      else if (fieldname.equals("name5")) {return "32";}
      else if (fieldname.equals("canchangename")) {return "1";}
      else if (fieldname.equals("description")) {return "100";}
      else if (fieldname.equals("description2")) {return "100";}
      else if (fieldname.equals("description3")) {return "100";}
      else if (fieldname.equals("description4")) {return "100";}
      else if (fieldname.equals("description5")) {return "100";}
      else if (fieldname.equals("parameter1")) {return "50";}
      else if (fieldname.equals("parameter2")) {return "50";}
      else if (fieldname.equals("parameter3")) {return "50";}
      else if (fieldname.equals("parameter4")) {return "50";}
      else if (fieldname.equals("parameter5")) {return "50";}
      else if (fieldname.equals("candelete")) {return "1";}
      else if (fieldname.equals("idkeyset")) {return "35";}

    } else if (datatype.equals("needed")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "yes";}
      else if (fieldname.equals("name2")) {return "no";}
      else if (fieldname.equals("name3")) {return "no";}
      else if (fieldname.equals("name4")) {return "no";}
      else if (fieldname.equals("name5")) {return "no";}
      else if (fieldname.equals("canchangename")) {return "no";}
      else if (fieldname.equals("description")) {return "no";}
      else if (fieldname.equals("description2")) {return "no";}
      else if (fieldname.equals("description3")) {return "no";}
      else if (fieldname.equals("description4")) {return "no";}
      else if (fieldname.equals("description5")) {return "no";}
      else if (fieldname.equals("parameter1")) {return "no";}
      else if (fieldname.equals("parameter2")) {return "no";}
      else if (fieldname.equals("parameter3")) {return "no";}
      else if (fieldname.equals("parameter4")) {return "no";}
      else if (fieldname.equals("parameter5")) {return "no";}
      else if (fieldname.equals("candelete")) {return "no";}
      else if (fieldname.equals("idkeyset")) {return "no";}

    }
    return "";
  }

  /**
   * The method <CODE>setFieldAsString</CODE> returns the field contens as a string.
   * @param fieldname the name of table field
   * @param valuexyz the value of table field
   * @exception Exception
   * @since 1.0
  */
  public void setFieldAsString(String fieldname , String valuexyz) throws Exception {
//    if (valuexyz == null) valuexyz = "0";
//    if (valuexyz.equals("null")) valuexyz = "0";
    if (valuexyz != null)  {
        valuexyz = valuexyz.trim();
        if (valuexyz.length() == 0) {
            valuexyz = null;
        }
    }
    try  {
    if (false) {}
    else if (fieldname.equals("uniqueid")) {uniqueid = valuexyz;}
    else if (fieldname.equals("version")) {version = Long.parseLong(valuexyz == null?"0":valuexyz);}
    else if (fieldname.equals("created")) {created = new java.util.Date(t4n.getString2Long(valuexyz == null?"0":valuexyz, SystemService.getLocaleDef()));}
    else if (fieldname.equals("creator")) {creator = valuexyz;}
    else if (fieldname.equals("changed")) {changed = new java.util.Date(Long.parseLong(valuexyz == null?"0":valuexyz));}
    else if (fieldname.equals("changedfrom")) {changedfrom = valuexyz;}
    else if (fieldname.equals("inuse")) {inuse = (valuexyz == null?0:Integer.parseInt(valuexyz));}
    else if (fieldname.equals("client")) {client = valuexyz;}
    else if (fieldname.equals("name")) {name = valuexyz;}
    else if (fieldname.equals("name2")) {name2 = valuexyz;}
    else if (fieldname.equals("name3")) {name3 = valuexyz;}
    else if (fieldname.equals("name4")) {name4 = valuexyz;}
    else if (fieldname.equals("name5")) {name5 = valuexyz;}
    else if (fieldname.equals("canchangename")) {
      if (valuexyz == null) {
        canchangename = 0;
      } else if (valuexyz.equals("0")) {
        canchangename = 0;
      } else if (valuexyz.equals("1")) {
        canchangename = 1;
      } else if (valuexyz.equals(t4m.getMessage("msg0016", null))) {
        canchangename = 0;
      } else if (valuexyz.equals(t4m.getMessage("msg0015", null))) {
        canchangename = 1;
      } else {
        canchangename = 0;
      }
    }
    else if (fieldname.equals("description")) {description = valuexyz;}
    else if (fieldname.equals("description2")) {description2 = valuexyz;}
    else if (fieldname.equals("description3")) {description3 = valuexyz;}
    else if (fieldname.equals("description4")) {description4 = valuexyz;}
    else if (fieldname.equals("description5")) {description5 = valuexyz;}
    else if (fieldname.equals("parameter1")) {parameter1 = valuexyz;}
    else if (fieldname.equals("parameter2")) {parameter2 = valuexyz;}
    else if (fieldname.equals("parameter3")) {parameter3 = valuexyz;}
    else if (fieldname.equals("parameter4")) {parameter4 = valuexyz;}
    else if (fieldname.equals("parameter5")) {parameter5 = valuexyz;}
    else if (fieldname.equals("candelete")) {
      if (valuexyz == null) {
        candelete = 0;
      } else if (valuexyz.equals("0")) {
        candelete = 0;
      } else if (valuexyz.equals("1")) {
        candelete = 1;
      } else if (valuexyz.equals(t4m.getMessage("msg0016", null))) {
        candelete = 0;
      } else if (valuexyz.equals(t4m.getMessage("msg0015", null))) {
        candelete = 1;
      } else {
        candelete = 0;
      }
    }
    else if (fieldname.equals("idkeyset")) {
      DbAccessKeySet temp = new DbAccessKeySet(sysUser , valuexyz , "all" , null , null);
      if (temp.errCode == 0) {
        setMyDbAccessKeySet(temp);
      } else {
        errCode = temp.errCode;
        errMess = temp.errMess;
      }
    }

    } catch (ParseException ex) {
       errCode = ERROR_0105;
       errMess = t4m.getMessage("msg0121", getDefData(fieldname , "label"));
    } catch (Exception ex) {
       throw new Exception(ex);
    }
  }

  /**
   * The method <CODE>getBlobField</CODE> returns the field contens of blob fields.
   * @param fieldname the name of table field.
   * @return field contens.
   * @exception Exception
   * @since 1.0
  */
  public byte[] getBlobField(String fieldname) throws Exception {
    if (false) {}

    return null;
  }

  /**
   * The method <CODE>getFieldAsStringKey</CODE> returns the field contens as a string.
   * @param fieldname the name of table field.
   * @param getkey, get the key value.
   * @return field contens.
   * @exception Exception
   * @since 1.0
  */
  public String getFieldAsStringKey(String fieldname , Boolean getkey) throws Exception {
    if (false) {}
    else if (fieldname.equals("uniqueid")) {return uniqueid == null?"":uniqueid ;}
    else if (fieldname.equals("version")) {return Long.toString(version);}
    else if (fieldname.equals("created")) {return created == null?"":created.toString();}
    else if (fieldname.equals("creator")) {return creator == null?"":creator ;}
    else if (fieldname.equals("changed")) {return changed == null?"":changed.toString();}
    else if (fieldname.equals("changedfrom")) {return changedfrom == null?"":changedfrom ;}
    else if (fieldname.equals("inuse")) {return Integer.toString(inuse);}
    else if (fieldname.equals("client")) {return client == null?"":client ;}
    else if (fieldname.equals("name")) {return name == null?"":name ;}
    else if (fieldname.equals("name2")) {return name2 == null?"":name2 ;}
    else if (fieldname.equals("name3")) {return name3 == null?"":name3 ;}
    else if (fieldname.equals("name4")) {return name4 == null?"":name4 ;}
    else if (fieldname.equals("name5")) {return name5 == null?"":name5 ;}
    else if (fieldname.equals("canchangename")) {if(getkey.booleanValue()) {return Integer.toString(canchangename);} else {return canchangename == 1?t4m.getMessage("msg0015", null):t4m.getMessage("msg0016", null);}}
    else if (fieldname.equals("description")) {return description == null?"":description ;}
    else if (fieldname.equals("description2")) {return description2 == null?"":description2 ;}
    else if (fieldname.equals("description3")) {return description3 == null?"":description3 ;}
    else if (fieldname.equals("description4")) {return description4 == null?"":description4 ;}
    else if (fieldname.equals("description5")) {return description5 == null?"":description5 ;}
    else if (fieldname.equals("parameter1")) {return parameter1 == null?"":parameter1 ;}
    else if (fieldname.equals("parameter2")) {return parameter2 == null?"":parameter2 ;}
    else if (fieldname.equals("parameter3")) {return parameter3 == null?"":parameter3 ;}
    else if (fieldname.equals("parameter4")) {return parameter4 == null?"":parameter4 ;}
    else if (fieldname.equals("parameter5")) {return parameter5 == null?"":parameter5 ;}
    else if (fieldname.equals("candelete")) {if(getkey.booleanValue()) {return Integer.toString(candelete);} else {return candelete == 1?t4m.getMessage("msg0015", null):t4m.getMessage("msg0016", null);}}
    else if (fieldname.equals("idkeyset")) {return getMyDbAccessKeySet()==null?"":getMyDbAccessKeySet().getUniqueid();}

    return "";
  }

  /**
   * The method <CODE>hasChanged</CODE> returns the status of field change.
   * @param fieldname the name of table field
   * @return field length
   * @exception Exception
   * @since 1.0
  */
  public boolean hasChanged(String fieldname) throws Exception {
    if (false) {}
    else if (fieldname.equals("name")) {
      if (name != null || old_name != null) {
        if ((name == null && old_name != null) || (name != null && old_name == null)) {
          return true;
        } else {
          if (!name.equals(old_name)) {return true;}
        }
      }
    }
    else if (fieldname.equals("name2")) {
      if (name2 != null || old_name2 != null) {
        if ((name2 == null && old_name2 != null) || (name2 != null && old_name2 == null)) {
          return true;
        } else {
          if (!name2.equals(old_name2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("name3")) {
      if (name3 != null || old_name3 != null) {
        if ((name3 == null && old_name3 != null) || (name3 != null && old_name3 == null)) {
          return true;
        } else {
          if (!name3.equals(old_name3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("name4")) {
      if (name4 != null || old_name4 != null) {
        if ((name4 == null && old_name4 != null) || (name4 != null && old_name4 == null)) {
          return true;
        } else {
          if (!name4.equals(old_name4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("name5")) {
      if (name5 != null || old_name5 != null) {
        if ((name5 == null && old_name5 != null) || (name5 != null && old_name5 == null)) {
          return true;
        } else {
          if (!name5.equals(old_name5)) {return true;}
        }
      }
    }
    else if (fieldname.equals("canchangename")) {
      if (canchangename != old_canchangename) {
        return true;
      }
    }
    else if (fieldname.equals("description")) {
      if (description != null || old_description != null) {
        if ((description == null && old_description != null) || (description != null && old_description == null)) {
          return true;
        } else {
          if (!description.equals(old_description)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description2")) {
      if (description2 != null || old_description2 != null) {
        if ((description2 == null && old_description2 != null) || (description2 != null && old_description2 == null)) {
          return true;
        } else {
          if (!description2.equals(old_description2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description3")) {
      if (description3 != null || old_description3 != null) {
        if ((description3 == null && old_description3 != null) || (description3 != null && old_description3 == null)) {
          return true;
        } else {
          if (!description3.equals(old_description3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description4")) {
      if (description4 != null || old_description4 != null) {
        if ((description4 == null && old_description4 != null) || (description4 != null && old_description4 == null)) {
          return true;
        } else {
          if (!description4.equals(old_description4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description5")) {
      if (description5 != null || old_description5 != null) {
        if ((description5 == null && old_description5 != null) || (description5 != null && old_description5 == null)) {
          return true;
        } else {
          if (!description5.equals(old_description5)) {return true;}
        }
      }
    }
    else if (fieldname.equals("parameter1")) {
      if (parameter1 != null || old_parameter1 != null) {
        if ((parameter1 == null && old_parameter1 != null) || (parameter1 != null && old_parameter1 == null)) {
          return true;
        } else {
          if (!parameter1.equals(old_parameter1)) {return true;}
        }
      }
    }
    else if (fieldname.equals("parameter2")) {
      if (parameter2 != null || old_parameter2 != null) {
        if ((parameter2 == null && old_parameter2 != null) || (parameter2 != null && old_parameter2 == null)) {
          return true;
        } else {
          if (!parameter2.equals(old_parameter2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("parameter3")) {
      if (parameter3 != null || old_parameter3 != null) {
        if ((parameter3 == null && old_parameter3 != null) || (parameter3 != null && old_parameter3 == null)) {
          return true;
        } else {
          if (!parameter3.equals(old_parameter3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("parameter4")) {
      if (parameter4 != null || old_parameter4 != null) {
        if ((parameter4 == null && old_parameter4 != null) || (parameter4 != null && old_parameter4 == null)) {
          return true;
        } else {
          if (!parameter4.equals(old_parameter4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("parameter5")) {
      if (parameter5 != null || old_parameter5 != null) {
        if ((parameter5 == null && old_parameter5 != null) || (parameter5 != null && old_parameter5 == null)) {
          return true;
        } else {
          if (!parameter5.equals(old_parameter5)) {return true;}
        }
      }
    }
    else if (fieldname.equals("candelete")) {
      if (candelete != old_candelete) {
        return true;
      }
    }
    else if (fieldname.equals("idkeyset")) {
      if (myDbAccessKeySet != old_myDbAccessKeySet) {
          return true;
      }
    }

    return false;
  }

  /**
   * The method <CODE>getDataSet</CODE> returns a data set from table.
   * @param addsqlorder order of sql result
   * @return dataSet
   * @exception Exception
   * @since 1.0
  */
  public ArrayList getDataSet(String addsqlorder) throws Exception {
    DatabaseDatasetLoader dbl = new DatabaseDatasetLoader();
    ArrayList dataSet = dbl.getDataSet(sysUser , dbtablename , fields4load , privfkey4load , publfkey4load , sqlAdd , addsqlorder , "expertanddecision");
    return dataSet;
  }

  /**
   * The method <CODE>getTranslationText</CODE> returns the translated text.
   * @param ndx the text index.
   * @return the translation.
   * @exception Exception
   * @since 1.0
  */
  public String getTranslationText(int ndx) throws Exception {
    if (false) {
    } else if (sysUser.getUserLanguageCode().equals("de")) {
      if (false) {}
      else if (ndx == 22) {return "Parameter 4";}
      else if (ndx == 21) {return "Parameter 3";}
      else if (ndx == 20) {return "Parameter 2";}
      else if (ndx == 19) {return "Parameter 1";}
      else if (ndx == 18) {return "Schl\u00fcsselname \u00e4nderbar";}
      else if (ndx == 6) {return "Schl\u00fcsselname";}
      else if (ndx == 2) {return "Beschreibung";}
      else if (ndx == 24) {return "vom Admin l\u00f6schbar";}
      else if (ndx == 23) {return "Parameter 5";}

    } else if (sysUser.getUserLanguageCode().equals("en")) {
      if (false) {}
      else if (ndx == 22) {return "Parameter 4";}
      else if (ndx == 21) {return "Parameter 3";}
      else if (ndx == 20) {return "Parameter 2";}
      else if (ndx == 19) {return "Parameter 1";}
      else if (ndx == 18) {return "Key Name changable";}
      else if (ndx == 6) {return "Key Name";}
      else if (ndx == 2) {return "Description";}
      else if (ndx == 24) {return "deletable through Admin";}
      else if (ndx == 23) {return "Parameter 5";}


    }
    return "no text available";
  }


}
