package n4e.expertanddecision.dbaccess;

/**
* <p>title: n4e application</p>
* <p>description: expertanddecision</p>
* <p>copyright: copyright (c) 2006-2011 by thomas kaffka; mba; all rights reserved.</p>
* <p>company: n.n.</p>
* @author thomas kaffka, mba.
* @version Fri May 01 16:26:19 CEST 2015
*/

import java.sql.*;
import java.text.*;
import java.util.*;
import java.math.*;
import java.util.zip.*;
import java.io.*;

import n4e.core.database.*;
import n4e.core.dbaccess.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.core.list.*;



/**
 * The <CODE>DbAccessReadKeySet</CODE> class reads fields of KeySet table in database.
 * @author Dipl.-Kfm. Thomas Kaffka
 * @version Fri May 01 16:26:19 CEST 2015
*/
public class DbAccessReadKeySet extends DbAccessRead {

  // individual database fields
  private String name = ""; // Schluesselname
  private String description = ""; // Beschreibung
  private String description2 = ""; // Beschreibung
  private String description3 = ""; // Beschreibung
  private String description4 = ""; // Beschreibung
  private String description5 = ""; // Beschreibung
  private int showatclients = 0; // Keyset fuer uebrige Clients
  private String label1 = ""; // Bezeichnung Parameter 1
  private String label2 = ""; // Bezeichnung Parameter 2
  private String label3 = ""; // Bezeichnung Parameter 3
  private String label4 = ""; // Bezeichnung Parameter 4
  private String label5 = ""; // Bezeichnung Parameter 5
  private String explanation1 = ""; // Erklaerung Parameter 1
  private String explanation2 = ""; // Erklaerung Parameter 2
  private String explanation3 = ""; // Erklaerung Parameter 3
  private String explanation4 = ""; // Erklaerung Parameter 4
  private String explanation5 = ""; // Erklaerung Parameter 5
  private ArrayList myDbAccessKeyWord = null ; // KeyWord


  // sets and gets of individual table fields
  public void setName(String input){name = input;}
  public String getName(){return name;}
  public void setDescription(String input){description = input;}
  public String getDescription(){return description;}
  public void setDescription2(String input){description2 = input;}
  public String getDescription2(){return description2;}
  public void setDescription3(String input){description3 = input;}
  public String getDescription3(){return description3;}
  public void setDescription4(String input){description4 = input;}
  public String getDescription4(){return description4;}
  public void setDescription5(String input){description5 = input;}
  public String getDescription5(){return description5;}
  public void setShowatclients(int input){showatclients = input;}
  public int getShowatclients(){return showatclients;}
  public void setLabel1(String input){label1 = input;}
  public String getLabel1(){return label1;}
  public void setLabel2(String input){label2 = input;}
  public String getLabel2(){return label2;}
  public void setLabel3(String input){label3 = input;}
  public String getLabel3(){return label3;}
  public void setLabel4(String input){label4 = input;}
  public String getLabel4(){return label4;}
  public void setLabel5(String input){label5 = input;}
  public String getLabel5(){return label5;}
  public void setExplanation1(String input){explanation1 = input;}
  public String getExplanation1(){return explanation1;}
  public void setExplanation2(String input){explanation2 = input;}
  public String getExplanation2(){return explanation2;}
  public void setExplanation3(String input){explanation3 = input;}
  public String getExplanation3(){return explanation3;}
  public void setExplanation4(String input){explanation4 = input;}
  public String getExplanation4(){return explanation4;}
  public void setExplanation5(String input){explanation5 = input;}
  public String getExplanation5(){return explanation5;}
  public void setMyDbAccessKeyWord(ArrayList input){myDbAccessKeyWord = input;}
  public ArrayList getMyDbAccessKeyWord(){return myDbAccessKeyWord;}


  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object.
   * @since 1.0
  */
  public DbAccessReadKeySet(){
      setWorkFields();
  }

  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object.
   * @param sysUser the system user.
   * @since 1.0
  */
  public DbAccessReadKeySet(List4SysUser sysUser){
    setSystemUser(sysUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }
  }

  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object
   * @param pUser the system user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessReadKeySet(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , null , true);

  }

  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object
   * @param conn database connection
   * @param pUser the system user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessReadKeySet(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , null , true);

  }

  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object with additional sqlwhere
   * @param pUser the system user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessReadKeySet(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd ) throws Exception {

    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd , true);

  }

  /**
   * The constructor <CODE>DbAccessReadKeySet</CODE> initialized the object with additional sqlwhere
    this.conn 0 conn;
   * @param conn database connection
   * @param pUser the system user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessReadKeySet(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd ) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd , true);

  }

  /**
   * The method <CODE>initiate</CODE> initializes the object with additional sqlwhere.
   * @param pUser the system user object.
   * @param uniqueid the unique key.
   * @param fieldlist List of fields to load.
   * @param privfkey List of privfkeys to load.
   * @param publfkey List of publfkeys to load.
   * @param sqlAdd additional where clause.
   * @param read_with_client read with use of the client id.
   * @exception Exception
   * @since 1.0
  */
  public void initiate(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd , boolean read_with_client) throws Exception {

    this.read_with_client = read_with_client;
    setSystemUser(pUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;
    publicforeignkeytable.put("idkeyword","KeyWord|idkeyset");



    success = loadFromTable(uniqueid , fieldlist , privfkey , publfkey , sqlAdd );
  }

  /**
   * The method <CODE>setWorkFields</CODE> sets the work fiels to current values.
   * @since 1.0
  */
  public void setWorkFields() {
      dbtablename = "KeySet"; // name of own database table
      if (sysUser != null) {
          databasename = sysUser.getClientDbsystemforeclient(); // name of own database
      }
      tblnameofprivk = ","; // list of table names of private foreign keys
      tblnameofpublvk = ",KeyWord,"; // list of table names of public foreign keys
      keynameofpublvk = ",idkeyset,"; // list of key names of table names of public foreign keys
      tblnameofownerfield = ","; // list of names of table names of owner key
      indivTableFields = ",name,description,description2,description3,description4,description5,showatclients,label1,label2,label3,label4,label5,explanation1,explanation2,explanation3,explanation4,explanation5,"; // list of inidividual table fields
      privateforeignkey = ";"; // list of private foreign key fields
      publicforeignkey = ";idkeyword;"; // list of public foreign key fields
  }

  /**
   * The method <CODE>loadFromTable</CODE> gets tabledata from database.
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean loadFromTable(String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd ) throws Exception {

    errCode = 0;
    errMess = "";

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;
    hasdata = false;
    // create connection to defined database system
    String dbsystem = databasename;
    DatabaseConnectionSet myDatabaseConnectionSet = DatabaseManager.getDatabaseConnectionSet(dbsystem);
    if (this.myconn) {
        this.conn = myDatabaseConnectionSet.conn();
    }
    DatabaseSQLResultSet resSet = new DatabaseSQLResultSet(dbsystem , conn);

    // handle fields to load
    String sqlFieldlist = "";
    String sqlPrivfkey = "";

    // build sql field list
    if (fieldlist != null && fieldlist.equals("all")) {
      sqlFieldlist = indivTableFields.substring(1);
    } else { // make individual fieldlist
      if (fieldlist != null) {
        sqlFieldlist = fieldlist;
      } else {
        sqlFieldlist = "";
      }
    }

    // build sql field list of private foreign keys
    if (privfkey != null && privfkey.equals("all")) {
      sqlPrivfkey = privateforeignkey.substring(1);
    } else { // make individual fieldlist
      if (privfkey != null) {
          int pos = privfkey.indexOf("(");
          if (pos >= 0) {
            StringTokenizer stok = new StringTokenizer(privfkey , ";"); // public foreign keys separated by ;
            while (stok.hasMoreTokens()) { // for each public foreign key
                String xfield = stok.nextToken();
                pos = xfield.indexOf("(");
                if (pos >= 0) {
                    sqlPrivfkey += "," + xfield.substring(0, pos);
                } else {
                    sqlPrivfkey += "," + xfield;
                }
            }
            sqlPrivfkey = sqlPrivfkey.substring(1);
          } else {
            sqlPrivfkey = t4st.replaceToken(privfkey , ";" , ",");
          }
      } else {
        sqlPrivfkey = "";
      }
    }

    StringTokenizer stok = null;

    String workingSqlFieldlist = stdTableFields + sqlFieldlist;
    if (workingSqlFieldlist.endsWith(",")) {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?sqlPrivfkey:"")+",";
    } else {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?","+sqlPrivfkey:"")+",";
    }


    int len = workingSqlFieldlist.length();
    workingSqlFieldlist = workingSqlFieldlist.substring(1,len-1);
    if (workingSqlFieldlist.endsWith(",")) {
      len = workingSqlFieldlist.length();
      workingSqlFieldlist = workingSqlFieldlist.substring(0,len-1);
    }

    resetFields();

    // grip into data sink
    if (uniqueid == null && sqlAdd == null) {
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
        errCode = ERROR_0001;
        errMess = t4m.getMessage("msg0001", null);
        return false;
    }

    String client_temp = client;
    if (!read_with_client) {
        client = null;
    }

    String where1 = ((client!=null&&client.length()>0)?("client='"+client+"'"):"");
    String where2 = ((uniqueid!=null&&uniqueid.length()>0)?("uniqueid='"+uniqueid+"'"):"");
    String where3 = ((sqlAdd!=null&&sqlAdd.length()>0)?sqlAdd:"");
    String where = "";
    if (where1.length()==0 && where2.length()==0 && where3.length()==0) { // 000
      where = "";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()==0) { // 100
      where = " WHERE (" + where1 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()==0) { // 010
      where = " WHERE (" + where2 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()==0) { // 110
      where = " WHERE (" + where1 + ") AND (" + where2 + ")";
    } else if (where1.length()==0 && where2.length()==0 && where3.length()>0) { // 001
      where = " WHERE (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()>0) { // 101
      where = " WHERE (" + where1 + ") AND (" + where3 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()>0) { // 011
      where = " WHERE (" + where2 + ") AND (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()>0) { // 111
      where = " WHERE (" + where1 + ") AND (" + where2 + ") AND (" + where3 + ")";
    }

    String sqlStatement = "SELECT "+workingSqlFieldlist+" FROM KeySet " + where;
    conn.connectionlog("DbAccessReadKeySet","sql statement", sqlStatement);
    ResultSet result = resSet.getResultSet(sqlStatement);
    if (result.next() && (result.isFirst() && result.isLast())) {
      hasdata = true;
      // get standard fields
      setUniqueid(result.getString(1));
      setVersion(result.getLong(2));
      long temp_timestamp = result.getLong(3);
      java.util.Date temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setCreated(temp_date);
      setCreator(result.getString(4));
      temp_timestamp = result.getLong(5);
      temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setChanged(temp_date);
      setChangedfrom(result.getString(6));
      setInuse(result.getInt(7));
      setClient(result.getString(8));

      //get individual fields
      int i = 9;
      workingSqlFieldlist = sqlFieldlist + (sqlPrivfkey.length()>0?","+sqlPrivfkey:"");
      stok = new StringTokenizer(workingSqlFieldlist ,",");
      while (stok.hasMoreTokens()) {
        String xfield = stok.nextToken();
        if (false) {}
          // dummy
          else if (xfield.equals("name")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName(value);}
          else if (xfield.equals("description")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription(value);}
          else if (xfield.equals("description2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription2(value);}
          else if (xfield.equals("description3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription3(value);}
          else if (xfield.equals("description4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription4(value);}
          else if (xfield.equals("description5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription5(value);}
          else if (xfield.equals("showatclients")) {int value = result.getInt(i);setShowatclients(value);}
          else if (xfield.equals("label1")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel1(value);}
          else if (xfield.equals("label2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel2(value);}
          else if (xfield.equals("label3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel3(value);}
          else if (xfield.equals("label4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel4(value);}
          else if (xfield.equals("label5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel5(value);}
          else if (xfield.equals("explanation1")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation1(value);}
          else if (xfield.equals("explanation2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation2(value);}
          else if (xfield.equals("explanation3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation3(value);}
          else if (xfield.equals("explanation4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation4(value);}
          else if (xfield.equals("explanation5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation5(value);}

        i++;
      }

      //get individual privateforeignkeys
      if (privfkey != null && privfkey.length()>0) {
        String pffieldlist = "";
        if (privfkey.equals("all")) { // load all private foreign key objects with field list 'all'
          privfkey = privateforeignkey.substring(1);
        }
        stok = new StringTokenizer(privfkey , ";"); // private foreign keys separated by ;
        while (stok.hasMoreTokens()) { // for each private foreign key
          String xfield = stok.nextToken();
          if (xfield == null || xfield.length() == 0) continue;
          if (xfield.indexOf("(") > -1) { // private foreign key with field list
            StringTokenizer stfield = new StringTokenizer(xfield ,"(");
            if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (pffieldlist.endsWith(")")) {
              pffieldlist = pffieldlist.substring(0, pffieldlist.length()-1);
            }
          } else {
            pffieldlist = "all";
          }
          if (false) {}

        }
      }

    } else { // no data found
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
       errCode = ERROR_0002;
       errMess = t4m.getMessage("msg0002", null);
       return false;
    }

    //get individual publicforeignkeys
    if (publfkey != null && publfkey.length()>0) {
      String pffieldlist = "";
      if (publfkey.equals("all")) { // load all public foreign key objects with field list 'all'
        publfkey = publicforeignkey.substring(1);
      }
      DatabaseDatasetLoader dsl = new DatabaseDatasetLoader(this.conn);
      stok = new StringTokenizer(publfkey ,";"); // public foreign keys separated by ;
      while (stok.hasMoreTokens()) { // for each public foreign key
        String xfield = stok.nextToken();
        if (xfield == null || xfield.length() == 0) continue;
        StringTokenizer stfield = null;
        if (xfield.indexOf("(") > -1) { // public foreign key with field list
          stfield = new StringTokenizer(xfield ,"(");
          if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
          if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
          if (pffieldlist.endsWith(")")) {
            pffieldlist = pffieldlist.substring(0 , pffieldlist.length()-1);
          }
        } else {
          pffieldlist = "all";
        }
        String orderby = null;
        if (pffieldlist.indexOf("|") > -1) { // order by feilds available.
            stfield = new StringTokenizer(pffieldlist ,"|");
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (stfield.hasMoreTokens()) orderby = stfield.nextToken();
        }
        String pfTableName = (String) publicforeignkeytable.get(xfield);
        String pfkeyfield = "";
        StringTokenizer staccess = new StringTokenizer(pfTableName ,"|");
        if (staccess.hasMoreTokens()) pfTableName = staccess.nextToken();
        if (staccess.hasMoreTokens()) pfkeyfield = staccess.nextToken();
        String sql = pfkeyfield + " = '" + result.getString("uniqueid")+"'";
        ArrayList keyList = dsl.getDataSetRead(sysUser , pfTableName , pffieldlist , null , null , sql , orderby , "expertanddecision");
        if (false) {}
        else if (xfield.equals("idkeyword")) {
          setMyDbAccessKeyWord(keyList);
        }

      }
    }

    if (!read_with_client) {
        client = client_temp;
    }

    resSet.closeResultSet();
    resSet = null;
    if (this.myconn) {
        myDatabaseConnectionSet.connClose(conn);
    }

    return true;
  }

  /**
   * The method <CODE>resetFields</CODE> sets fields to initvalue.
   * @exception Exception
   * @since 1.0
  */
  private void resetFields() throws Exception {
    uniqueid = null;
    version = 0;
    created = null;
    creator = null;
    changed = null;
    changedfrom = null;
    inuse = 0;
    name = null;
    description = null;
    description2 = null;
    description3 = null;
    description4 = null;
    description5 = null;
    showatclients = 0;
    label1 = null;
    label2 = null;
    label3 = null;
    label4 = null;
    label5 = null;
    explanation1 = null;
    explanation2 = null;
    explanation3 = null;
    explanation4 = null;
    explanation5 = null;
    myDbAccessKeyWord = new ArrayList();

  }

  /**
   * The method <CODE>getDefData</CODE> returns data concerning a table field.
   * @param fieldname the name of table field
   * @param datatype type of data to return
   * @return def data
   * @exception Exception
   * @since 1.0
  */
  public String getDefData(String fieldname , String datatype) throws Exception {
    if (datatype.equals("label")) {
      if (false) {}
      else if (fieldname.equals("name")) {return getTranslationText(6);}
      else if (fieldname.equals("description")) {return getTranslationText(2);}
      else if (fieldname.equals("description2")) {return getTranslationText(2);}
      else if (fieldname.equals("description3")) {return getTranslationText(2);}
      else if (fieldname.equals("description4")) {return getTranslationText(2);}
      else if (fieldname.equals("description5")) {return getTranslationText(2);}
      else if (fieldname.equals("showatclients")) {return getTranslationText(7);}
      else if (fieldname.equals("label1")) {return getTranslationText(8);}
      else if (fieldname.equals("label2")) {return getTranslationText(9);}
      else if (fieldname.equals("label3")) {return getTranslationText(10);}
      else if (fieldname.equals("label4")) {return getTranslationText(11);}
      else if (fieldname.equals("label5")) {return getTranslationText(12);}
      else if (fieldname.equals("explanation1")) {return getTranslationText(13);}
      else if (fieldname.equals("explanation2")) {return getTranslationText(14);}
      else if (fieldname.equals("explanation3")) {return getTranslationText(15);}
      else if (fieldname.equals("explanation4")) {return getTranslationText(16);}
      else if (fieldname.equals("explanation5")) {return getTranslationText(17);}

//       return dbtablename + fieldname;
    } else if (datatype.equals("type")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "char";}
      else if (fieldname.equals("description")) {return "char";}
      else if (fieldname.equals("description2")) {return "char";}
      else if (fieldname.equals("description3")) {return "char";}
      else if (fieldname.equals("description4")) {return "char";}
      else if (fieldname.equals("description5")) {return "char";}
      else if (fieldname.equals("showatclients")) {return "flag";}
      else if (fieldname.equals("label1")) {return "char";}
      else if (fieldname.equals("label2")) {return "char";}
      else if (fieldname.equals("label3")) {return "char";}
      else if (fieldname.equals("label4")) {return "char";}
      else if (fieldname.equals("label5")) {return "char";}
      else if (fieldname.equals("explanation1")) {return "char";}
      else if (fieldname.equals("explanation2")) {return "char";}
      else if (fieldname.equals("explanation3")) {return "char";}
      else if (fieldname.equals("explanation4")) {return "char";}
      else if (fieldname.equals("explanation5")) {return "char";}
      else if (fieldname.equals("idkeyword")) {return "publicforeignkey";}

    } else if (datatype.equals("length")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "32";}
      else if (fieldname.equals("description")) {return "100";}
      else if (fieldname.equals("description2")) {return "100";}
      else if (fieldname.equals("description3")) {return "100";}
      else if (fieldname.equals("description4")) {return "100";}
      else if (fieldname.equals("description5")) {return "100";}
      else if (fieldname.equals("showatclients")) {return "1";}
      else if (fieldname.equals("label1")) {return "30";}
      else if (fieldname.equals("label2")) {return "30";}
      else if (fieldname.equals("label3")) {return "30";}
      else if (fieldname.equals("label4")) {return "30";}
      else if (fieldname.equals("label5")) {return "30";}
      else if (fieldname.equals("explanation1")) {return "255";}
      else if (fieldname.equals("explanation2")) {return "255";}
      else if (fieldname.equals("explanation3")) {return "255";}
      else if (fieldname.equals("explanation4")) {return "255";}
      else if (fieldname.equals("explanation5")) {return "255";}
      else if (fieldname.equals("idkeyword")) {return "35";}

    } else if (datatype.equals("needed")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "yes";}
      else if (fieldname.equals("description")) {return "no";}
      else if (fieldname.equals("description2")) {return "no";}
      else if (fieldname.equals("description3")) {return "no";}
      else if (fieldname.equals("description4")) {return "no";}
      else if (fieldname.equals("description5")) {return "no";}
      else if (fieldname.equals("showatclients")) {return "yes";}
      else if (fieldname.equals("label1")) {return "no";}
      else if (fieldname.equals("label2")) {return "no";}
      else if (fieldname.equals("label3")) {return "no";}
      else if (fieldname.equals("label4")) {return "no";}
      else if (fieldname.equals("label5")) {return "no";}
      else if (fieldname.equals("explanation1")) {return "no";}
      else if (fieldname.equals("explanation2")) {return "no";}
      else if (fieldname.equals("explanation3")) {return "no";}
      else if (fieldname.equals("explanation4")) {return "no";}
      else if (fieldname.equals("explanation5")) {return "no";}
      else if (fieldname.equals("idkeyword")) {return "no";}

    }
    return "";
  }

  /**
   * The method <CODE>getBlobField</CODE> returns the field contens of blob fields.
   * @param fieldname the name of table field.
   * @return field contens.
   * @exception Exception
   * @since 1.0
  */
  public byte[] getBlobField(String fieldname) throws Exception {
    if (false) {}

    return null;
  }

  /**
   * The method <CODE>getFieldAsStringKey</CODE> returns the field contens as a string.
   * @param fieldname the name of table field.
   * @param getkey, get the key value.
   * @return field contens
   * @exception Exception
   * @since 1.0
  */
  public String getFieldAsStringKey(String fieldname , Boolean getkey) throws Exception {
    if (false) {}
    else if (fieldname.equals("uniqueid")) {return uniqueid == null?"":uniqueid;}
    else if (fieldname.equals("version")) {return Long.toString(version);}
    else if (fieldname.equals("created")) {return created == null?"":created.toString();}
    else if (fieldname.equals("creator")) {return creator == null?"":creator;}
    else if (fieldname.equals("changed")) {return changed == null?"":changed.toString();}
    else if (fieldname.equals("changedfrom")) {return changedfrom == null?"":changedfrom;}
    else if (fieldname.equals("inuse")) {return Integer.toString(inuse);}
    else if (fieldname.equals("client")) {return client == null?"":client;}
    else if (fieldname.equals("name")) {return name == null?"":name ;}
    else if (fieldname.equals("description")) {return description == null?"":description ;}
    else if (fieldname.equals("description2")) {return description2 == null?"":description2 ;}
    else if (fieldname.equals("description3")) {return description3 == null?"":description3 ;}
    else if (fieldname.equals("description4")) {return description4 == null?"":description4 ;}
    else if (fieldname.equals("description5")) {return description5 == null?"":description5 ;}
    else if (fieldname.equals("showatclients")) {if(getkey.booleanValue()) {return Integer.toString(showatclients);} else {return showatclients == 1?t4m.getMessage("msg0015", null):t4m.getMessage("msg0016", null);}}
    else if (fieldname.equals("label1")) {return label1 == null?"":label1 ;}
    else if (fieldname.equals("label2")) {return label2 == null?"":label2 ;}
    else if (fieldname.equals("label3")) {return label3 == null?"":label3 ;}
    else if (fieldname.equals("label4")) {return label4 == null?"":label4 ;}
    else if (fieldname.equals("label5")) {return label5 == null?"":label5 ;}
    else if (fieldname.equals("explanation1")) {return explanation1 == null?"":explanation1 ;}
    else if (fieldname.equals("explanation2")) {return explanation2 == null?"":explanation2 ;}
    else if (fieldname.equals("explanation3")) {return explanation3 == null?"":explanation3 ;}
    else if (fieldname.equals("explanation4")) {return explanation4 == null?"":explanation4 ;}
    else if (fieldname.equals("explanation5")) {return explanation5 == null?"":explanation5 ;}

    return "";
  }

  /**
   * The method <CODE>getDataSet</CODE> returns a data set from table.
   * @param addsqlorder order of sql result
   * @return dataSet
   * @exception Exception
   * @since 1.0
  */
  public ArrayList getDataSet(String addsqlorder) throws Exception {
    DatabaseDatasetLoader dbl = new DatabaseDatasetLoader();
    ArrayList dataSet = dbl.getDataSetRead(sysUser , dbtablename , fields4load , privfkey4load , publfkey4load , sqlAdd , addsqlorder , "expertanddecision");
    return dataSet;
  }

  /**
   * The method <CODE>getTranslationText</CODE> returns the translated text.
   * @param ndx the text index.
   * @return the translation.
   * @exception Exception
   * @since 1.0
  */
  public String getTranslationText(int ndx) throws Exception {
    if (false) {
    } else if (sysUser.getUserLanguageCode().equals("de")) {
      if (false) {}
      else if (ndx == 17) {return "Erkl\u00e4rung Parameter 5";}
      else if (ndx == 16) {return "Erkl\u00e4rung Parameter 4";}
      else if (ndx == 15) {return "Erkl\u00e4rung Parameter 3";}
      else if (ndx == 14) {return "Erkl\u00e4rung Parameter 2";}
      else if (ndx == 13) {return "Erkl\u00e4rung Parameter 1";}
      else if (ndx == 12) {return "Bezeichnung Parameter 5";}
      else if (ndx == 11) {return "Bezeichnung Parameter 4";}
      else if (ndx == 10) {return "Bezeichnung Parameter 3";}
      else if (ndx == 9) {return "Bezeichnung Parameter 2";}
      else if (ndx == 8) {return "Bezeichnung Parameter 1";}
      else if (ndx == 7) {return "Keyset f\u00fcr \u00fcbrige Clients";}
      else if (ndx == 6) {return "Schl\u00fcsselname";}
      else if (ndx == 2) {return "Beschreibung";}

    } else if (sysUser.getUserLanguageCode().equals("en")) {
      if (false) {}
      else if (ndx == 17) {return "Explanation Parameter 5";}
      else if (ndx == 16) {return "Explanation Parameter 4";}
      else if (ndx == 15) {return "Explanation Parameter 3";}
      else if (ndx == 14) {return "Explanation Parameter 2";}
      else if (ndx == 13) {return "Explanation Parameter 1";}
      else if (ndx == 12) {return "Description Parameter 5";}
      else if (ndx == 11) {return "Description Parameter 4";}
      else if (ndx == 10) {return "Description Parameter 3";}
      else if (ndx == 9) {return "Description Parameter 2";}
      else if (ndx == 8) {return "Description Parameter 1";}
      else if (ndx == 7) {return "Key Set f\u00fcr other Clients";}
      else if (ndx == 6) {return "Key Name";}
      else if (ndx == 2) {return "Description";}


    }
    return "no text available";
  }


}
