package n4e.expertanddecision.screen;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;

import n4e.core.controls.AWCombo;
import n4e.core.controls.AWTextField;
import n4e.core.database.DatabaseDatasetLoader;
import n4e.expertanddecision.dbaccess.DbAccessReadExpAttribute;
import n4e.core.list.Context;
import n4e.core.screen.DataSite;
import n4e.core.system.AttHelp;
import n4e.core.tool.Tool4ExpertStochastic;
import n4e.core.tool.Tool4ExpertSystem;
import n4e.core.tool.Tool4ExpertSystemDeterministic;
import n4e.core.tool.Tool4Throwable;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCondition;
import n4e.expertanddecision.dbaccess.DbAccessReadExpSystem;
import n4e.expertanddecision.dbaccess.DbAccessReadResultAtt;
import n4e.expertanddecision.dbaccess.DbAccessReadResultValue;
import n4e.expertanddecision.dbaccess.DbAccessResultAtt;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;
import n4e.expertanddecision.system.RuleHelp;

/**
 * The <CODE>ExpApplicationDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 18:03:04
 * @since 1.0
 */

public class ExpApplicationDataSite extends DataSite {

	public static final int AUDIT = 1;
	public static final int EXPSYS = 2;
	
    private JLabel lblAppname;
    private JLabel lblType;

    private JTextArea taQuestion; 
	private AWCombo cbxOperand;
    private AWTextField tfOperand;
	private JRadioButton rbOperand_M5;
	private JRadioButton rbOperand_M4;
	private JRadioButton rbOperand_M3;
	private JRadioButton rbOperand_M2;
	private JRadioButton rbOperand_M1;
	private JRadioButton rbOperand_0;
	private JRadioButton rbOperand_P1;
	private JRadioButton rbOperand_P2;
	private JRadioButton rbOperand_P3;
	private JRadioButton rbOperand_P4;
	private JRadioButton rbOperand_P5;
    private JTextArea taEditor;

	public JButton btnHelp; 
	public JButton btnHelpRule; 
	private JButton btnReset; 
	private JButton btnResetData; 
	private JButton btnGo; 

	private String curr_uniqueid; // the uniqueid of the current app.
	private int flag;
	private String att_uid;
	private String codomain;
	private String valuetype;
	private RuleHelp oHelp;
	public String audit_uid;
	public String log;
	public boolean first_call;
    private DatabaseDatasetLoader dsl;
    private boolean stochastic_go;
    private boolean stochastic_end;
	
    /**
	 * The constructor <CODE>ExpApplicationDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpApplicationDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);
		
		try {
			
			first_call = false;
			dsl = new DatabaseDatasetLoader();

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(630, 405));

	        createHead(pnlScreen, Globals.message.getMessage("msg0082"));

			DbAccessReadExpSystem app = new DbAccessReadExpSystem(Globals.sysUser);
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser);
			DbAccessReadExpCondition con = new DbAccessReadExpCondition(Globals.sysUser);

			control_column = 160;
			label_line = 10;
			createLabelAt(pnlScreen, app.getDefData("name", "label"), 350);
			label_line = 10;
	        lblAppname = createLabelField(pnlScreen, 400, 400, false);
			label_line = 25;
	        lblType = createLabelField(pnlScreen, 400, 400, false);

			label_line = 30;
			createLabel(pnlScreen, att.getDefData("question", "label"));
			taQuestion = createTextArea(pnlScreen, 440, (int) (pnl_height / 6.1));
			taQuestion.setEditable(false);
	        btnHelp = createButton(pnlScreen, label_line, 120, 
					DataSite.BUTTON_HELP, Globals.message.getMessage("msg0056"));
			btnHelp.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnHelp_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
    	    btnHelp.setEnabled(false);

			label_line += (int) (pnl_height / 8);
			createLabel(pnlScreen, con.getDefData("operand", "label"));
			cbxOperand = createCombo(pnlScreen, control_column, 440);
	        tfOperand = createTextField(pnlScreen);
	        tfOperand.setVisible(false);
	        
	        rbOperand_M5 = new JRadioButton("-5");
	        rbOperand_M5.setBounds(control_column, label_line, 36, 20);
            pnlScreen.add(rbOperand_M5);
	        rbOperand_M4 = new JRadioButton("-4");
	        rbOperand_M4.setBounds(control_column + 35, label_line, 36, 20);
            pnlScreen.add(rbOperand_M4);
	        rbOperand_M3= new JRadioButton("-3");
	        rbOperand_M3.setBounds(control_column + 70, label_line, 36, 20);
            pnlScreen.add(rbOperand_M3);
	        rbOperand_M2 = new JRadioButton("-2");
	        rbOperand_M2.setBounds(control_column + 105, label_line, 36, 20);
            pnlScreen.add(rbOperand_M2);
	        rbOperand_M1 = new JRadioButton("-1");
	        rbOperand_M1.setBounds(control_column + 140, label_line, 36, 20);
            pnlScreen.add(rbOperand_M1);
	        rbOperand_0 = new JRadioButton("0");
	        rbOperand_0.setBounds(control_column + 175, label_line, 36, 20);
            pnlScreen.add(rbOperand_0);
            rbOperand_0.setSelected(true);
	        rbOperand_P1 = new JRadioButton("+1");
	        rbOperand_P1.setBounds(control_column + 210, label_line, 39, 20);
            pnlScreen.add(rbOperand_P1);
	        rbOperand_P2 = new JRadioButton("+2");
	        rbOperand_P2.setBounds(control_column + 245, label_line, 39, 20);
            pnlScreen.add(rbOperand_P2);
	        rbOperand_P3 = new JRadioButton("+3");
	        rbOperand_P3.setBounds(control_column + 280, label_line, 39, 20);
            pnlScreen.add(rbOperand_P3);
	        rbOperand_P4 = new JRadioButton("+4");
	        rbOperand_P4.setBounds(control_column + 315, label_line, 39, 20);
            pnlScreen.add(rbOperand_P4);
	        rbOperand_P5 = new JRadioButton("+5");
	        rbOperand_P5.setBounds(control_column + 350, label_line, 39, 20);
            pnlScreen.add(rbOperand_P5);
			ButtonGroup bg = new ButtonGroup();
			bg.add(rbOperand_M5);
			bg.add(rbOperand_M4);
			bg.add(rbOperand_M3);
			bg.add(rbOperand_M2);
			bg.add(rbOperand_M1);
			bg.add(rbOperand_0);
			bg.add(rbOperand_P1);
			bg.add(rbOperand_P2);
			bg.add(rbOperand_P3);
			bg.add(rbOperand_P4);
			bg.add(rbOperand_P5);
			rbOperand_M5.setVisible(false);
			rbOperand_M4.setVisible(false);
			rbOperand_M3.setVisible(false);
			rbOperand_M2.setVisible(false);
			rbOperand_M1.setVisible(false);
			rbOperand_0.setVisible(false);
			rbOperand_P1.setVisible(false);
			rbOperand_P2.setVisible(false);
			rbOperand_P3.setVisible(false);
			rbOperand_P4.setVisible(false);
			rbOperand_P5.setVisible(false);

	        createSeparator(pnlScreen, 575);

	        createLabel(pnlScreen, Globals.message.getMessage("msg0058"));
			taEditor = createTextArea(pnlScreen, 440, (int) (pnl_height / 6.1));
			taEditor.setEditable(false);

		    sclScreen = createScrollPane(pnlScreen, pnl_width, pnl_height);

	        btnHelpRule = createButton(pnlScreen, (int) (pnl_height / 1.245), 450, 
					DataSite.BUTTON_HELP, Globals.message.getMessage("msg0055"));
			btnHelpRule.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnHelpRule_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
    	    btnHelpRule.setEnabled(false);

	        btnGo = createButton(pnlScreen, (int) (pnl_height / 1.245), 490, 
					DataSite.BUTTON_USE, Globals.message.getMessage("msg0059"));
			btnGo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnGo_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnGo.setEnabled(false);

			btnReset = createButton(pnlScreen, (int) (pnl_height / 1.245), 530, 
					DataSite.BUTTON_CHECK, Globals.message.getMessage("msg0057"));
			btnReset.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReset_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnReset.setEnabled(false);

			btnResetData = createButton(pnlScreen, (int) (pnl_height / 1.245), 570, 
					DataSite.BUTTON_UPLOAD, Globals.message.getMessage("msg0081"));
			btnResetData.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnResetData_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnResetData.setEnabled(false);

			flag = 0;

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>btnHelpRule_actionPerformed</CODE> action of the btnHelpRule.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnHelpRule_actionPerformed(ActionEvent e) throws Exception {
		btnHelpRule.setEnabled(false);
		ArrayList messages = new ArrayList();
		messages.add(Globals.message.getMessage("msg0050"));
		messages.add(Globals.message.getMessage("msg0051"));
		messages.add(Globals.message.getMessage("msg0043"));
		messages.add(Globals.message.getMessage("msg0052"));
		messages.add(Globals.message.getMessage("msg0053"));
		messages.add(Globals.message.getMessage("msg0054"));
		if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
			oHelp = new RuleHelp(Globals.ead, this, Globals.t4ex.getCurrRule(), -1,
					Globals.message.getMessage("msg0055"),
					Globals.t4ex, messages, Globals.sysUser, "expertanddecision");
		}
		btnHelpRule.setEnabled(true);
	}
	
	/**
	 * The method <CODE>btnHelp_actionPerformed</CODE> action of the btnHelp.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnHelp_actionPerformed(ActionEvent e) throws Exception {
		btnHelp.setEnabled(false);
		AttHelp oHelpAtt = new AttHelp(Globals.ead, att_uid, Globals.message.getMessage("msg0056"), 
				Globals.sysUser);
		btnHelp.setEnabled(true);
	}
	
	/**
	 * The method <CODE>performReset</CODE> resets the expert system.
	 * @param reset_data true -> load attribute data. 
	 * @exception Exception
	 * @since 1.0
	 */
	private void performReset(boolean reset_data) throws Exception {
		
		Globals.t4base.enableAllRules(Globals.curr_expsystem_uniqueid_1);
		
		Globals.info_message.setText("");
    	Globals.curr_expsystem_uniqueid_1 = curr_uniqueid;
		flag = 0;
    	btnGo.setEnabled(true);
    	taQuestion.setText("");
    	taEditor.setText("");
    	cbxOperand.setVisible(false);
    	tfOperand.setText("");
    	if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
    	    btnHelp.setEnabled(false);
    	    btnHelpRule.setEnabled(false);
    		tfOperand.setVisible(true);
        	rbOperand_M5.setVisible(false);
			rbOperand_M4.setVisible(false);
			rbOperand_M3.setVisible(false);
			rbOperand_M2.setVisible(false);
			rbOperand_M1.setVisible(false);
			rbOperand_0.setVisible(false);
			rbOperand_P1.setVisible(false);
			rbOperand_P2.setVisible(false);
			rbOperand_P3.setVisible(false);
			rbOperand_P4.setVisible(false);
			rbOperand_P5.setVisible(false);
    	} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
    	    btnHelp.setEnabled(true);
    	    btnHelpRule.setEnabled(false);
    		tfOperand.setVisible(false);
        	rbOperand_M5.setVisible(true);
			rbOperand_M4.setVisible(true);
			rbOperand_M3.setVisible(true);
			rbOperand_M2.setVisible(true);
			rbOperand_M1.setVisible(true);
			rbOperand_0.setVisible(true);
			rbOperand_P1.setVisible(true);
			rbOperand_P2.setVisible(true);
			rbOperand_P3.setVisible(true);
			rbOperand_P4.setVisible(true);
			rbOperand_P5.setVisible(true);
    	}
    	
    	if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
    		
			Globals.t4ex.reset();
	    	Globals.t4ex.putInitialAttributesOnGoal(curr_uniqueid);
	    	
	    	if (reset_data) {
	    		if (Globals.t4base.isResultAttribute(Globals.curr_project_uniqueid)) {
	    			
	    	    	ArrayList tabs = dsl.getDataSetRead(Globals.sysUser, "ResultAtt",
	    					null, "idexpattribute(codomain)", "idresultvalue(value,ruleno)", 
	    					"idproject='" + Globals.curr_project_uniqueid + "'",
	    					null, "expertanddecision");
	    			
	    			int len = tabs.size();
	    	    	for (int ndx=0; ndx<len;ndx++) {
	    	    		DbAccessReadResultAtt tab = (DbAccessReadResultAtt) tabs.get(ndx);
	    	       		if (tab.errCode != 0) {
	    					t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
	    					return;
	    	       		}
	    	    		
	    				ArrayList vals = tab.getMyDbAccessResultValue();
	        			int len2 = vals.size();
	        	    	for (int ndx2=0; ndx2<len2;ndx2++) {
	        	    		DbAccessReadResultValue val = (DbAccessReadResultValue) vals.get(ndx2);
	        	       		if (val.errCode != 0) {
	        					t4dialog.showException(val.errCode + "\r\n" + val.errMess);
	        					return;
	        	       		}
	    	       			Globals.t4ex.putContextList(tab.getMyDbAccessReadExpAttribute().getUniqueid(), 
	    	       					val.getValue(), val.getRuleno());
	        	    	}
	    	    	}
	    	    	
	    			Globals.info_message.setText(Globals.message.getMessage("msg0079"));
	    		} else {
	        		Globals.info_message.setText(Globals.message.getMessage("msg0080"));
	    		}
	    	} else {
	    		Globals.info_message.setText(Globals.message.getMessage("msg0080"));
	    	}
	    	
    	} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
    		
			stochastic_go = true;
			stochastic_end = false;

			DbAccessReadExpSystem exp = new DbAccessReadExpSystem(Globals.sysUser, 
					curr_uniqueid, "resultnumber", null, null);
			if (exp.errCode != 0) {
				t4dialog.showException(exp.errCode + "\r\n" + exp.errMess);
				return;
			}
			
			Globals.info_message.setText(Globals.message.getMessage("msg0080"));
    		Globals.t4exps = new Tool4ExpertStochastic(Globals.sysUser, curr_uniqueid, (int)exp.getResultnumber(), "core");
    		if (Globals.t4exps.findMaxSymptom()) {
    			att_uid = Globals.t4exps.getAttributeUid();
    			taQuestion.setText(Globals.t4s.replaceString(Globals.t4exps.getQuestion(), "[msg0088]", Globals.message.getMessage("msg0088")));
    		} else {
    			taEditor.setText(Globals.t4s.replaceString(Globals.t4exps.getQuestion(), "[msg0087]", Globals.message.getMessage("msg0087")));
    			enableButtons();
    		}
    		
    	}
	}
	
	/**
	 * The method <CODE>btnReset_actionPerformed</CODE> action of the btnReset.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReset_actionPerformed(ActionEvent e) throws Exception {
    	int val = t4dialog.showDialog(Globals.message.getMessage("msg0057"));
    	if (val == 0) {
        	performReset(false);
    	}
	}
	
	/**
	 * The method <CODE>btnResetData_actionPerformed</CODE> action of the btnResetData.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnResetData_actionPerformed(ActionEvent e) throws Exception {
    	int val = t4dialog.showDialog(Globals.message.getMessage("msg0057"));
    	if (val == 0) {
        	performReset(true);
    	}
	}
	
	/**
	 * The method <CODE>btnGo_actionPerformed</CODE> action of the btnGo.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnGo_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
		
		if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
			goDeterministic();
		} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
			goStochastic();
		}
		
	}

	/**
	 * The method <CODE>goStochastic</CODE> performs the stochastic rule interpreter. 
	 * @exception Exception
	 * @since 1.0
	 */
	public void goStochastic() throws Exception {
		if (!stochastic_go || stochastic_end) {
			return;
		}
		double answer = 0;
		if (rbOperand_M5.isSelected()) {
			answer = -5;
		} else if (rbOperand_M4.isSelected()) {
			answer = -4;
		} else if (rbOperand_M3.isSelected()) {
			answer = -3;
		} else if (rbOperand_M2.isSelected()) {
			answer = -2;
		} else if (rbOperand_M1.isSelected()) {
			answer = -1;
		} else if (rbOperand_0.isSelected()) {
			answer = 0;
		} else if (rbOperand_P1.isSelected()) {
			answer = 1;
		} else if (rbOperand_P2.isSelected()) {
			answer = 2;
		} else if (rbOperand_P3.isSelected()) {
			answer = 3;
		} else if (rbOperand_P4.isSelected()) {
			answer = 4;
		} else if (rbOperand_P5.isSelected()) {
			answer = 5;
		}
		Globals.t4exps.updateProbabilities(answer);
		stochastic_end = Globals.t4exps.searchForBest();
		if (!stochastic_end) {
			stochastic_go = Globals.t4exps.findMaxSymptom();
    		if (stochastic_go) {
    			att_uid = Globals.t4exps.getAttributeUid();
    			taQuestion.setText(Globals.t4s.replaceString(Globals.t4exps.getQuestion(), "[msg0088]", Globals.message.getMessage("msg0088")));
    		} else {
    			taEditor.setText(Globals.t4s.replaceString(Globals.t4exps.getQuestion(), "[msg0087]", Globals.message.getMessage("msg0087")));
    		}
		} else {
		    btnHelp.setEnabled(false);
			att_uid = "";
			taQuestion.setText("");
			String message = Globals.message.getMessage("msg0095") + "\r\n";
			message = Globals.t4s.replaceString(message, "@", Integer.toString(Globals.t4exps.getCountQuestion()));
			message += Globals.t4s.replaceToken(Globals.t4exps.getQuestion(), "[msg0089]", Globals.message.getMessage("msg0089"));
			message = Globals.t4s.replaceToken(message, "[msg0090]", Globals.message.getMessage("msg0090"));
			message = Globals.t4s.replaceToken(message, "[msg0091]", Globals.message.getMessage("msg0091"));
			taEditor.setText(message);
		}
	}
	
	/**
	 * The method <CODE>goDeterministic</CODE> performs the deterministic rule interpreter. 
	 * @exception Exception
	 * @since 1.0
	 */
	public void goDeterministic() throws Exception {
		
    	if (flag == Tool4ExpertSystemDeterministic.ATTRIBUTE_ANSWER) {
    		if (valuetype.equals("-72c8c14d:13cbf89ea6b:-7ffa")) { // univalue
				if (codomain.equals("-72c8c14d:13cbf89ea6b:-7fff")) { // boolean.
					Globals.t4ex.putContextList(att_uid, cbxOperand.getIndexKey(), -1);
				} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffd")) { // float.
					Globals.t4ex.putContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffe")) { // integer.
					Globals.t4ex.putContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set.
					Globals.t4ex.putContextList(att_uid, cbxOperand.getIndexKey(), -1);
				} else if (codomain.equals("-10553fa8:13cc8d95901:-7ffe")) { // string.
					Globals.t4ex.putContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("6935473a:13cf7e0dacf:-7fff")) { // function.
					Globals.t4ex.putContextList(att_uid, tfOperand.getText(), -1);
				} else {
					throw new Exception("codomain not for univalue.");
				}
    		} else if (valuetype.equals("-72c8c14d:13cbf89ea6b:-7ff9")) { // multivalue
				if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffd")) { // float.
					Globals.t4ex.putListContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffe")) { // integer.
					Globals.t4ex.putListContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("-10553fa8:13cc8d95901:-7ffe")) { // string.
					Globals.t4ex.putListContextList(att_uid, tfOperand.getText(), -1);
				} else if (codomain.equals("574e61e8:13d58824c04:-8000")) { // sum.
					Globals.t4ex.putListContextList(att_uid, tfOperand.getText(), -1);
				} else {
					throw new Exception("codomain not for multivalue.");
				}
    		}
    	}
    	
    	ArrayList result = Globals.t4ex.ruleInterpreter();
    	flag = (Integer) result.get(0);
    	
    	if (flag == Tool4ExpertSystemDeterministic.ATTRIBUTE) {
    		
    		att_uid = (String) result.get(1);
    		createCurrentData(curr_uniqueid);
    		
    		
    	} else if (flag == Tool4ExpertSystemDeterministic.END) {
    		
    		Globals.info_message.setText(Globals.message.getMessage("msg0060"));
        	btnGo.setEnabled(false);
        	btnHelp.setEnabled(false);
        	btnHelpRule.setEnabled(false);

        	cbxOperand.setVisible(false);
        	tfOperand.setText("");
        	tfOperand.setVisible(true);
        	taQuestion.setText("");

        	boolean is_result = false;
        	String att_log = "";
        	DatabaseDatasetLoader dsl = new DatabaseDatasetLoader();
    		ArrayList atts = dsl.getDataSetRead(Globals.sysUser, "ExpAttribute", 
    				"name", null, null, "initialattribute=1 AND idexpsystem='" + Globals.curr_expsystem_uniqueid_1 + "'", 
    				null, "core");
    		int len = atts.size();
    		for (int ndx=0;ndx<len;ndx++) {
    			n4e.core.dbaccess.DbAccessReadExpAttribute att = (n4e.core.dbaccess.DbAccessReadExpAttribute) atts.get(ndx) ;
        		if (att.errCode == 0) {
        			att_log += att.getName() + "\r\n";
        			ArrayList values = Globals.t4ex.getContextListValue(att.getUniqueid());
        			if (values != null) {
        				is_result = true;
	        			int len2 = values.size();
						for (int ndx2=0;ndx2<len2;ndx2++) {
							Context con = (Context) values.get(ndx2);
							DbAccessReadExpCodomain cod = new DbAccessReadExpCodomain(Globals.sysUser, con.value, "text", null, null);
							att_log += "   " + cod.getText() + "\r\n";
						}
        			}
        		} else {
    				att_log = Globals.message.getMessage("msg0062");
        		}
    		}
    		
    		if (!is_result) {
				att_log = Globals.message.getMessage("msg0061");
    		}
    		
    		taEditor.setText(att_log);
    		taEditor.setSelectionStart(0);
    		taEditor.setSelectionEnd(0);
    	}
	}
	
	/**
	 * The method <CODE>callUseFromTable</CODE> performs the use button functionality, 
	 * if use button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callUseFromTable(String table_name) throws Exception {
    	int select = oHelp.modRuleData.getSelectedRow();
    	if (select > -1) {
    		DbAccessReadExpCondition con = new DbAccessReadExpCondition(Globals.sysUser, 
    				oHelp.modRuleData.getIndexKey(), 
    				null, "idexpattribute(name,codomain)", null);
    		if (con.errCode != 0) {
    			t4dialog.showException(con.errCode + "\r\n" + con.errMess);
    			return;
    		}
    		Tool4ExpertSystem expsys = Globals.t4ex;
			String value = expsys.getContextListFirstValue(con.getMyDbAccessReadExpAttribute().getUniqueid());
			long rule = expsys.getContextListFirstRule(con.getMyDbAccessReadExpAttribute().getUniqueid());
			if (rule == -1) {
				String message = Globals.message.getMessage("msg0094");
				message = Globals.t4s.replaceString(message, "@att@", con.getMyDbAccessReadExpAttribute().getName());
				if (con.getMyDbAccessReadExpAttribute().getCodomain().equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set
					DbAccessReadExpCodomain cod = new DbAccessReadExpCodomain(Globals.sysUser, value, "text", null, null);
					message = Globals.t4s.replaceString(message, "@value@", cod.getText());
				} else {
					message = Globals.t4s.replaceString(message, "@value@", value);
				}
				t4dialog.showInfoDialog(message);
			} else {
				ArrayList messages = new ArrayList();
				messages.add(Globals.message.getMessage("msg0050"));
				messages.add(Globals.message.getMessage("msg0051"));
				messages.add(Globals.message.getMessage("msg0043"));
				messages.add(Globals.message.getMessage("msg0052"));
				messages.add(Globals.message.getMessage("msg0053"));
				messages.add(Globals.message.getMessage("msg0054"));
				oHelp.dispose();
				oHelp = new RuleHelp(Globals.ead, this, null, rule,
						Globals.message.getMessage("msg0079"),
						Globals.t4ex, messages, Globals.sysUser, "core");
			}
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
	}
	
	/**
	 * The method <CODE>enableButtons</CODE> enable the buttons.
	 * @exception Exception
	 * @since 1.0
	 */
	public void enableButtons() throws Exception {
		btnReset.setEnabled(true);
		btnResetData.setEnabled(true);
    	btnGo.setEnabled(false);
	    btnHelp.setEnabled(false);
	    btnHelpRule.setEnabled(false);
    	taQuestion.setText("");
    	taEditor.setText("");
		cbxOperand.resetKeyList();
        tfOperand.setText("");;
	}
	
	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		curr_uniqueid = uniqueid;
		sclScreen.setVisible(true);

		DbAccessReadExpSystem app = new DbAccessReadExpSystem(Globals.sysUser, 
				uniqueid, "name,type", null, null);
		if (app.errCode != 0) {
			t4dialog.showException(app.errCode + "\r\n" + app.errMess);
			return;
		}
		
        lblAppname.setText(app.getName());
        if (app.getType() == Globals.DETERMINISTIC) {
            lblType.setText("(" + Globals.message.getMessage("msg0085") + ")");
        } else if (app.getType() == Globals.STOCHASTIC) {
            lblType.setText("(" + Globals.message.getMessage("msg0086") + ")");
        }
	    
    	if (flag == Tool4ExpertSystemDeterministic.ATTRIBUTE) { 
    		
    		flag = Tool4ExpertSystemDeterministic.ATTRIBUTE_ANSWER;
    		
    		DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
    				att_uid, "name,codomain,valuetype,question", null, null);
    		if (att.errCode != 0) {
    			t4dialog.showException(att.errCode + "\r\n" + att.errMess);
    			return;
    		}
    	    taQuestion.setText(att.getQuestion());
    	    btnHelp.setEnabled(true);
    	    btnHelpRule.setEnabled(true);

			cbxOperand.resetKeyList();
			codomain = att.getCodomain();
			valuetype = att.getValuetype();
			if (codomain.equals("-72c8c14d:13cbf89ea6b:-7fff")) { // boolean.
				tfOperand.setVisible(false);
				cbxOperand.setVisible(true);
				cbxOperand.addItem("true");
				cbxOperand.addKey("true");
				cbxOperand.addItem("false");
				cbxOperand.addKey("false");
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffd")) { // float.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("");
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffe")) { // integer.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("");
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set.
				tfOperand.setVisible(false);
				cbxOperand.setVisible(true);
				Globals.t4md.fillComboCod(cbxOperand, null, att_uid);
			} else if (codomain.equals("-10553fa8:13cc8d95901:-7ffe")) { // string.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("");
			} else if (codomain.equals("6935473a:13cf7e0dacf:-7fff")) { // function.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("-don't show it-");
			} else if (codomain.equals("574e61e8:13d58824c04:-8000")) { // sum.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("");
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffa")) { // tuple.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText("");
			}
    	}

	}
}

