package n4e.expertanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import n4e.core.controls.*;
import n4e.core.database.DatabaseDatasetLoader;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.expertanddecision.dbaccess.DbAccessExpAttribute;
import n4e.expertanddecision.dbaccess.DbAccessExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpAttribute;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpSystem;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>ExpAttributeDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 14:50:38
 * @since 1.0
 */

public class ExpAttributeDataSite extends DataSite {

    private AWTextField tfName;
    private JLabel lblCodomain;
    private AWCombo cbxCodomain;
    private AWCombo cbxValuetype;
    private JCheckBox cbInitialattribute;
    private JCheckBox cbInitial; 
    private JTextArea taQuestion; 
    private JLabel lblSentence;
    private JTextArea taShortdescription; 
    private JTextArea taDescription; 
    private AWTableModel modValueMod; 

//    private JButton btnRuleList; 
    private JButton btnNewValue; 
    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;

	/**
	 * The constructor <CODE>ExpAttributeDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpAttributeDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(600, 380));

			createHead(pnlScreen, Globals.message.getMessage("msg0040"));

			DbAccessReadExpAttribute tab = new DbAccessReadExpAttribute(Globals.sysUser);

            createLabel(pnlScreen, tab.getDefData("name", "label"));
            tfName = createTextField(pnlScreen);

            createLabelMid(pnlScreen, tab.getDefData("initialattribute", "label"), 420);
            cbInitialattribute = createCheckBox(pnlScreen, 490);

			createLabel(pnlScreen, tab.getDefData("codomain", "label") + " / " + 
					tab.getDefData("valuetype", "label"));
			cbxCodomain = createCombo(pnlScreen, control_column, 157);
			cbxCodomain.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						cbxCodomain_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
	    	
			cbxValuetype = createCombo(pnlScreen, 420, 157);
	    	
			createLabel(pnlScreen, tab.getDefData("question", "label"));
			taQuestion = createTextArea(pnlScreen, 380, 40);
			
			label_line = label_line + 40;
			lblSentence = new JLabel(Globals.message.getMessage("msg0044"));
			lblSentence.setBounds(control_column, label_line, label_width, label_hight);
			pnlScreen.add(lblSentence);
			
			createLabel(pnlScreen, tab.getDefData("adddata", "label"));
			taShortdescription = createTextArea(pnlScreen, 380, 40);
			 
			label_line = label_line + 20;
			createLabel(pnlScreen, tab.getDefData("description", "label"));
			taDescription = createTextArea(pnlScreen, 380, 50);

			label_line += 30;
			lblCodomain = createLabel(pnlScreen, Globals.message.getMessage("msg0083"));
			modValueMod = createTable("Value", pnlScreen, 
					new DbAccessReadExpCodomain(Globals.sysUser), 
					"text", 
					control_column, label_line, 380, 90, this.BUTTON_USE_AND_DELETE, 
					null, null);

			sclScreen = createScrollPane(pnlScreen, pnl_width - 25, pnl_height - 45);

/*			btnRuleList = createButton(pnlScreen, 360, 410, 
					DataSite.BUTTON_LIST, Globals.message.getMessage("msg0046"));
			btnRuleList.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnRuleList_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});*/

			btnNewValue = createButton(pnlScreen, 350, 450, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0045"));
			btnNewValue.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNewValue_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnNew = createButton(pnlScreen, 350, 490, 
				DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, 350, 530,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, 350, 570,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>cbxCodomain_actionPerformed</CODE> action of the cbxCodomain.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void cbxCodomain_actionPerformed(ActionEvent e) throws Exception {
		if (cbxCodomain.getIndexKey() != null 
				&& cbxCodomain.getIndexKey().equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set.
			tableScrollPane.setVisible(true);
			lblCodomain.setVisible(true);
			btnNewValue.setVisible(true);
		} else {
			tableScrollPane.setVisible(false);
			lblCodomain.setVisible(false);
			btnNewValue.setVisible(false);
		}
	}

	/**
	 * The method <CODE>btnRuleList_actionPerformed</CODE> action of the btnRuleList.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
/*	private void btnRuleList_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
		fireSiteChangeEvent_3(curr_uniqueid);
	}*/
	
	/**
	 * The method <CODE>btnNewValue_actionPerformed</CODE> action of the btnNewValue.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNewValue_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
		sclScreen.setVisible(false);
		fireSiteChangeEvent_2(null);
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessExpAttribute tab = new DbAccessExpAttribute(Globals.sysUser, curr_uniqueid,
				"all", null, null);

		if (tab.errCode == 0 || tab.errCode == tab.ERROR_0001) {

			tab.errCode = 0;
			tab.setFieldAsString("name", tfName.getText());
            tab.setCodomain(cbxCodomain.getIndexKey());
            tab.setValuetype(cbxValuetype.getIndexKey());
            if (cbInitialattribute.isSelected()) {
                tab.setInitialattribute(1);
            } else {
                tab.setInitialattribute(0);
            }
			tab.setFieldAsString("question", taQuestion.getText());
			tab.setFieldAsString("adddata", taShortdescription.getText());
			tab.setFieldAsString("description", taDescription.getText());
			tab.setFieldAsString("idexpsystem", Globals.curr_expsystem_uniqueid_2);

            if (tab.errCode != 0) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			} else if (!tab.putToSink(null)) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			}

			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			curr_uniqueid = tab.getUniqueid();
			Globals.curr_attribute_uniqueid = curr_uniqueid;
			createCurrentData(curr_uniqueid);

		} else {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
		}

	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_1(curr_uniqueid);
	}

	/**
	 * The method <CODE>callUseFromTable</CODE> performs the use button functionality, 
	 * if use button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callUseFromTable(String table_name) throws Exception {
		
		Globals.info_message.setText("");
    	
    	int select = modValueMod.getSelectedRow();
    	if (select > -1) {
        	sclScreen.setVisible(false);
    		fireSiteChangeEvent_2(modValueMod.getIndexKey());
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
    	
	}

	/**
	 * The method <CODE>callDeleteFromTable</CODE> performs the delete button functionality, 
	 * if delete button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callDeleteFromTable(String table_name) throws Exception {
		
    	int select = modValueMod.getSelectedRow();
    	if (select > -1) {
    		
    		// read the author.
    		DbAccessExpCodomain val = new DbAccessExpCodomain(Globals.sysUser, 
    				modValueMod.getIndexKey(), null, null, null);
    		
    		if (val.errCode == 0) {
    			if (!val.deleteInSink(null)) {
    				t4dialog.showException(val.errCode + "\r\n" + val.errMess);
    				return;
    			}
    			Globals.info_message.setText(Globals.message.getMessage("msg0029"));
				createCurrentData(curr_uniqueid);
    		} else {
				t4dialog.showException(val.errCode + "\r\n" + val.errMess);
    		}
    		
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
        tfName.setText("");
        cbInitialattribute.setSelected(false);
        if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
            Globals.t4md.fillCombo(cbxCodomain, "-72c8c14d:13cbf89ea6b:-8000", false, false, null, true);
            Globals.t4md.fillCombo(cbxValuetype, "-72c8c14d:13cbf89ea6b:-7ffb", false, false, null, true);
        	cbInitialattribute.setEnabled(true);
        	cbxCodomain.setEnabled(true);
        	cbxValuetype.setEnabled(true);
        } else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
            Globals.t4md.fillCombo(cbxCodomain, "-72c8c14d:13cbf89ea6b:-8000", false, false, "637bc401:15a408ce90e:-8000", true);
            Globals.t4md.fillCombo(cbxValuetype, "-72c8c14d:13cbf89ea6b:-7ffb", false, false, "-72c8c14d:13cbf89ea6b:-7ffa", true);
        	cbInitialattribute.setEnabled(false);
        	cbxCodomain.setEnabled(false);
        	cbxValuetype.setEnabled(false);
        }
	    taQuestion.setText("*");
	    taShortdescription.setText("*"); 
	    taDescription.setText("*");
	    btnNewValue.setEnabled(false);
//	    btnRuleList.setEnabled(false);
		modValueMod.resetKeyList();
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;
	    btnNewValue.setEnabled(true);

		DbAccessReadExpAttribute tab = new DbAccessReadExpAttribute(Globals.sysUser,
				uniqueid, "all", null, null);
		if (tab.errCode != 0) {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
			return;
		}

        tfName.setText(tab.getName());
        Globals.t4md.fillCombo(cbxCodomain, "-72c8c14d:13cbf89ea6b:-8000", false, false, tab.getCodomain(), true);
        Globals.t4md.fillCombo(cbxValuetype, "-72c8c14d:13cbf89ea6b:-7ffb", false, false, tab.getValuetype(), true);
        if (tab.getInitialattribute() == 1) {
            cbInitialattribute.setSelected(true);
        } else {
            cbInitialattribute.setSelected(false);
        }
        if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
        	cbInitialattribute.setEnabled(true);
        	cbxCodomain.setEnabled(true);
        	cbxValuetype.setEnabled(true);
        } else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
        	cbInitialattribute.setEnabled(false);
        	cbxCodomain.setEnabled(false);
        	cbxValuetype.setEnabled(false);
        }

	    taQuestion.setText(tab.getQuestion());
	    
	    taShortdescription.setText(tab.getAdddata());
	    
		taDescription.setText(tab.getDescription());
	    
	    // fetch values. 
		DatabaseDatasetLoader dsl = new DatabaseDatasetLoader();
		ArrayList tabs = dsl.getDataSetRead(Globals.sysUser, "ExpCodomain",
				"text", null, null, "idexpattribute='" + uniqueid + "'",
				"text ASC", "expertanddecision");
		
		modValueMod.resetKeyList();
    	
    	int len = tabs.size();
    	for (int ndx=0; ndx<len;ndx++) {
    		DbAccessReadExpCodomain val = (DbAccessReadExpCodomain) tabs.get(ndx);
       		if (tab.errCode == 0) {
    			modValueMod.addKey(val.getUniqueid());
				Object[] row = new Object[3]; 
				row[0] = val.getText(); 
				row[1] = "";
				row[2] = "";
				modValueMod.addRow(row);
       		}
    	}
	}
}
