package n4e.expertanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.*;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.expertanddecision.dbaccess.DbAccessExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpRule;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>ExpCodomainDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 17:43:50
 * @since 1.0
 */

public class ExpCodomainDataSite extends DataSite {

    private AWTextField tfValue;

    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;

	/**
	 * The constructor <CODE>ExpCodomainDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpCodomainDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(300, 300));

			createHead(pnlScreen, Globals.message.getMessage("msg0047"));

			DbAccessReadExpCodomain tab = new DbAccessReadExpCodomain(Globals.sysUser);

			createLabel(pnlScreen, tab.getDefData("text", "label"));
	        tfValue = createTextField(pnlScreen);

		    sclScreen = createScrollPane(pnlScreen, pnl_width - 25, pnl_height - 45);

			btnNew = createButton(pnlScreen, pnl_height - 100, pnl_width - 170, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, pnl_height - 100, pnl_width - 130,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, pnl_height - 100, pnl_width - 90,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessExpCodomain val = new DbAccessExpCodomain(Globals.sysUser, curr_uniqueid, 
				"all", "idexpattribute", null);
		
		if (val.errCode == 0 || val.errCode == val.ERROR_0001) {
			
			val.errCode = 0;
			val.setFieldAsString("text", tfValue.getText());
			val.setFieldAsString("idexpattribute", Globals.curr_attribute_uniqueid);
			
			if (val.errCode != 0) {
				t4dialog.showException(val.errCode + "\r\n" + val.errMess, false);
				return;
			} else if (!val.putToSink(null)) {
				t4dialog.showException(val.errCode + "\r\n" + val.errMess, false);
				return;
			}
			
			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			curr_uniqueid = val.getUniqueid();
		    
		} else {
			t4dialog.showException(val.errCode + "\r\n" + val.errMess);
			return;
		}

	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_2(Globals.curr_attribute_uniqueid);
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
	    tfValue.setText("");
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;

		DbAccessExpCodomain val = new DbAccessExpCodomain(Globals.sysUser, curr_uniqueid, 
				"text", null, null);
		
		if (val.errCode != 0) {
			t4dialog.showException(val.errCode + "\r\n" + val.errMess);
			return;
		}

	    tfValue.setText(val.getText());

	}
}
