package n4e.expertanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.*;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.expertanddecision.dbaccess.DbAccessExpCondition;
import n4e.expertanddecision.dbaccess.DbAccessReadExpAttribute;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCondition;
import n4e.expertanddecision.dbaccess.DbAccessReadExpRule;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;
import n4e.expertanddecision.tool.Tool4MyDialog;

/**
 * The <CODE>ExpConditionDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 15:47:06
 * @since 1.0
 */

public class ExpConditionDataSite extends DataSite {

    private AWCombo cbxCondition;
	private AWCombo cbxAttribute;
	private JLabel lblCodomain;
	private JLabel lblValuetype;
    private AWCombo cbxOperator;
	private AWCombo cbxOperand;
    private AWTextField tfOperand;

    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;
    private long sort_cond;

	/**
	 * The constructor <CODE>ExpConditionDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpConditionDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(600, 250));

			createHead(pnlScreen, Globals.message.getMessage("msg0043"));

			DbAccessReadExpCondition tab = new DbAccessReadExpCondition(Globals.sysUser);
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser);

            createLabel(pnlScreen, tab.getDefData("condition", "label"));
            cbxCondition = createCombo(pnlScreen);
			cbxCondition.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						cbxCondition_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createLabel(pnlScreen, Globals.message.getMessage("msg0040"));
			cbxAttribute = createCombo(pnlScreen, control_column, 300);
			cbxAttribute.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						cbxAttribute_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createLabel(pnlScreen, att.getDefData("codomain", "label"));
			lblCodomain = createLabelField(pnlScreen, control_column, 200, false);
			
			createLabel(pnlScreen, att.getDefData("valuetype", "label"));
			lblValuetype = createLabelField(pnlScreen, control_column, 200, false);

			createLabel(pnlScreen, tab.getDefData("operator", "label"));
            cbxOperator = createCombo(pnlScreen);

			createLabel(pnlScreen, tab.getDefData("operand", "label"));
			cbxOperand = createCombo(pnlScreen, control_column, 300);
	        tfOperand = createTextField(pnlScreen);
	        tfOperand.setVisible(false);

		    sclScreen = createScrollPane(pnlScreen, pnl_width - 25, pnl_height - 50);

			btnNew = createButton(pnlScreen, 210, 490, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, 210, 530,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, 210, 570,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>calcDimension</CODE> calculates the dimension of the controls.
	 * @param width the width of the panel.
	 * @param height the height of the panel.
	 * @since 1.0
	 */
	public void calcDimension(int width, int height) {
		sclScreen.setBounds(10, 10, width - 45, height - 70);
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessExpCondition tab = new DbAccessExpCondition(Globals.sysUser, curr_uniqueid,
				"all", null, null);

		if (tab.errCode == 0 || tab.errCode == tab.ERROR_0001) {

			tab.errCode = 0;
			tab.setSort(sort_cond);
            tab.setCondition(cbxCondition.getIndexKey());
            tab.setOperator(cbxOperator.getIndexKey());
			tab.setFieldAsString("idexpattribute", cbxAttribute.getIndexKey());
			tab.setFieldAsString("idexprule", Globals.curr_rule_uniqueid);

			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
					cbxAttribute.getIndexKey(), "codomain", null, null);

			String codomain = att.getCodomain();
			if (codomain.equals("-72c8c14d:13cbf89ea6b:-7fff")) { // boolean.
				tab.setOperand(cbxOperand.getIndexKey());
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffd")) { // float.
				tab.setOperand(tfOperand.getText());
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffe")) { // integer.
				tab.setOperand(tfOperand.getText());
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set.
				tab.setOperand(cbxOperand.getIndexKey());
			} else if (codomain.equals("-10553fa8:13cc8d95901:-7ffe")) { // string.
				tab.setOperand(tfOperand.getText());
			} else if (codomain.equals("574e61e8:13d58824c04:-8000")) { // sum.
				tab.setOperand(tfOperand.getText());
			} else if (codomain.equals("6935473a:13cf7e0dacf:-7fff")) { // function.
				tab.setOperand(tfOperand.getText());
			} else if (codomain.equals("637bc401:15a408ce90e:-8000")) { // tuple.
				String tuple = tfOperand.getText().trim();
				int ndx1 = tuple.indexOf("(");
				int ndx2 = tuple.indexOf(";");
				int ndx3 = tuple.indexOf(")");
				if (ndx1 == -1 || ndx2 == -1 || ndx3 == -1) {
					Globals.t4dialog.showErrorDialog(Globals.message.getMessage("msg0084"));
					return;
				}
				if (ndx1 > ndx2 || ndx1 > ndx3 || ndx2 > ndx3) {
					Globals.t4dialog.showErrorDialog(Globals.message.getMessage("msg0084"));
					return;
				}
				tab.setOperand(tuple);
			}

			if (tab.errCode != 0) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			} else if (!tab.putToSink(null)) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			}

			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			curr_uniqueid = tab.getUniqueid();

		} else {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
		}

	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_2(Globals.curr_rule_uniqueid);
	}

	/**
	 * The method <CODE>cbxAttribute_actionPerformed</CODE> action of the cbxAttribute.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void cbxCondition_actionPerformed(ActionEvent e) throws Exception {
		
		String condition = cbxCondition.getIndexKey();
		if (condition == null) {
			return;
		}
		
		// preset the then condition.
		if (condition.equals("-72c8c14d:13cbf89ea6b:-7ff5")) { // THEN.
			DbAccessReadExpRule rule = new DbAccessReadExpRule(Globals.sysUser, Globals.curr_rule_uniqueid, 
					null, "idexpsystem", null);
			if (rule.errCode != 0) {
				t4dialog.showException(rule.errCode + "\r\n" + rule.errMess);
				return;
			}
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
					null, "all", null, null, "idexpsystem='" 
					+ rule.getMyDbAccessReadExpSystem().getUniqueid() + "' "
					+ "AND initialattribute=1");
			if (att.errCode == att.ERROR_0002) {
				return;
			}
			if (att.errCode != 0) {
				t4dialog.showException(att.errCode + "\r\n" + att.errMess);
				return;
			}
			Globals.t4md.fillComboAtt(cbxAttribute, att.getUniqueid(), 
					rule.getMyDbAccessReadExpSystem().getUniqueid(), Tool4MyDialog.ALL);
			Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
					false, false, "-72c8c14d:13cbf89ea6b:-7fee", "--:");
		}
		
	}
	
	/**
	 * The method <CODE>cbxAttribute_actionPerformed</CODE> action of the cbxAttribute.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void cbxAttribute_actionPerformed(ActionEvent e) throws Exception {
		fillComboOperand(null);
	}

	/**
	 * The method <CODE>fillComboOperand</CODE> fills the combo operand with values 
	 * depending of the attribute definition.
	 * @param att_uniqueid the uniqueid of the attribute.
	 * @exception Exception
	 * @since 1.0
	 */
	public void fillComboOperand(String index_key) throws Exception {
		
		if (cbxAttribute.getIndexKey() == null) {
			return;
		}
		
		DbAccessReadExpCondition con = new DbAccessReadExpCondition(Globals.sysUser, 
				curr_uniqueid, "operand,operator", "idexpattribute", null);

		String operator;
		if (index_key == null) {
			operator = "-72c8c14d:13cbf89ea6b:-7ff3"; // =
		} else {
			operator = con.getOperator();
		}
		
		DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
				cbxAttribute.getIndexKey(), "codomain,valuetype", null, null);

		if (att.errCode == 0) {
			
			lblCodomain.setText(att.getFieldAsString("codomain"));
			lblValuetype.setText(att.getFieldAsString("valuetype"));
			cbxOperand.resetKeyList();

			String codomain = att.getCodomain();
			if (codomain.equals("-72c8c14d:13cbf89ea6b:-7fff")) { // boolean.
				tfOperand.setVisible(false);
				cbxOperand.setVisible(true);
				cbxOperand.addItem("true");
				cbxOperand.addKey("true");
				cbxOperand.addItem("false");
				cbxOperand.addKey("false");
				cbxOperand.setIndexKey(index_key);
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, ",=,!=,--:");
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffd")) { // float.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, null);
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffe")) { // integer.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, null);
			} else if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set.
				tfOperand.setVisible(false);
				cbxOperand.setVisible(true);
				Globals.t4md.fillComboCod(cbxOperand, con.getOperand(), cbxAttribute.getIndexKey());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, "=,!=,--:");
			} else if (codomain.equals("-10553fa8:13cc8d95901:-7ffe")) { // string.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, ",!=,--:,<,<=,>,>=");
			} else if (codomain.equals("574e61e8:13d58824c04:-8000")) { // sum.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, "--:");
			} else if (codomain.equals("6935473a:13cf7e0dacf:-7fff")) { // function.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, "--:");
			} else if (codomain.equals("637bc401:15a408ce90e:-8000")) { // tuple.
				tfOperand.setVisible(true);
				cbxOperand.setVisible(false);
				tfOperand.setText(con.getOperand());
				Globals.t4md.fillComboExt(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", 
						false, false, operator, "=,!=");
			}
			
			
		} else {
			t4dialog.showException(att.errCode + "\r\n" + att.errMess);
		}
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
        Globals.t4md.fillCombo(cbxCondition, "-72c8c14d:13cbf89ea6b:-7ff8", false, false, null, true);
        Globals.t4md.fillCombo(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", false, false, null, true);
        tfOperand.setText("");

		curr_uniqueid = null;
	    sort_cond = Globals.t4base.getMaxNumberOfConditions(Globals.curr_rule_uniqueid) + 1;
	    if (sort_cond == 1) {
	    	Globals.t4md.fillCombo(cbxCondition, "-72c8c14d:13cbf89ea6b:-7ff8", false, false, 
	    			"-72c8c14d:13cbf89ea6b:-7ff7", true); // IF.
	    } else {
	    	Globals.t4md.fillCombo(cbxCondition, "-72c8c14d:13cbf89ea6b:-7ff8", false, false, null, true);
	    }
		Globals.t4md.fillCombo(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", false, false, null, true);
		DbAccessReadExpRule rule = new DbAccessReadExpRule(Globals.sysUser, Globals.curr_rule_uniqueid, 
				null, "idexpsystem", null);
		if (rule.errCode != 0) {
			t4dialog.showException(rule.errCode + "\r\n" + rule.errMess);
			return;
		}
		Globals.t4md.fillComboAtt(cbxAttribute, null, 
				rule.getMyDbAccessReadExpSystem().getUniqueid(), Tool4MyDialog.ALL);
		
		fillComboOperand(null);
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;

		DbAccessReadExpCondition tab = new DbAccessReadExpCondition(Globals.sysUser,
				uniqueid, "all", "idexpattribute", null);
		if (tab.errCode != 0) {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
			return;
		}

        sort_cond = tab.getSort();
        Globals.t4md.fillCombo(cbxCondition, "-72c8c14d:13cbf89ea6b:-7ff8", false, false, tab.getCondition(), true);
        Globals.t4md.fillCombo(cbxOperator, "-72c8c14d:13cbf89ea6b:-7ff4", false, false, tab.getOperator(), true);
        tfOperand.setText(tab.getOperand());

		String att_id = tab.getMyDbAccessReadExpAttribute().getUniqueid();
		DbAccessReadExpRule rule = new DbAccessReadExpRule(Globals.sysUser, Globals.curr_rule_uniqueid, 
				null, "idexpsystem", null);
		if (rule.errCode != 0) {
			t4dialog.showException(rule.errCode + "\r\n" + rule.errMess);
			return;
		}
		Globals.t4md.fillComboAtt(cbxAttribute, att_id, 
				rule.getMyDbAccessReadExpSystem().getUniqueid(), Tool4MyDialog.ALL);
		fillComboOperand(tab.getOperand());

	}
}
