package n4e.expertanddecision.screen;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.JLabel;
import javax.swing.JPanel;

import n4e.core.controls.AWButton;
import n4e.core.controls.AWTableModel;
import n4e.core.database.DatabaseDatasetLoader;
import n4e.core.list.Context;
import n4e.core.screen.DataSite;
import n4e.core.tool.Tool4Array;
import n4e.core.tool.Tool4Date;
import n4e.core.tool.Tool4Throwable;
import n4e.core.tool.comparision.KeyElement;
import n4e.expertanddecision.dbaccess.DbAccessReadExpAttribute;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadProject;
import n4e.expertanddecision.dbaccess.DbAccessResultAtt;
import n4e.expertanddecision.dbaccess.DbAccessResultValue;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>ExpParameterDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 16.10.2014 12:50:11
 * @since 1.0
 */

public class ExpParameterDataSite extends DataSite {

    private AWTableModel modGoalMod; 
    private AWTableModel modContextMod; 

    private AWButton btnSave;
    private AWButton btnDelete;

    private ArrayList val_index;
    
    private DatabaseDatasetLoader dsl;

    /**
	 * The constructor <CODE>ExpParameterDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpParameterDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {
			
			dsl = new DatabaseDatasetLoader();

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(630, 405));

			createHead(pnlScreen, Globals.message.getMessage("msg0064"));

			control_column = 160;
			createLabel(pnlScreen, Globals.message.getMessage("msg0065"));
			modGoalMod = createTable("Goal", pnlScreen, null, 
					Globals.message.getMessage("msg0040"), control_column, 
					label_line, 440, (int) (pnl_height / 4.36)/*100*/, this.BUTTON_NO, 
					null, null);

			label_line += (int) (pnl_height / 4.36);//100;
			label_line -= (int) (pnl_height / 8.5);//30;
			createLabel(pnlScreen, Globals.message.getMessage("msg0066"));
			label_line += 30;
			Hashtable column_width = t4dialog.createColumnWidthTable("290,260");
			modContextMod = createTable("Attribute", pnlScreen, null, 
					Globals.message.getMessage("msg0040")
					+ "," + Globals.message.getMessage("msg0067"), label_column, 
					label_line, 580, (int) (pnl_height / 3)/*200*/, this.BUTTON_NO, 
					null, column_width);

			btnSave = createButton(pnlScreen, pnl_height, 100, pnl_width, 120,
	        		DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnSave.setEnabled(false);

			btnDelete = createButton(pnlScreen, pnl_height, 100, pnl_width, 80,
	        		DataSite.BUTTON_DELETE, Globals.message.getMessage("msg0009"));
			btnDelete.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnDelete_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnDelete.setEnabled(false);

			sclScreen = createScrollPane(pnlScreen, pnl_width - 60, pnl_height - 40);
			
		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {
		
    	int val = t4dialog.showDialog(Globals.message.getMessage("msg0075"));
    	if (val != 0) {
    		return;
    	}
    	
		if (!Globals.t4base.deleteAllAttributes(Globals.curr_project_uniqueid)) {
			return;
		}
    	
		Enumeration<String> keys = null;
		if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
			keys = Globals.t4ex.getContextList().keys();
		} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
			keys = Globals.t4exps.getContextList().keys();
		}
		while (keys.hasMoreElements()) {
			String att_id = keys.nextElement();
			
			DbAccessResultAtt ratt = new DbAccessResultAtt(Globals.sysUser, null, null, "idexpattribute;idproject", null);
			if (ratt.errCode != ratt.ERROR_0001 && ratt.errCode != ratt.ERROR_0002) {
				t4dialog.showException(ratt.errCode + "\r\n" + ratt.errMess);
			}
			
			ratt.setFieldAsString("idexpattribute", att_id);
			ratt.setFieldAsString("idproject", Globals.curr_project_uniqueid);
      		if (!ratt.putToSink(null)) {
   				t4dialog.showException(ratt.errCode + "\r\n" +ratt.errMess);
   				return;
      		}

			ArrayList values = null;
			if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
				values = (ArrayList) Globals.t4ex.getContextList().get(att_id);
			} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
				values = (ArrayList) Globals.t4exps.getContextList().get(att_id);
			}
			int len = values.size();
			for (int ndx=0;ndx<len;ndx++) {
				
				Context con = (Context) values.get(ndx);
				String value = con.value;
				
				DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, att_id, "codomain", null, null);
				if (att.errCode != 0) {
					t4dialog.showException(att.errCode + "\r\n" + att.errMess);
					return;
				}
				
				DbAccessResultValue rval = new DbAccessResultValue(Globals.sysUser, null, "all", "idresultatt", null);
				if (rval.errCode != rval.ERROR_0001 && rval.errCode != rval.ERROR_0002) {
					t4dialog.showException(rval.errCode + "\r\n" + rval.errMess);
				}
				
				rval.setValue(value);
				rval.setRuleno(con.rule);
				rval.setFieldAsString("idresultatt", ratt.getUniqueid());
	      		if (!rval.putToSink(null)) {
	   				t4dialog.showException(rval.errCode + "\r\n" + rval.errMess);
	   				return;
	      		}
			}
		}
		Globals.info_message.setText(Globals.message.getMessage("msg0077"));
	}
	
	/**
	 * The method <CODE>btnDelete_actionPerformed</CODE> action of the btnDelete.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnDelete_actionPerformed(ActionEvent e) throws Exception {
		
    	int val = t4dialog.showDialog(Globals.message.getMessage("msg0076"));
    	if (val != 0) {
    		return;
    	}

		if (!Globals.t4base.deleteAllAttributes(Globals.curr_project_uniqueid)) {
			return;
		}
    	
		Globals.info_message.setText(Globals.message.getMessage("msg0078"));
	}
	
	/**
	 * The method <CODE>callUseFromTable</CODE> performs the use button functionality, 
	 * if use button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callUseFromTable(String table_name) throws Exception {
		
		Globals.info_message.setText("");
    	
    	int select = modContextMod.getSelectedRow();
    	if (select > -1) {
//    		Globals.aar.epvds.value_ndx = (Integer) val_index.get(select);
    		fireSiteChangeEvent_1(modContextMod.getIndexKey());
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
    	
	}

	/**
	 * The method <CODE>callDeleteFromTable</CODE> performs the delete button functionality, 
	 * if delete button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callDeleteFromTable(String table_name) throws Exception {
		Globals.info_message.setText("");
    	int select = modContextMod.getSelectedRow();
    	if (select > -1) {
    		String att_uid = modContextMod.getIndexKey();
			ArrayList values = (ArrayList) Globals.t4ex.getContextList().get(att_uid);
			int len = values.size();
			if (len == 1) {
				Globals.t4ex.getContextList().remove(att_uid);
			} else {
				int ndx = (Integer) val_index.get(select);
				values.remove(ndx);
			}
			createCurrentData(null);
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
	}
	
	/**
	 * The method <CODE>enableButtons</CODE> enables the buttons.
	 * @exception Exception
	 * @since 1.0
	 */
	public void enableButtons() throws Exception {
		btnSave.setEnabled(true);
		btnDelete.setEnabled(true);
	}
	
	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();
    	
		// fill the table with the goal stack entries.
		modGoalMod.resetKeyList();
    	ArrayList goal = Globals.t4ex.getGoalStack();
    	int len = goal.size();
		for (int ndx=len-1;ndx>=0;ndx--) {
			
			String att_id = (String) goal.get(ndx);
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
					att_id, "name", null, null);
			if (att.errCode != 0) {
				t4dialog.showException(att.errCode + "\r\n" + att.errMess);
				return;
			}
			modGoalMod.addKey(att_id);
			Object[] row = new Object[3]; 
			row[0] = att.getName(); 
			row[1] = "";
			row[2] = "";
			modGoalMod.addRow(row);
		}

		// sort the attributes first.
		ArrayList to_sort = new ArrayList();
		modContextMod.resetKeyList();
		Enumeration keys = null;
		if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
			keys = Globals.t4ex.getContextList().keys();
		} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
			keys = Globals.t4exps.getContextList().keys();
		}
		while (keys != null && keys.hasMoreElements()) {
			String att_id = (String) keys.nextElement();
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
					att_id, "name", null, null);
			KeyElement ele = new KeyElement(att.getName(), att_id);
			to_sort.add(ele);
		}
		to_sort = Globals.t4a.sortArray(to_sort);

		val_index = new ArrayList();
		len = to_sort.size();
		for (int ndx=0;ndx<len;ndx++) {
			
			KeyElement ele = (KeyElement) to_sort.get(ndx);
			String att_id = ele.getValue();
			
			DbAccessReadExpAttribute att = new DbAccessReadExpAttribute(Globals.sysUser, 
					att_id, "name,codomain", null, null);
			if (att.errCode != 0) {
				t4dialog.showException(att.errCode + "\r\n" + att.errMess);
				return;
			}
			
			ArrayList values = null;
			if (Globals.curr_expsystem_type == Globals.DETERMINISTIC) {
				values = (ArrayList) Globals.t4ex.getContextList().get(att_id);
			} else if (Globals.curr_expsystem_type == Globals.STOCHASTIC) {
				values = (ArrayList) Globals.t4exps.getContextList().get(att_id);
			}
			int len2 = values.size();
			for (int ndx2=0;ndx2<len2;ndx2++) {
				val_index.add(ndx2);
				Context con = (Context) values.get(ndx2);
				String value = con.value;
				if (att.getCodomain().equals("-72c8c14d:13cbf89ea6b:-7ffc")
						&& Globals.curr_expsystem_type == Globals.DETERMINISTIC) { // set.
					DbAccessReadExpCodomain cod = new DbAccessReadExpCodomain(Globals.sysUser, 
							value, "text", null, null);
					if (cod.errCode != 0) {
						t4dialog.showException(cod.errCode + "\r\n" + cod.errMess);
						return;
					}
					value = cod.getText();
				}
				value += (con.rule>-1?" (" + con.rule + ")":"");
				modContextMod.addKey(att_id);
				Object[] row = new Object[4]; 
				row[0] = att.getName(); 
				row[1] = value;
				row[2] = "";
				row[3] = "";
				modContextMod.addRow(row);
			}
		}
	}
}

