package n4e.expertanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.*;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.expertanddecision.dbaccess.DbAccessExpSystem;
import n4e.expertanddecision.dbaccess.DbAccessReadExpSystem;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;
import n4e.expertanddecision.tool.Tool4Export;

/**
 * The <CODE>ExpSystemDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 11:11:36
 * @since 1.0
 */

public class ExpSystemDataSite extends DataSite {

    private AWTextField tfName;
	private JRadioButton rbDeterministic;
	private JRadioButton rbStochastic;
    private AWTextField tfResultNumber; 
    private JTextArea taDescription; 

    private JButton btnExport;
    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;

	/**
	 * The constructor <CODE>ExpSystemDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ExpSystemDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(600, 325));

			createHead(pnlScreen, Globals.message.getMessage("msg0036"));

			DbAccessReadExpSystem tab = new DbAccessReadExpSystem(Globals.sysUser);

            createLabel(pnlScreen, tab.getDefData("name", "label"));
            tfName = createTextField(pnlScreen);

            label_line += label_line_count;
            rbDeterministic = new JRadioButton(Globals.message.getMessage("msg0085"));
            rbDeterministic.setBounds(control_column, label_line, 200, 20);
            pnlScreen.add(rbDeterministic);

            label_line += label_line_count;
			rbStochastic = new JRadioButton(Globals.message.getMessage("msg0086"));
			rbStochastic.setBounds(control_column, label_line, 200, 20);
			pnlScreen.add(rbStochastic);
			
			ButtonGroup bg = new ButtonGroup();
			bg.add(rbDeterministic);
			bg.add(rbStochastic);

            createLabelMid(pnlScreen, tab.getDefData("resultnumber", "label"), 410);
            tfResultNumber = createTextField(pnlScreen, 530, 40);

            createLabel(pnlScreen, tab.getDefData("description", "label"));
			taDescription = createTextArea(pnlScreen, 390, 170, true, AWTextAreaPopUp.NONE);

		    sclScreen = createScrollPane(pnlScreen, pnl_width - 20, pnl_height - 50);

			btnExport = createButton(pnlScreen, 300, 450, 
					DataSite.BUTTON_EXPORT, Globals.message.getMessage("msg0068"));
			btnExport.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnExport_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnNew = createButton(pnlScreen, 300, 490, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, 300, 530,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, 300, 570,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>calcDimension</CODE> calculates the dimension of the controls.
	 * @param width the width of the panel.
	 * @param height the height of the panel.
	 * @since 1.0
	 */
	public void calcDimension(int width, int height) {
		sclScreen.setBounds(10, 10, width - 20, height - 50);
	}

	/**
	 * The method <CODE>btnExport_actionPerformed</CODE> action of the btnExport.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnExport_actionPerformed(ActionEvent e) throws Exception {
    	int val = t4dialog.showDialog(Globals.message.getMessage("msg0070"));
    	if (val == 0) {
        	DbAccessReadExpSystem exp = new DbAccessReadExpSystem(Globals.sysUser, Globals.curr_expsystem_uniqueid_2, "name", null, null);
        	if (exp.errCode != 0) {
    			t4dialog.showException(exp.errCode + "\r\n" + exp.errMess);
    			return;
        	}
        	String file_name = Globals.t4s.replaceToken(exp.getName(), " ", "");
        	file_name = Globals.t4s.replaceToken(file_name, ",", "");
        	file_name = Globals.t4s.replaceToken(file_name, ":", "");
        	file_name = Globals.t4s.replaceToken(file_name, "'", "");
        	file_name = Globals.t4s.replaceToken(file_name, ".", "");
        	file_name += ".xml"; 
			Tool4Export t4e = new Tool4Export();
			String content = t4e.createXMLContent(Globals.curr_expsystem_uniqueid_2);
			Globals.t4f.putTheFile(Globals.t4f.getFullPathToSystem("data"), file_name, content);
	   		Globals.info_message.setText(Globals.message.getMessage("msg0072"));
    	}		
	}
	
	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessExpSystem tab = new DbAccessExpSystem(Globals.sysUser, curr_uniqueid,
				"all", null, null);

		if (tab.errCode == 0 || tab.errCode == tab.ERROR_0001) {

			tab.errCode = 0;
            tab.setName(tfName.getText());
            if (rbDeterministic.isSelected()) {
            	tab.setType(1);
            } else if (rbStochastic.isSelected()) {
            	tab.setType(2);
            }
            tab.setDescription(taDescription.getText());
            tab.setFieldAsString("resultnumber", tfResultNumber.getText());

            if (tab.errCode != 0) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			} else if (!tab.putToSink(null)) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			}

			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			if (curr_uniqueid == null) {
				Globals.curr_expsystem_uniqueid_2 = tab.getUniqueid();
        		Globals.ead.rls.createCurrentData(null);
        		Globals.ead.als.createCurrentData(null);
        		Globals.ead.rls.enableButtons(true);
        		Globals.ead.als.enableButtons(true);
			}
			curr_uniqueid = tab.getUniqueid();
			createCurrentData(curr_uniqueid);

		} else {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
		}
	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_1(curr_uniqueid);
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
        tfName.setText("");
        rbDeterministic.setSelected(true);
	    taDescription.setText("");
        tfResultNumber.setText("0");
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;

	    DbAccessReadExpSystem tab = new DbAccessReadExpSystem(Globals.sysUser,
				uniqueid, "all", null, null);
		if (tab.errCode != 0) {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
			return;
		}

        tfName.setText(tab.getName());
        if (tab.getType() == 1) { // deterministic
            rbDeterministic.setSelected(true);
            tfResultNumber.setText("0");
        } else if (tab.getType() == 2) { // stochastic
            rbStochastic.setSelected(true);
            tfResultNumber.setText(tab.getFieldAsString("resultnumber"));
        }
        taDescription.setText(tab.getDescription());

	}
}
