package n4e.expertanddecision.screen;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import n4e.core.screen.DataSite;
import n4e.core.tool.Tool4Throwable;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>InfoBarDataSite</CODE> class shows the system messages.
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: shows the system messages.</P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 16.10.2014 15:32:41
 * @since 1.0
 */

public class InfoBarDataSite extends DataSite {

	/**
	 * The constructor <CODE>InfoBarDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public InfoBarDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {
			
			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(300, 50));
	        message = createMessage(pnlScreen);

			message.setBounds(20, 5, pnl_width, 20);
			
			sclScreen = new JScrollPane(pnlScreen, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
	    			JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			sclScreen.setViewportView(pnlScreen);
			sclScreen.setBounds(0, 0, pnl_width, pnl_height);
			sclScreen.setBackground(Color.WHITE);

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>setText</CODE> sets the message text.
	 * @param text the text.
	 * @since 1.0
	 */
	public void setText(String text) {
		message.setText(text);
	}

}

