package n4e.expertanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.*;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.expertanddecision.dbaccess.DbAccessProject;
import n4e.expertanddecision.dbaccess.DbAccessReadProject;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>ProjectDataSite</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 11:11:36
 * @since 1.0
 */

public class ProjectDataSite extends DataSite {

    private AWTextField tfName;
    private AWTextField tfDate;
    private AWCombo cbxExpertsystem;
    private JTextArea taRemarks; 

    private JButton btnDate;
    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;

	/**
	 * The constructor <CODE>ProjectDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ProjectDataSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;

			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(600, 324));

			createHead(pnlScreen, Globals.message.getMessage("msg0073"));

			DbAccessReadProject tab = new DbAccessReadProject(Globals.sysUser);

            createLabel(pnlScreen, tab.getDefData("name", "label"));
            tfName = createTextField(pnlScreen);

            createLabel(pnlScreen, tab.getDefData("projdate", "label"));
            tfDate = createTextField(pnlScreen);

			btnDate = createButton(pnlScreen, label_line, 410, 
					DataSite.BUTTON_TIME, Globals.message.getMessage("msg0049"));
			btnDate.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnDate_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createLabel(pnlScreen, Globals.message.getMessage("msg0036"));
			cbxExpertsystem = createCombo(pnlScreen);

			createLabel(pnlScreen, tab.getDefData("remarks", "label"));
			taRemarks = createTextArea(pnlScreen, 390, 150, true, AWTextAreaPopUp.NONE);

		    sclScreen = createScrollPane(pnlScreen, pnl_width - 20, pnl_height - 50);

			btnNew = createButton(pnlScreen, 300, 490, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, 300, 530,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, 300, 570,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>calcDimension</CODE> calculates the dimension of the controls.
	 * @param width the width of the panel.
	 * @param height the height of the panel.
	 * @since 1.0
	 */
	public void calcDimension(int width, int height) {
		sclScreen.setBounds(10, 10, width - 20, height - 50);
	}

	/**
	 * The method <CODE>btnDate_actionPerformed</CODE> action of the btnDate.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnDate_actionPerformed(ActionEvent e) throws Exception {
		DatePicker dp = new DatePicker(Globals.ead, this);
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessProject tab = new DbAccessProject(Globals.sysUser, curr_uniqueid,
				"all", "idexpsystem", null);

		if (tab.errCode == 0 || tab.errCode == tab.ERROR_0001 || tab.errCode == tab.ERROR_0002) {

			tab.errCode = 0;
            tab.setFieldAsString("name", tfName.getText());
            tab.setFieldAsString("projdate", tfDate.getText());
            tab.setFieldAsString("remarks", taRemarks.getText());
            tab.setFieldAsString("idexpsystem", cbxExpertsystem.getIndexKey());

            if (tab.errCode != 0) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			} else if (!tab.putToSink(null)) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			}

			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			curr_uniqueid = tab.getUniqueid();
			createCurrentData(curr_uniqueid);

		} else {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
		}
	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_1(curr_uniqueid);
	}

	/**
	 * The method <CODE>setGetData</CODE> adds a new contact item.
	 * @param uniqueid the key of the new item.
	 * @exception Exception
	 * @since 1.0
	 */
	public void setGetData(String uniqueid) throws Exception {
		tfDate.setText(uniqueid);
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
        tfName.setText("");
	    tfDate.setText(Globals.t4d.getDate2String(new Date(), SystemService.getDateDef()));
		Globals.t4md.fillComboExp(cbxExpertsystem, null);
	    taRemarks.setText("");
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;

	    DbAccessReadProject tab = new DbAccessReadProject(Globals.sysUser,
				uniqueid, "all", "idexpsystem", null);
		if (tab.errCode != 0) {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
			return;
		}

        tfName.setText(tab.getName());
        tfDate.setText(tab.getFieldAsString("projdate"));
		if (tab.getMyDbAccessReadExpSystem() != null) {
			Globals.t4md.fillComboExp(cbxExpertsystem, tab.getMyDbAccessReadExpSystem().getUniqueid());
		} else {
			Globals.t4md.fillComboExp(cbxExpertsystem, null);
		}
        taRemarks.setText(tab.getRemarks());

	}
}
