package n4e.expertanddecision.screen;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JLabel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import n4e.core.controls.AWButton;
import n4e.core.controls.AWTableModel;
import n4e.core.database.DatabaseDatasetLoader;
import n4e.core.screen.DataSite;
import n4e.core.system.GlobalsDialog;
import n4e.core.tool.Tool4Throwable;
import n4e.expertanddecision.dbaccess.DbAccessProject;
import n4e.expertanddecision.dbaccess.DbAccessReadExpSystem;
import n4e.expertanddecision.dbaccess.DbAccessReadProject;
import n4e.expertanddecision.dbaccess.DbAccessResultAtt;
import n4e.expertanddecision.dbaccess.DbAccessResultValue;
import n4e.expertanddecision.system.ExpertAndDecision;
import n4e.expertanddecision.system.Globals;

/**
 * The <CODE>ProjectListSite</CODE> class ...
 * <P><B>title: ExpertAndDecision</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2015 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 28.04.2015 09:51:26
 * @since 1.0
 */

public class ProjectListSite extends DataSite {

    private AWTableModel modProjectMod;
    private JLabel lblTableRows;

    private AWButton btnNew;

    private String index_uniqueid;
    private int pnl_width; // width of the calling frame.
    private int pnl_height; // height of the calling frame.

    /**
	 * The constructor <CODE>ProjectListSite</CODE> creates a new instance(object) of the class.
	 * @param
	 * @exception
	 * @see package.class#member label
	 * @since 1.0
	 */
	public ProjectListSite(ExpertAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {
			
			label_hight = Globals.label_hight;
			label_width = Globals.label_width;
			control_hight = Globals.control_hight;
			control_width = Globals.control_width;
			this.pnl_width = pnl_width;
			this.pnl_height = pnl_height;

			pnlScreen = createPanel(pnl_width - 25, pnl_height - 45);
			createHead(pnlScreen, Globals.message.getMessage("msg0048"));

			// calculate the width of the table columns.
			int fac = 150/2; // action columns.
			int[] column_len = new int[2];
            column_len[0] = (int) (pnl_width * (170.0 / 640.0)) - fac;
            column_len[1] = (int) (pnl_width * (400.0 / 640.0)) - fac;
			Hashtable column_width = t4dialog.createColumnWidthTable(column_len);

			modProjectMod = createTable("Project", pnlScreen,
					new DbAccessReadProject(Globals.sysUser),
					"projdate,name", 20, 40,
					pnl_width, 70, pnl_height, 120, this.BUTTON_USE_AND_DELETE,
					null, column_width, null, Globals.fontStandard12);

			modProjectMod.getTable().getSelectionModel().addListSelectionListener(new ListSelectionListener() {
	            public void valueChanged(ListSelectionEvent e) {
	            	try {
	                	int select = modProjectMod.getSelectedRow();
	                	if (select > -1) {
	                		DbAccessReadProject proj = new DbAccessReadProject(Globals.sysUser, 
	                				modProjectMod.getIndexKey(), "name", "idexpsystem", null);
                			Globals.ead.setTitle(GlobalsDialog.program_name + " [" + proj.getName() + "]");
	                		if (proj.getMyDbAccessReadExpSystem() != null) {
	                			Globals.curr_project_uniqueid = modProjectMod.getIndexKey();
	                			Globals.curr_expsystem_uniqueid_1 = proj.getMyDbAccessReadExpSystem().getUniqueid();
	                			Globals.curr_expsystem_type = proj.getMyDbAccessReadExpSystem().getType();
	                			Globals.ead.eads.enableButtons();
	                			Globals.ead.eads.createCurrentData(proj.getMyDbAccessReadExpSystem().getUniqueid());
	                			Globals.ead.pads.enableButtons();
	                		}
 	                	}
	        		} catch (Exception ex) {
	        			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
	        		}
	                
	            }
	        });


			lblTableRows = new JLabel("");
			lblTableRows.setFont(Globals.fontStandard12);
			lblTableRows.setBounds(20, pnl_height - 70, 100, label_hight);
			pnlScreen.add(lblTableRows);

			btnNew = createButton(pnlScreen, pnl_height, 70, pnl_width, 80,
	        		DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createCurrentData(null);

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>calcDimension</CODE> calculates the dimension of the controls.
	 * @param width the width of the panel.
	 * @param height the height of the panel.
	 * @since 1.0
	 */
	public void calcDimension(int width, int height) {
		super.calcDimension(width, height);
		pnlScreen.setBounds(10, 10, width - 25, height - 45);
		btnNew.calcDimension(width, height);
		lblTableRows.setBounds(20, height - 70, 100, label_hight);
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
		fireSiteChangeEvent_1(null);
	}

	/**
	 * The method <CODE>callUseFromTable</CODE> performs the use button functionality,
	 * if use button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callUseFromTable(String table_name) throws Exception {

		Globals.info_message.setText("");

    	int select = modProjectMod.getSelectedRow();
    	if (select > -1) {
    		fireSiteChangeEvent_1(modProjectMod.getIndexKey());
    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
	}

	/**
	 * The method <CODE>callDeleteFromTable</CODE> performs the delete button functionality,
	 * if delete button in table is pressed.
	 * @param table_name the name of the belonging table.
	 * @exception Exception
	 * @since 1.0
	 */
	public void callDeleteFromTable(String table_name) throws Exception {

    	int select = modProjectMod.getSelectedRow();
    	if (select > -1) {
    		
    		// delete the concerning result attributes.
    		if (!Globals.t4base.deleteAllAttributes(modProjectMod.getIndexKey())) {
    			return;
    		}
    		
    		// read the audit.
    		DbAccessProject tab = new DbAccessProject(Globals.sysUser,
    				modProjectMod.getIndexKey(), null, null, null);

    		if (tab.errCode == 0) {
    			if (!tab.deleteInSink(null)) {
    				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
    				return;
    			}
    			Globals.info_message.setText(Globals.message.getMessage("msg0029"));
				createCurrentData(null);
    		} else {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
    		}

    	} else {
    		Globals.info_message.setText(Globals.message.getMessage("msg0021"));
    	}
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

		index_uniqueid = uniqueid;

		DatabaseDatasetLoader dsl = new DatabaseDatasetLoader();
		ArrayList tabs = dsl.getDataSetRead(Globals.sysUser, "Project",
				"projdate,name", null, null, null,
				"projdate DESC", "expertanddecision");

		modProjectMod.resetKeyList();

    	int len = tabs.size();
    	for (int ndx=0; ndx<len;ndx++) {
    		DbAccessReadProject tab = (DbAccessReadProject) tabs.get(ndx);
       		if (tab.errCode == 0) {
    			modProjectMod.addKey(tab.getUniqueid());

    			Object[] row = new Object[4];
                row[0] = tab.getFieldAsString("projdate");
                row[1] = tab.getFieldAsString("name");
                row[2] = "";
                row[3] = "";
    			modProjectMod.addRow(row);
    		}
    	}
    	lblTableRows.setText(Globals.message.getMessage("msg0031") + modProjectMod.getRowCount());
	}

}

