package n4e.expertanddecision.system;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.StringTokenizer;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import n4e.core.controls.AWTableCellRenderer;
import n4e.core.controls.AWTableModel;
import n4e.core.database.DatabaseDatasetLoader;
import n4e.core.database.DatabaseSQLResultSet;
import n4e.core.database.DbAccessRead;
import n4e.core.list.List4SysUser;
import n4e.core.screen.DataSite;
import n4e.core.system.GlobalsDialog;
import n4e.core.tool.Tool4Dialog;
import n4e.core.tool.Tool4ExpertSystem;
import n4e.core.tool.Tool4String;
import n4e.core.tool.Tool4Throwable;
import n4e.expertanddecision.dbaccess.DbAccessExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpAttribute;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCodomain;
import n4e.expertanddecision.dbaccess.DbAccessReadExpCondition;
import n4e.expertanddecision.dbaccess.DbAccessReadExpRule;
import n4e.expertanddecision.tool.Tool4Database;

/**
 * The <CODE>RuleHelp</CODE> class ...
 * <P><B>title: AuditAndReport</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 15.10.2014 18:47:46
 * @since 1.0
 */

public class RuleHelp extends JDialog implements ActionListener {

	public static final int BUTTON_CHOOSE = 16; // label for choose button.
	public static final int BUTTON_USE = 0; // layout type for the use button.
	public static final int BUTTON_USE_AND_DELETE = 9; // label for use and/or delete button.
	public static final int BUTTON_USE_LIST_AND_DELETE = 25; // label for use, list and delete button.
	public static final int BUTTON_DELETE = 1; // layout type for the delete button.
	public static final int BUTTON_NO = 18; // label for photo button.

	private JLabel lblRule;
    public AWTableModel modRuleData; 
    private AWTableModel modRuleNoData; 
	private JLabel lblResult;

    private JButton btnClose; // button: close window.

    public JScrollPane tableScrollPane; // the table scroll pane.

    public int label_column = 20;
	public int label_line = -10;
	public int label_line_count = 30;
	public int label_hight = 26;
	public int label_width = 400;

	public int control_column = 100;
	public int control_hight = 26;
	public int control_width = 400;

	public boolean set_horizontal_scrollbar = false; // label for the horizontal scroll bar in a table model.

    private List4SysUser sysUser;
    private ArrayList messages;
    private String database;

    private Tool4Dialog t4dialog; 
	private Tool4ExpertSystem expsys;
	private Tool4String t4s;
    private Tool4Database t4db;
    
    private DataSite site;
    private DatabaseDatasetLoader dsl;


    /**
	 * The constructor <CODE>RuleHelp</CODE> creates a new instance(object) of the class.
	 * @param g4w the calling system.
	 * @param rule_uid the uniqueid of the rule.
	 * @since 1.0
	 */
	public RuleHelp(JFrame exp, DataSite site, String rule_uid, long ruleid, String headline,
			Tool4ExpertSystem expsys, ArrayList messages, List4SysUser sysUser,
			String database) {
        super(exp, headline);

        try {
        	
        	this.site = site;
        	dsl = new DatabaseDatasetLoader();
	        this.sysUser = sysUser;
	        this.messages = messages;
	        this.database = database;
        	
	        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	        this.setBackground(Color.lightGray);
	        this.setSize(new Dimension(700, 500));
	
	        Font fontStandard = new Font("Dialog", Font.PLAIN, 12);
	        setFont(fontStandard);
	
	        t4dialog = new Tool4Dialog(null);
			this.expsys = expsys;
			t4s = new Tool4String();
	        t4db = new Tool4Database();
	
	        Container c = getContentPane();
	        c.setLayout(null);
	        c.setSize(new Dimension(700, 500));

	        createLabel(c, (String) messages.get(0));
	        label_line += label_line_count;
	        lblRule = createLabelField(c, label_column, 600, false);
	        lblRule.setForeground(Color.BLUE);

	        createLabel(c, (String) messages.get(1));
	        
	        label_line += label_line_count;
	        ArrayList field_list = new ArrayList();
	        field_list.add((String) messages.get(2));
	        modRuleData = createTable("RuleData", c, null, 
	    			field_list, 10, label_line, 660, 100, 
	    			BUTTON_NO, null, null, null, null);
	        
	        label_line += 80;
	        createLabel(c, (String) messages.get(3));
	        
	        label_line += label_line_count;
	        modRuleNoData = createTable("RuleNoData", c, null, 
	    			field_list, 10, label_line, 660, 100, 
	    			BUTTON_NO, null, null, null, null);

	        label_line += 80;
	        createLabel(c, (String) messages.get(4));
	        label_line += label_line_count;
	        lblResult = createLabelField(c, label_column, 600, false);

            btnClose = new JButton("close");
            btnClose.setBounds(600, 430, 72, 20);
            btnClose.setFont(new Font("Dialog", Font.PLAIN, 12));
            btnClose.addActionListener(this);
            c.add(btnClose);

	        center();
	        showRule(rule_uid, ruleid);
	        setVisible(true);

        } catch (Exception ex) {
        	t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
        }
	}

    /**
     * The method <CODE>showRule</CODE> shows the knowledge status of a rule.
     * The place holders have the following meaning:
     * @value1@ ein / kein if boolean.
     * @value2@ .. / nicht if boolean.
     * @value3@ .. / keine if boolean.
     * @value4@ the value of the attribute.
     * @param rule_uid the uniqueid of a rule.
     * @param ruleid the number of a rule.
     * @since 1.0
     */
	private void showRule(String rule_uid, long ruleid) throws Exception {

		// get the rule data.
		DbAccessReadExpRule rule = null;
		if (rule_uid == null) {
			rule = new DbAccessReadExpRule(sysUser, null, 
					"ruleid,description", null, null, "ruleid=" + ruleid);
			rule_uid = rule.getUniqueid();
		} else {
			rule = new DbAccessReadExpRule(sysUser, rule_uid, 
					"ruleid,description", null, null);
		}
		if (rule.errCode != 0) {
			t4dialog.showException(rule.errCode + "\r\n" + rule.errMess);
			return;
		}

		String description = rule.getDescription();
		lblRule.setText("(" + rule.getRuleid() + ") " + description);
		
		// get the condition data.
		ArrayList cons = dsl.getDataSetRead(sysUser, "ExpCondition", 
				"condition,operator,operand", "idexpattribute(name,codomain,adddata)", 
				null, "idexprule='" + rule_uid + "'", 
				"sort", database);

		// we already know.
		modRuleData.resetKeyList();
    	int len = cons.size();
    	boolean knowledge_available = false;
    	for (int ndx=0; ndx<len;ndx++) {
    		DbAccessReadExpCondition con = (DbAccessReadExpCondition) cons.get(ndx);
    		if (con.errCode == 0) {
    			if (con.getCondition().equals("-72c8c14d:13cbf89ea6b:-7ff5") 
    					|| con.getCondition().equals("12c5e122:13cf85acfca:-8000") // THEN, ELSE
  					    || con.getCondition().equals("-7809eaa8:159267fd635:-7fe7")) { // OR
    				continue;
    			}
    			if (expsys.getContextListValue(con.getMyDbAccessReadExpAttribute().getUniqueid()) == null) {
    				continue;
    			}
    			knowledge_available = true;
    			modRuleData.addKey(con.getUniqueid());
    			Object[] row = new Object[2];
    			description = con.getMyDbAccessReadExpAttribute().getAdddata();
    			String condition = description;
    			String value = expsys.getContextListFirstValue(con.getMyDbAccessReadExpAttribute().getUniqueid());
    			String codomain = con.getMyDbAccessReadExpAttribute().getCodomain();
    			if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set
    				DbAccessReadExpCodomain cod = new DbAccessReadExpCodomain(Globals.sysUser, value, "text", null, null);
    				value = cod.getText();
    			}
    			if (GlobalsDialog.language_code.equals("de")) {
	    			if (value.equals("true")) {
	        			condition = t4s.replaceString(condition, "@value1@", "ein");
	        			condition = t4s.replaceString(condition, "@value2@", "eine");
	        			condition = t4s.replaceString(condition, "@value3@", "");
	        			condition = t4s.replaceString(condition, "@value5@", "einen");
	    			} else if (value.equals("false")) {
	        			condition = t4s.replaceString(condition, "@value1@", "kein");
	        			condition = t4s.replaceString(condition, "@value2@", "keine");
	        			condition = t4s.replaceString(condition, "@value3@", "nicht");
	        			condition = t4s.replaceString(condition, "@value5@", "keinen");
	    			} else {
	        			condition = t4s.replaceString(condition, "@value4@", value);
	    			}
    			} else if (GlobalsDialog.language_code.equals("en")) {
	    			if (value.equals("true")) {
	        			condition = t4s.replaceString(condition, "@value1@", "");
	        			condition = t4s.replaceString(condition, "@value2@", "");
	        			condition = t4s.replaceString(condition, "@value3@", "");
	        			condition = t4s.replaceString(condition, "@value5@", "");
	    			} else if (value.equals("false")) {
	        			condition = t4s.replaceString(condition, "@value1@", "no");
	        			condition = t4s.replaceString(condition, "@value2@", "no");
	        			condition = t4s.replaceString(condition, "@value3@", "not");
	        			condition = t4s.replaceString(condition, "@value5@", "no");
	    			} else {
	        			condition = t4s.replaceString(condition, "@value4@", value);
	    			}
    			}
    			condition = t4s.replaceSQLWithChars(condition);
    			row[0] = condition;
    			row[1] = "";
    			modRuleData.addRow(row);
    		}
    	}
    	if (!knowledge_available) {
			Object[] row = new Object[1];
			row[0] = Globals.message.getMessage("msg0063");
			modRuleData.addRow(row);
    	}
		
		// if we show.
		modRuleNoData.resetKeyList();
    	for (int ndx=0; ndx<len;ndx++) {
    		DbAccessReadExpCondition con = (DbAccessReadExpCondition) cons.get(ndx) ;
    		if (con.errCode == 0) {
    			if (con.getCondition().equals("-72c8c14d:13cbf89ea6b:-7ff5") 
    					|| con.getCondition().equals("12c5e122:13cf85acfca:-8000")) { // THEN, ELSE
    				continue;
    			}
    			if (expsys.getContextListValue(con.getMyDbAccessReadExpAttribute().getUniqueid()) != null) {
    				continue;
    			}
    			modRuleNoData.addKey(con.getUniqueid());
    			Object[] row = new Object[1];
    			description = con.getMyDbAccessReadExpAttribute().getAdddata();
    			String condition = description;
    			String operator = getKeyWordNameByUid(con.getOperator());
    			String value = con.getOperand();
    			String codomain = con.getMyDbAccessReadExpAttribute().getCodomain();
    			if (codomain.equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // set
    				DbAccessReadExpCodomain cod = new DbAccessReadExpCodomain(Globals.sysUser, value, "text", null, null);
    				value = cod.getText();
    				operator = null;
    			}
    			if (GlobalsDialog.language_code.equals("de")) {
	    			if (value.equals("true")) {
	        			condition = t4s.replaceString(condition, "@value1@", "ein");
	        			condition = t4s.replaceString(condition, "@value2@", "eine");
	        			condition = t4s.replaceString(condition, "@value3@", "");
	        			condition = t4s.replaceString(condition, "@value5@", "einen");
	    			} else if (value.equals("false")) {
	        			condition = t4s.replaceString(condition, "@value1@", "kein");
	        			condition = t4s.replaceString(condition, "@value2@", "keine");
	        			condition = t4s.replaceString(condition, "@value3@", "nicht");
	        			condition = t4s.replaceString(condition, "@value5@", "keinen");
					} else {
		    			condition = t4s.replaceString(condition, "@value4@", operator==null?value:operator + " " + value);
					}
    			} else if (GlobalsDialog.language_code.equals("en")) {
	    			if (value.equals("true")) {
	        			condition = t4s.replaceString(condition, "@value1@", "");
	        			condition = t4s.replaceString(condition, "@value2@", "");
	        			condition = t4s.replaceString(condition, "@value3@", "");
	        			condition = t4s.replaceString(condition, "@value5@", "");
	    			} else if (value.equals("false")) {
	        			condition = t4s.replaceString(condition, "@value1@", "no");
	        			condition = t4s.replaceString(condition, "@value2@", "no");
	        			condition = t4s.replaceString(condition, "@value3@", "not");
	        			condition = t4s.replaceString(condition, "@value5@", "no");
					} else {
		    			condition = t4s.replaceString(condition, "@value4@", operator==null?value:operator + " " + value);
					}
    			}
    			condition = t4s.replaceSQLWithChars(condition);
    			row[0] = condition;
    			modRuleNoData.addRow(row);
    		}
    	}

    	String result = "";
    	for (int ndx=0; ndx<len;ndx++) {
    		DbAccessReadExpCondition con = (DbAccessReadExpCondition) cons.get(ndx) ;
    		if (con.errCode == 0) {
    			if (con.getCondition().equals("-72c8c14d:13cbf89ea6b:-7ff5")) { // THEN
    				result += con.getMyDbAccessReadExpAttribute().getName();
    				result += " " + getKeyWordNameByUid(con.getOperator());
    				if (con.getMyDbAccessReadExpAttribute().getCodomain().equals("-72c8c14d:13cbf89ea6b:-7ffc")) { // Set.
    					DbAccessExpCodomain cod = new DbAccessExpCodomain(Globals.sysUser, con.getOperand(), "text", null, null);
	    				result += cod.getText();
    				} else {
	    				result += " " + con.getOperand();
    				}
    			}
    			if (con.getCondition().equals("12c5e122:13cf85acfca:-8000")) { // ELSE
    				result += (String) messages.get(5) + con.getMyDbAccessReadExpAttribute().getName();
    				result += " " + getKeyWordNameByUid(con.getOperator());
    				result += " " + con.getOperand();
    			}
    		}
    	}
		lblResult.setText(result);
	}
	
    /**
     * The method <CODE>center</CODE> centers the main window.
     * @since 1.0
     */
    private void center() {
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((dim.width - getWidth()) / 2, (dim.height - getHeight()) / 2);
    }

    /**
     * The method <CODE>actionPerformed</CODE> processes the button clicks.
     * @param e the event.
     * @since 1.0
     */
	public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btnClose) {
            dispose();
        }
	}

	/**
	 * The method <CODE>createLabel</CODE> creates a label object.
	 * @param pnl the current panel object.
	 * @param text the label text.
	 * @return the new label.
	 * @since 1.0
	 */
	public JLabel createLabel(Container pnl, String text) {
		JLabel label = new JLabel(text);
        label_line += label_line_count;
        label.setFont(GlobalsDialog.fontStandardBig);
        label.setBounds(label_column, label_line, label_width, label_hight);
        pnl.add(label);
        return label;
	}

	/**
	 * The method <CODE>createLabelField</CODE> creates a label object as a data field.
	 * @param pnl the current panel object.
	 * @param column the site column, if 0 then take the control_column data field.
	 * @param width the width of the label field.
	 * @param numeric if true, set alignment to right.
	 * @return the new label.
	 * @since 1.0
	 */
	public JLabel createLabelField(Container pnl, int column, int width, boolean numeric) {
		JLabel label = new JLabel("");
        label.setFont(GlobalsDialog.fontStandardBig);
        if (column == 0) {
        	column = control_column;
        }
        if (width == 0) {
        	width = control_width;
        }
        label.setBounds(column, label_line, width, control_hight);
        if (numeric) {
        	label.setHorizontalAlignment(JLabel.RIGHT);
        }
        pnl.add(label);
        return label;
	}

	/**
	 * The method <CODE>createTable</CODE> creates a table object.
	 * @param name the name of the table.
	 * @param pnl the current panel object.
	 * @param data_list list with the the current database access object.
	 * @param field_list the field list for the columns.
	 * @Param column the column of the table.
	 * @Param row the row of the table.
	 * @Param width the width of the table.
	 * @Param height the height of the table.
	 * @param work_delete, if true work and delete buttons are added.
	 * @param flag to identify the model.
	 * @param flag2 to identify the model.
	 * @param status the status of the table cells.
	 * @param column_width the width of a column.
	 * @return a AWTableModel object.
	 * @since 1.0
	 */
	public AWTableModel createTable(String name, Container pnl, ArrayList data_list, 
			ArrayList field_list, int column, int row, int width, int height, 
			int work_delete, String flag, String flag2, Hashtable status, 
			Hashtable column_width) throws Exception {
		
		if (data_list == null && field_list == null) {
			throw new Exception("no valide data available.");
		}
		
		if (data_list != null && data_list.size() != field_list.size()) {
			throw new Exception("not same number of data rows available.");
		}
		
		// check, if fields of table definitions are to use 
		// or the original transferred column names.
		boolean work_with_table_fields = true;
		if (data_list == null && field_list != null) {
			work_with_table_fields = false;
		}
		
		JTable table = new JTable();
        table.setRowHeight(control_hight);
        table.setBorder(BorderFactory.createEtchedBorder());
        table.setGridColor(Color.black);
        table.setFont(GlobalsDialog.fontStandardBig);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        table.setName(name);     
        table.setBackground(Color.lightGray);

        // set orientation of the table columns.
        table.setDefaultRenderer(Object.class, new AWTableCellRenderer(table, status, name));
        
		// add the table columns.
		if (column_width == null) {
			column_width = new Hashtable();
		}
        
        AWTableModel model = new AWTableModel(table, site);
        table.setModel(model);

        int column_count = 0;
        int data_len = field_list.size();
        
        for (int ndx=0;ndx<data_len;ndx++) {
        	DbAccessRead data = null;
        	if (work_with_table_fields) {
        		data = (DbAccessRead) data_list.get(ndx);
        	}
        	String fields = (String) field_list.get(ndx);
	        StringTokenizer st = new StringTokenizer(fields, ",");
	        while(st.hasMoreTokens()) {
	        	if (work_with_table_fields) {
	        		if (data != null) {
	        			String column_header = data.getDefData(st.nextToken(), "label");
	        			if (column_header != null && column_header.trim().length() > 0) {
		        			model.addColumn(column_header);
	        			} else {
		        			model.addColumn("---");
	        			}
	        		} else {
	        			model.addColumn(st.nextToken());
	        		}
	        	} else {
	        		model.addColumn(st.nextToken());
	        	}
	            column_count++;
	        }
        }

        // create the button columns.
        if (work_delete == BUTTON_CHOOSE) {
        	model.addColumn(GlobalsDialog.message.getMessage("msg0010")); // choose.
            column_width.put(new Integer(column_count), new Integer(70));
            column_count++;
        }
        if (work_delete == BUTTON_USE || work_delete == BUTTON_USE_AND_DELETE 
        		|| work_delete == BUTTON_USE_LIST_AND_DELETE) {
        	model.addColumn(GlobalsDialog.message.getMessage("msg0019")); // work with.
            column_width.put(new Integer(column_count), new Integer(70));
            column_count++;
        }
        if (work_delete == BUTTON_USE_LIST_AND_DELETE) {
        	model.addColumn(GlobalsDialog.message.getMessage("msg0020")); // list.
            column_width.put(new Integer(column_count), new Integer(50));
            column_count++;
        }
        if (work_delete == BUTTON_DELETE || work_delete == BUTTON_USE_AND_DELETE 
        		|| work_delete == BUTTON_USE_LIST_AND_DELETE) {
        	model.addColumn(GlobalsDialog.message.getMessage("msg0018")); // delete.
            column_width.put(new Integer(column_count), new Integer(50));
            column_count++;
        }

        // sets the defined column width.
        for (int ndx=0;ndx<column_count;ndx++) {
        	Integer column_width_ndx = new Integer(ndx);
        	if (column_width.containsKey(column_width_ndx)) {
        		int curr_column_width = ((Integer) column_width.get(column_width_ndx)).intValue();
				table.getColumnModel().getColumn(ndx).setMinWidth(curr_column_width);
        		table.getColumnModel().getColumn(ndx).setMaxWidth(curr_column_width);
        	}
        }
        
        switch (work_delete) {
        	case BUTTON_USE:
    	        model.setUseButton(flag, flag2);
    	        break;
        	case BUTTON_DELETE:
    	        model.setDeleteButton(flag, flag2);
    	        break;
        	case BUTTON_USE_LIST_AND_DELETE:
    	        model.setUseButton(flag, flag2);
    	        model.setListButton();
    	        model.setDeleteButton(flag, flag2);
    	        break;
        	case BUTTON_USE_AND_DELETE:
    	        model.setUseButton(flag, flag2);
    	        model.setDeleteButton(flag, flag2);
    	        break;
        	case BUTTON_CHOOSE:
    	        model.setChooseButton();
    	        break;
        }
        
        tableScrollPane = null;
        if (set_horizontal_scrollbar) {
            table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            tableScrollPane = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
        			JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        } else {
        	tableScrollPane = new JScrollPane(table);
        }
        tableScrollPane.setViewportView(table);
        tableScrollPane.setBounds(column, row, width, height);
        pnl.add(tableScrollPane);
        
        return model;
	}

    /**
     * The method <CODE>getKeyWordNameByUid</CODE> fetches the name of key word from database.
     * Be aware of that this function is redundant to the web system.
     * @param key_uid the uniqueid of the keyword.
     * @return the name.
     * @exception Exception.
     * @since 1.0
     */
    public String getKeyWordNameByUid(String key_uid) throws Exception {
    	String name = "";
    	DatabaseSQLResultSet dbRes = new DatabaseSQLResultSet(sysUser.getClientDbsystemforeclient() , null);
        String query = "SELECT name FROM KeyWord WHERE uniqueid='" + key_uid + "'";
        ResultSet resultset = dbRes.getResultSet(query);
        if (resultset.next()) {
            name = resultset.getString(1);
        }
        dbRes.closeResultSet();
        resultset.close();
        return name;
    }
}

