package n4e.expertanddecision.tool;

import n4e.core.list.List4SysUser;
import n4e.core.tool.Tool4DbMessages;

/**
 * The <CODE>Tool4EADMessage</CODE> class  provides messages for the application.
 * <P><B>title: SpectroscopicWorkbench</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2013 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 05.02.2013 13:59:09
 * @since 1.0
 */

public class Tool4EADMessage {

    private String language_code = null;

    /**
	 * The constructor <CODE>Tool4EADMessage</CODE> creates a new instance(object) of the class.
	 * @param sysUser the system user.
	 * @since 1.0
	 */
	public Tool4EADMessage(List4SysUser sysUser) {
        this.language_code = sysUser.getUserLanguageCode();
	}

    /**
	 * The constructor <CODE>Tool4EADMessage</CODE> creates a new instance(object) of the class.
	 * @param language_code the language code.
	 * @since 1.0
	 */
	public Tool4EADMessage(String language_code) {
        this.language_code = language_code;
	}

    /**
     * The method <CODE>getMessages</CODE> gets the senior network messages of the language.
     * @return the senior network message object.
     * @since 1.0
   */
    public Tool4DbMessages getMessages() {
        Tool4DbMessages mess = null;
        if (language_code.equals("de")) {
            mess = new Tool4EADMessages_de();
        } else if (language_code.equals("en")) {
            mess = new Tool4EADMessages_en();
        }
        return mess;
    }
}

