package de.hopfieldnet.tool;

import n4e.core.tool.Tool4DbMessages;

/**
 * The <CODE>Tool4HNMessage</CODE> class  provides messages for the application.
 * <P><B>title: HopfieldNet</B></P>
 * <P>description: HopfieldNet</P>
 * <P>copyright: (c) 2017 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 03.03.2017 11:57:18
 * @since 1.0
 */

public class Tool4HNMessage {

    private String language_code = null;

    /**
	 * The constructor <CODE>Tool4HNMessage</CODE> creates a new instance(object) of the class.
	 * @param language_code the language code.
	 * @since 1.0
	 */
	public Tool4HNMessage(String language_code) {
        this.language_code = language_code;
	}

    /**
     * The method <CODE>getMessages</CODE> gets the senior network messages of the language.
     * @return the senior network message object.
     * @since 1.0
   */
    public Tool4DbMessages getMessages() {
        Tool4DbMessages mess = null;
        if (language_code.equals("de")) {
            mess = new Tool4HNMessages_de();
        } else if (language_code.equals("en")) {
            mess = new Tool4HNMessages_en();
        }
        return mess;
    }
}

