package n4e.netanddecision.dbaccess;

/**
* <p>title: n4e application</p>
* <p>description: netanddecision</p>
* <p>copyright: copyright (c) 2006-2011 by thomas kaffka; mba; all rights reserved.</p>
* <p>company: n.n.</p>
* @author thomas kaffka, mba.
* @version Tue Mar 14 12:11:07 CET 2017
*/

import java.sql.*;
import java.text.*;
import java.util.*;
import java.math.*;
import java.rmi.server.UID;
import java.util.zip.*;
import java.io.*;
import java.nio.*;
import java.security.*;

import n4e.core.database.*;
import n4e.core.dbaccess.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.core.list.*;



/**
 * The <CODE>DbAccessKeySet</CODE> class reads fields and put to data sink of KeySet table in database.
 * @author Dipl.-Kfm. Thomas Kaffka
 * @version Tue Mar 14 12:11:07 CET 2017
 * @since 1.0
*/
public class DbAccessKeySet extends DbAccess {



    // individual database fields
  private String name = ""; // Schluesselname
  private String old_name = ""; // (old value of) Schluesselname
  private String description = ""; // Beschreibung
  private String old_description = ""; // (old value of) Beschreibung
  private String description2 = ""; // Beschreibung
  private String old_description2 = ""; // (old value of) Beschreibung
  private String description3 = ""; // Beschreibung
  private String old_description3 = ""; // (old value of) Beschreibung
  private String description4 = ""; // Beschreibung
  private String old_description4 = ""; // (old value of) Beschreibung
  private String description5 = ""; // Beschreibung
  private String old_description5 = ""; // (old value of) Beschreibung
  private int showatclients = 0; // Keyset fuer uebrige Clients
  private int old_showatclients = 0; // (old value of) Keyset fuer uebrige Clients
  private String label1 = ""; // Bezeichnung Parameter 1
  private String old_label1 = ""; // (old value of) Bezeichnung Parameter 1
  private String label2 = ""; // Bezeichnung Parameter 2
  private String old_label2 = ""; // (old value of) Bezeichnung Parameter 2
  private String label3 = ""; // Bezeichnung Parameter 3
  private String old_label3 = ""; // (old value of) Bezeichnung Parameter 3
  private String label4 = ""; // Bezeichnung Parameter 4
  private String old_label4 = ""; // (old value of) Bezeichnung Parameter 4
  private String label5 = ""; // Bezeichnung Parameter 5
  private String old_label5 = ""; // (old value of) Bezeichnung Parameter 5
  private String explanation1 = ""; // Erklaerung Parameter 1
  private String old_explanation1 = ""; // (old value of) Erklaerung Parameter 1
  private String explanation2 = ""; // Erklaerung Parameter 2
  private String old_explanation2 = ""; // (old value of) Erklaerung Parameter 2
  private String explanation3 = ""; // Erklaerung Parameter 3
  private String old_explanation3 = ""; // (old value of) Erklaerung Parameter 3
  private String explanation4 = ""; // Erklaerung Parameter 4
  private String old_explanation4 = ""; // (old value of) Erklaerung Parameter 4
  private String explanation5 = ""; // Erklaerung Parameter 5
  private String old_explanation5 = ""; // (old value of) Erklaerung Parameter 5
  private ArrayList myDbAccessKeyWord = null ; // KeyWord
  private ArrayList old_myDbAccessKeyWord = null ; // (old value of) KeyWord


  // sets and gets of individual table fields
  public void setName(String input){name = input;}
  public String getName(){return name;}
  public void setDescription(String input){description = input;}
  public String getDescription(){return description;}
  public void setDescription2(String input){description2 = input;}
  public String getDescription2(){return description2;}
  public void setDescription3(String input){description3 = input;}
  public String getDescription3(){return description3;}
  public void setDescription4(String input){description4 = input;}
  public String getDescription4(){return description4;}
  public void setDescription5(String input){description5 = input;}
  public String getDescription5(){return description5;}
  public void setShowatclients(int input){showatclients = input;}
  public int getShowatclients(){return showatclients;}
  public void setLabel1(String input){label1 = input;}
  public String getLabel1(){return label1;}
  public void setLabel2(String input){label2 = input;}
  public String getLabel2(){return label2;}
  public void setLabel3(String input){label3 = input;}
  public String getLabel3(){return label3;}
  public void setLabel4(String input){label4 = input;}
  public String getLabel4(){return label4;}
  public void setLabel5(String input){label5 = input;}
  public String getLabel5(){return label5;}
  public void setExplanation1(String input){explanation1 = input;}
  public String getExplanation1(){return explanation1;}
  public void setExplanation2(String input){explanation2 = input;}
  public String getExplanation2(){return explanation2;}
  public void setExplanation3(String input){explanation3 = input;}
  public String getExplanation3(){return explanation3;}
  public void setExplanation4(String input){explanation4 = input;}
  public String getExplanation4(){return explanation4;}
  public void setExplanation5(String input){explanation5 = input;}
  public String getExplanation5(){return explanation5;}
  public void setMyDbAccessKeyWord(ArrayList input){myDbAccessKeyWord = input;}
  public ArrayList getMyDbAccessKeyWord(){return myDbAccessKeyWord;}


  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object.
   * @since 1.0
  */
  public DbAccessKeySet(){
      setWorkFields();
  }

  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object.
   * @param sysUser the system user.
   * @since 1.0
  */
  public DbAccessKeySet(List4SysUser sysUser){
    setSystemUser(sysUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }
  }

  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object.
   * @param pUser the user object.
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeySet(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    initiate(pUser, uniqueid , fieldlist , privfkey , publfkey , null, true);

  }

  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object.
   * @param conn the database connection.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeySet(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey ) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , null, true);

  }

  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object with additional sqlwhere.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeySet(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd) throws Exception {

    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd, true);

  }

  /**
   * The constructor <CODE>DbAccessKeySet</CODE> initialized the object with additional sqlwhere.
   * @param conn the database connection.
   * @param pUser the user object
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @exception Exception
   * @since 1.0
  */
  public DbAccessKeySet(DatabaseConnection conn , List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd) throws Exception {

    if (conn != null) {
        this.conn = conn;
        this.myconn = false;
    }
    initiate(pUser , uniqueid , fieldlist , privfkey , publfkey , sqlAdd, true);

  }

  /**
   * The method <CODE>initiate</CODE> initializes the object with additional sqlwhere.
   * @param pUser the user object.
   * @param uniqueid the unique key.
   * @param fieldlist List of fields to load.
   * @param privfkey List of privfkeys to load.
   * @param publfkey List of publfkeys to load.
   * @param sqlAdd additional where clause.
   * @param read_with_client read with use of the clientid.
   * @exception Exception.
   * @since 1.0
  */
  public void initiate(List4SysUser pUser , String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd , boolean read_with_client) throws Exception {

    this.read_with_client = read_with_client;
    setSystemUser(pUser);
    if (sysUser.getUserLanguageCode().equals("de")) {
        t4m = new Tool4DbMessages_de(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("en")) {
        t4m = new Tool4DbMessages_en(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("fr")) {
        t4m = new Tool4DbMessages_fr(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("es")) {
        t4m = new Tool4DbMessages_es(dbtablename);
    } else if (sysUser.getUserLanguageCode().equals("gr")) {
        t4m = new Tool4DbMessages_gr(dbtablename);
    } else {
        t4m = new Tool4DbMessages_en(dbtablename);
    }

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;
    publicforeignkeytable.put("idkeyword","KeyWord|idkeyset");




    success = loadFromTable(uniqueid , fieldlist , privfkey , publfkey , sqlAdd);
  }

  /**
   * The method <CODE>setWorkFields</CODE> sets the work fiels to current values.
   * @since 1.0
  */
  public void setWorkFields() {
      dbtablename = "KeySet"; // name of own database table
      if (sysUser != null) {
          databasename = sysUser.getClientDbsystemforeclient(); // name of own database
          myDatabaseConnectionSet = DatabaseManager.getDatabaseConnectionSet(databasename);
          setProtocol(dbtablename);
      }
      tblnameofprivk = ","; // list of table names of private foreign keys
      tblnameofpublvk = ",KeyWord,"; // list of table names of public foreign keys
      keynameofpublvk = ",idkeyset,"; // list of key names of table names of
      tblnameofownerfield = ","; // list of names of table names of public foreign keys owner key
      indivTableFields = ",name,description,description2,description3,description4,description5,showatclients,label1,label2,label3,label4,label5,explanation1,explanation2,explanation3,explanation4,explanation5,"; // list of inidividual table fields
      privateforeignkey = ";"; // list of private foreign key fields
      publicforeignkey = ";idkeyword;"; // list of public foreign key fields
  }

  /**
   * The method <CODE>loadFromTable</CODE> gets tabledata from database with fieldcheck.
   * @param uniqueid the unique key
   * @param fieldlist List of fields to load
   * @param privfkey List of privfkeys to load
   * @param publfkey List of publfkeys to load
   * @param sqlAdd additional where clause
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean loadFromTable(String uniqueid , String fieldlist , String privfkey , String publfkey , String sqlAdd ) throws Exception {

    errCode = 0;
    errMess = "";

    this.fields4load = fieldlist;
    this.privfkey4load = privfkey;
    this.publfkey4load = publfkey;
    this.sqlAdd = sqlAdd;
    hasdata = false;
    // create connection to defined database system
    if (this.myconn) {
        this.conn = myDatabaseConnectionSet.conn();
    }
    DatabaseSQLResultSet resSet = new DatabaseSQLResultSet(databasename , conn);



    // handle fields to load
    String sqlFieldlist = "";
    String sqlPrivfkey = "";

    // build sql field list
    if (fieldlist != null && fieldlist.equals("all")) {
      sqlFieldlist = indivTableFields.substring(1);
    } else { // make individual fieldlist
      if (fieldlist != null) {
        sqlFieldlist = fieldlist;
      } else {
        sqlFieldlist = "";
      }
    }

    // build sql field list of private foreign keys
    if (privfkey != null && privfkey.equals("all")) {
      sqlPrivfkey = privateforeignkey.substring(1);
    } else { // make individual fieldlist
      if (privfkey != null) {
          int pos = privfkey.indexOf("(");
          if (pos >= 0) {
            StringTokenizer stok = new StringTokenizer(privfkey , ";"); // public foreign keys separated by ;
            while (stok.hasMoreTokens()) { // for each public foreign key
                String xfield = stok.nextToken();
                pos = xfield.indexOf("(");
                if (pos >= 0) {
                    sqlPrivfkey += "," + xfield.substring(0, pos);
                } else {
                    sqlPrivfkey += "," + xfield;
                }
            }
            sqlPrivfkey = sqlPrivfkey.substring(1);
          } else {
            sqlPrivfkey = t4st.replaceToken(privfkey , ";" , ",");
          }
      } else {
        sqlPrivfkey = "";
      }
    }

    StringTokenizer stok = null;

    String workingSqlFieldlist = stdTableFields + sqlFieldlist;
    if (workingSqlFieldlist.endsWith(",")) {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?sqlPrivfkey:"")+",";
    } else {
      workingSqlFieldlist += (sqlPrivfkey.length()>0?","+sqlPrivfkey:"")+",";
    }


    int len = workingSqlFieldlist.length();
    workingSqlFieldlist = workingSqlFieldlist.substring(1,len-1);
    if (workingSqlFieldlist.endsWith(",")) {
      len = workingSqlFieldlist.length();
      workingSqlFieldlist = workingSqlFieldlist.substring(0,len-1);
    }

    resetFields();

    // grip into data sink
    if (uniqueid == null && sqlAdd == null) {
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
        errCode = ERROR_0001;
        errMess = t4m.getMessage("msg0001", null);
        return false;
    }

    String client_temp = client;
    if (!read_with_client) {
        client = null;
    }

    String where1 = ((client!=null&&client.length()>0)?("client='"+client+"'"):"");
    String where2 = ((uniqueid!=null&&uniqueid.length()>0)?("uniqueid='"+ uniqueid +"'"):"");
    String where3 = ((sqlAdd!=null&&sqlAdd.length()>0)?sqlAdd:"");
    String where = "";
    if (where1.length()==0 && where2.length()==0 && where3.length()==0) { // 000
      where = "";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()==0) { // 100
      where = " WHERE (" + where1 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()==0) { // 010
      where = " WHERE (" + where2 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()==0) { // 110
      where = " WHERE (" + where1 + ") AND (" + where2 + ")";
    } else if (where1.length()==0 && where2.length()==0 && where3.length()>0) { // 001
      where = " WHERE (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()==0 && where3.length()>0) { // 101
      where = " WHERE (" + where1 + ") AND (" + where3 + ")";
    } else if (where1.length()==0 && where2.length()>0 && where3.length()>0) { // 011
      where = " WHERE (" + where2 + ") AND (" + where3 + ")";
    } else if (where1.length()>0 && where2.length()>0 && where3.length()>0) { // 111
      where = " WHERE (" + where1 + ") AND (" + where2 + ") AND (" + where3 + ")";
    }

    String sqlStatement = "SELECT " + workingSqlFieldlist + " FROM KeySet " + where;
    conn.connectionlog("DbAccessKeySet","sql statement", sqlStatement);
    ResultSet result = resSet.getResultSet(sqlStatement);
    if (result.next() && (result.isFirst() && result.isLast())) {
      hasdata = true;
      // get standard fields
      setUniqueid(result.getString(1));
      setVersion(result.getLong(2));
      long temp_timestamp = result.getLong(3);
      java.util.Date temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setCreated(temp_date);
      setCreator(result.getString(4));
      temp_timestamp = result.getLong(5);
      temp_date = new java.util.Date();
      temp_date.setTime(temp_timestamp);
      setChanged(temp_date);
      setChangedfrom(result.getString(6));
      setInuse(result.getInt(7));
      setClient(result.getString(8));

      //get individual fields
      int i = 9;
      workingSqlFieldlist = sqlFieldlist + (sqlPrivfkey.length()>0?","+sqlPrivfkey:""); // only individuals.
      stok = new StringTokenizer(workingSqlFieldlist ,",");
      while (stok.hasMoreTokens()) {
        String xfield = stok.nextToken();
        if (false) {}
          // dummy
          else if (xfield.equals("name")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setName(value);old_name = value;}
          else if (xfield.equals("description")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription(value);old_description = value;}
          else if (xfield.equals("description2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription2(value);old_description2 = value;}
          else if (xfield.equals("description3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription3(value);old_description3 = value;}
          else if (xfield.equals("description4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription4(value);old_description4 = value;}
          else if (xfield.equals("description5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setDescription5(value);old_description5 = value;}
          else if (xfield.equals("showatclients")) {int value = result.getInt(i);setShowatclients(value);old_showatclients = value;}
          else if (xfield.equals("label1")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel1(value);old_label1 = value;}
          else if (xfield.equals("label2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel2(value);old_label2 = value;}
          else if (xfield.equals("label3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel3(value);old_label3 = value;}
          else if (xfield.equals("label4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel4(value);old_label4 = value;}
          else if (xfield.equals("label5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setLabel5(value);old_label5 = value;}
          else if (xfield.equals("explanation1")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation1(value);old_explanation1 = value;}
          else if (xfield.equals("explanation2")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation2(value);old_explanation2 = value;}
          else if (xfield.equals("explanation3")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation3(value);old_explanation3 = value;}
          else if (xfield.equals("explanation4")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation4(value);old_explanation4 = value;}
          else if (xfield.equals("explanation5")) {String value = result.getString(i)==null?"":t4st.replaceSQLWithChars(result.getString(i));setExplanation5(value);old_explanation5 = value;}

        i++;
      }

      //get individual privateforeignkeys
      if (privfkey != null && privfkey.length()>0) {
        String pffieldlist = "";
        if (privfkey.equals("all")) { // load all private foreign key objects with field list 'all'
          privfkey = privateforeignkey.substring(1);
        }
        stok = new StringTokenizer(privfkey , ";"); // private foreign keys separated by ;
        while (stok.hasMoreTokens()) { // for each private foreign key
          String xfield = stok.nextToken();
          if (xfield == null || xfield.length() == 0) continue;
          if (xfield.indexOf("(") > -1) { // private foreign key with field list
            StringTokenizer stfield = new StringTokenizer(xfield ,"(");
            if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (pffieldlist.endsWith(")")) {
              pffieldlist = pffieldlist.substring(0, pffieldlist.length()-1);
            }
          } else {
            pffieldlist = "all";
          }
          if (false) {}

          }
        }

     } else { // no data found
        if (this.myconn) {
            myDatabaseConnectionSet.connClose(conn);
        }
       errCode = ERROR_0002;
       errMess = t4m.getMessage("msg0002", null);
       return false;
     }

    //get individual publicforeignkeys
    if (publfkey != null && publfkey.length() > 0) {
      String pffieldlist = "";
      if (publfkey.equals("all")) { // load all public foreign key objects with field list 'all'
        publfkey = publicforeignkey.substring(1);
      }
      DatabaseDatasetLoader dsl = new DatabaseDatasetLoader(this.conn);
      stok = new StringTokenizer(publfkey , ";"); // public foreign keys separated by ;
       while (stok.hasMoreTokens()) { // for each public foreign key
        String xfield = stok.nextToken();
        if (xfield == null || xfield.length() == 0) continue;
        StringTokenizer stfield = null;
        if (xfield.indexOf("(") > -1) { // public foreign key with field list
          stfield = new StringTokenizer(xfield , "(");
          if (stfield.hasMoreTokens()) xfield = stfield.nextToken();
          if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
          if (pffieldlist.endsWith(")")) {
            pffieldlist = pffieldlist.substring(0, pffieldlist.length() - 1);
          }
        } else {
          pffieldlist = "all";
        }
        String orderby = null;
        if (pffieldlist.indexOf("|") > -1) { // order by feilds available.
            stfield = new StringTokenizer(pffieldlist ,"|");
            if (stfield.hasMoreTokens()) pffieldlist = stfield.nextToken();
            if (stfield.hasMoreTokens()) orderby = stfield.nextToken();
        }
        String pfTableName = (String) publicforeignkeytable.get(xfield);
        String pfkeyfield = "";
        StringTokenizer staccess = new StringTokenizer(pfTableName , "|");
        if (staccess.hasMoreTokens()) pfTableName = staccess.nextToken();
        if (staccess.hasMoreTokens()) pfkeyfield = staccess.nextToken();
        String sql = pfkeyfield + " = '" + result.getString("uniqueid") + "'";
        ArrayList keyList = dsl.getDataSet(sysUser , pfTableName , pffieldlist , null , null , sql , orderby , "netanddecision");
        if (false) {}
          else if (xfield.equals("idkeyword")) {
            setMyDbAccessKeyWord(keyList);
          }

      }
    }

    if (!read_with_client) {
        client = client_temp;
    }

    resSet.closeResultSet();
    resSet = null;
    if (this.myconn) {
        myDatabaseConnectionSet.connClose(conn);
    }



    return true;
  }

  /**
   * The method <CODE>putToSink</CODE> stores the data to database (data sink).
   * @param conn Connection to Database, if null => make own connection
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putToSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;

    // get connection
    boolean ownconn = false;
    if (conn == null) {
      conn = myDatabaseConnectionSet.conn();
      conn.setAutoCommit(false);
      ownconn = true;
    }

    initializeStandardFields();

    try {
        if (hasdata) {
          ok = putCurrentDataToSink(conn);
        } else {
          ok = putNewDataToSink(conn);
        }
    } catch (Exception ex) {
        String message = ex.getMessage();
        if (message != null) {
            // check if duplicate data in an unique key.
            // 'duplicate' unique index of mysql.
            // 'unique constraint or index violation' unique index of hsqldb.
            if (message.toLowerCase().indexOf("duplicate") >= 0 ||
                 message.toLowerCase().indexOf("unique constraint or index violation") >= 0) {
              errCode = ERROR_0104;
              errMess = t4m.getMessage("msg0104", null);
              ok = false;
            } else {
                conn.getDatabaseSystem().writeLine2Log(Tool4Throwable.getCallStackOut(ex));
                conn.getDatabaseSystem().flushLog();
                conn.rollback();
                System.out.println(Tool4Throwable.getMessage4Log("see log of database system: " + conn.getDatabaseSystem().getSystemName()));
                throw new Exception(ex);
            }
        } else {
            conn.getDatabaseSystem().writeLine2Log(Tool4Throwable.getCallStackOut(ex));
            conn.getDatabaseSystem().flushLog();
            conn.rollback();
            System.out.println(Tool4Throwable.getMessage4Log("see log of database system: " + conn.getDatabaseSystem().getSystemName()));
            throw new Exception(ex);
        }
    }

    if (ownconn) {
      if (ok) {
        conn.commit();
      } else {
        conn.rollback();
      }
      myDatabaseConnectionSet.connClose(conn);
    }

    return ok;
  }

  /**
   * The method <CODE>putNewDataToSink</CODE> executes an sql insert.
   * @param conn the database connection.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putNewDataToSink(DatabaseConnection conn) throws Exception {
    return putNewDataToSink(conn , new Boolean(true));
  }

  /**
   * The method <CODE>putNewDataToSink</CODE> executes an sql insert.
   * @param conn the database connection.
   * @param dotrigger, do the trigger.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putNewDataToSink(DatabaseConnection conn , Boolean dotrigger) throws Exception {
    boolean ok = true;



    // identify fields to insert
    String insertFieldlist = "";
    String insertValuelist = "";
    if (name != null && name.length()>0) {
        insertFieldlist += ",name";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(name)+"'";
    }
    if (description != null && description.length()>0) {
        insertFieldlist += ",description";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description)+"'";
    }
    if (description2 != null && description2.length()>0) {
        insertFieldlist += ",description2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description2)+"'";
    }
    if (description3 != null && description3.length()>0) {
        insertFieldlist += ",description3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description3)+"'";
    }
    if (description4 != null && description4.length()>0) {
        insertFieldlist += ",description4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description4)+"'";
    }
    if (description5 != null && description5.length()>0) {
        insertFieldlist += ",description5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(description5)+"'";
    }
    insertFieldlist += ",showatclients";
    insertValuelist += ","+Integer.toString(showatclients)+"";
    if (label1 != null && label1.length()>0) {
        insertFieldlist += ",label1";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(label1)+"'";
    }
    if (label2 != null && label2.length()>0) {
        insertFieldlist += ",label2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(label2)+"'";
    }
    if (label3 != null && label3.length()>0) {
        insertFieldlist += ",label3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(label3)+"'";
    }
    if (label4 != null && label4.length()>0) {
        insertFieldlist += ",label4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(label4)+"'";
    }
    if (label5 != null && label5.length()>0) {
        insertFieldlist += ",label5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(label5)+"'";
    }
    if (explanation1 != null && explanation1.length()>0) {
        insertFieldlist += ",explanation1";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(explanation1)+"'";
    }
    if (explanation2 != null && explanation2.length()>0) {
        insertFieldlist += ",explanation2";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(explanation2)+"'";
    }
    if (explanation3 != null && explanation3.length()>0) {
        insertFieldlist += ",explanation3";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(explanation3)+"'";
    }
    if (explanation4 != null && explanation4.length()>0) {
        insertFieldlist += ",explanation4";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(explanation4)+"'";
    }
    if (explanation5 != null && explanation5.length()>0) {
        insertFieldlist += ",explanation5";
        insertValuelist += ",'"+t4st.replaceCharsWithSQL(explanation5)+"'";
    }
    if (myDbAccessKeyWord != null) {
      int len = myDbAccessKeyWord.size();
      for (int i=0;i<len;i++) {
        DbAccessKeyWord updateClass = (DbAccessKeyWord) myDbAccessKeyWord.get(i);
        updateClass.setMyDbAccessKeySet(this);
        updateClass.putToSink(conn);
      }
    }


    // test before store
    DbAccessCheckKeySet test = new DbAccessCheckKeySet(t4m);
    if (!test.checkData(this , true , insertFieldlist + ",")) {
      errCode = test.errCode;
      errMess = test.errMess;
      return false;
    }

    String sqlTest = insertFieldlist + ",";
    String temp_changed = "null";
    java.util.Date temp_changed_date = getChanged();
    if (temp_changed_date != null) {
        temp_changed = Long.toString(temp_changed_date.getTime());
    }
    String temp_changedfrom = getChangedfrom();
    if (temp_changedfrom == null) {
        temp_changedfrom = "null";
    } else {
        temp_changedfrom = "'" + temp_changedfrom + "'";
    }

    if (insertFieldlist.length() > 0) {
      String insertFields = "uniqueid,version,created,creator,changed,changedfrom,inuse,client" + (insertFieldlist.length()>0?insertFieldlist:"");
      String valueFields = "'"+ uniqueid +"',"+Long.toString(version)+","+Long.toString(created.getTime())+",'"+ creator +"',"+temp_changed+","+temp_changedfrom+","+Integer.toString(inuse)+",'"+getClient()+"'"+ (insertValuelist.length()>0?insertValuelist:"");
      String sqlStatement = "INSERT INTO KeySet ("+insertFields+") VALUES ("+valueFields+")";
      conn.connectionlog("DbAccessKeySet","sql statement", sqlStatement);
      setKeyWordsAsUsed(conn);
      PreparedStatement ps = conn.prepareStatement(sqlStatement);
      int psndx = 0;

      ps.execute();
      ps.close();
    }



    if (ok) {
        errCode = MSG_0006;
        errMess = t4m.getMessage("msg0006", null);
    }
    return ok;
  }

  /**
   * The method <CODE>putCurrentDataToSink</CODE> executes an sql update.
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean putCurrentDataToSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;



    // identify fields to update
    String sqlStatement = "UPDATE KeySet SET version="+Long.toString(version)+",changed="+Long.toString(changed.getTime())+",changedfrom='"+changedfrom +"',inuse="+Integer.toString(inuse)+"";
    String updateFieldlist = "";
    if (hasChanged("name")) {updateFieldlist += ",name"; sqlStatement += (name==null?",name=null":",name='"+t4st.replaceCharsWithSQL(name)+"'");}
    if (hasChanged("description")) {updateFieldlist += ",description"; sqlStatement += (description==null?",description=null":",description='"+t4st.replaceCharsWithSQL(description)+"'");}
    if (hasChanged("description2")) {updateFieldlist += ",description2"; sqlStatement += (description2==null?",description2=null":",description2='"+t4st.replaceCharsWithSQL(description2)+"'");}
    if (hasChanged("description3")) {updateFieldlist += ",description3"; sqlStatement += (description3==null?",description3=null":",description3='"+t4st.replaceCharsWithSQL(description3)+"'");}
    if (hasChanged("description4")) {updateFieldlist += ",description4"; sqlStatement += (description4==null?",description4=null":",description4='"+t4st.replaceCharsWithSQL(description4)+"'");}
    if (hasChanged("description5")) {updateFieldlist += ",description5"; sqlStatement += (description5==null?",description5=null":",description5='"+t4st.replaceCharsWithSQL(description5)+"'");}
    if (hasChanged("showatclients")) {updateFieldlist += ",showatclients";sqlStatement+=",showatclients="+Integer.toString(showatclients)+"";}
    if (hasChanged("label1")) {updateFieldlist += ",label1"; sqlStatement += (label1==null?",label1=null":",label1='"+t4st.replaceCharsWithSQL(label1)+"'");}
    if (hasChanged("label2")) {updateFieldlist += ",label2"; sqlStatement += (label2==null?",label2=null":",label2='"+t4st.replaceCharsWithSQL(label2)+"'");}
    if (hasChanged("label3")) {updateFieldlist += ",label3"; sqlStatement += (label3==null?",label3=null":",label3='"+t4st.replaceCharsWithSQL(label3)+"'");}
    if (hasChanged("label4")) {updateFieldlist += ",label4"; sqlStatement += (label4==null?",label4=null":",label4='"+t4st.replaceCharsWithSQL(label4)+"'");}
    if (hasChanged("label5")) {updateFieldlist += ",label5"; sqlStatement += (label5==null?",label5=null":",label5='"+t4st.replaceCharsWithSQL(label5)+"'");}
    if (hasChanged("explanation1")) {updateFieldlist += ",explanation1"; sqlStatement += (explanation1==null?",explanation1=null":",explanation1='"+t4st.replaceCharsWithSQL(explanation1)+"'");}
    if (hasChanged("explanation2")) {updateFieldlist += ",explanation2"; sqlStatement += (explanation2==null?",explanation2=null":",explanation2='"+t4st.replaceCharsWithSQL(explanation2)+"'");}
    if (hasChanged("explanation3")) {updateFieldlist += ",explanation3"; sqlStatement += (explanation3==null?",explanation3=null":",explanation3='"+t4st.replaceCharsWithSQL(explanation3)+"'");}
    if (hasChanged("explanation4")) {updateFieldlist += ",explanation4"; sqlStatement += (explanation4==null?",explanation4=null":",explanation4='"+t4st.replaceCharsWithSQL(explanation4)+"'");}
    if (hasChanged("explanation5")) {updateFieldlist += ",explanation5"; sqlStatement += (explanation5==null?",explanation5=null":",explanation5='"+t4st.replaceCharsWithSQL(explanation5)+"'");}
    if (myDbAccessKeyWord != null) {
      int len = myDbAccessKeyWord.size();
      for (int i=0;i<len;i++) {
        DbAccessKeyWord updateClass = (DbAccessKeyWord) myDbAccessKeyWord.get(i);
        updateClass.putToSink(conn);
      }
    }


    // test before store
    DbAccessCheckKeySet test = new DbAccessCheckKeySet(t4m);
    if (!test.checkData(this , false , updateFieldlist + ",")) {
      errCode = test.errCode;
      errMess = test.errMess;
      return false;
    }

    if (updateFieldlist.length() > 0) {
      sqlStatement+=" WHERE uniqueid='"+ uniqueid +"'";
      conn.connectionlog("DbAccessKeySet","sql statement", sqlStatement );
      setKeyWordsAsUsed(conn);
      PreparedStatement ps = conn.prepareStatement(sqlStatement);
      int psndx = 0;

      int count = ps.executeUpdate();
      ps.close();
      if (count == 0) {
        ok = false;
        errCode = ERROR_0003;
        errMess = t4m.getMessage("msg0003", null);
      }
    }



    if (ok) {
        errCode = MSG_0007;
        errMess = t4m.getMessage("msg0007", null);
    }
    return ok;
  }

  /**
   * The method <CODE>deleteInSink</CODE> deletes the data in database (data sink).
   * @param conn Connection to Database, if null => make own connection
   * @return true if success
   * @exception Exception
   * @since 1.0
  */
  public boolean deleteInSink(DatabaseConnection conn) throws Exception {
    boolean ok = true;

    // test before delete
    if (!hasdata) {
      errCode = ERROR_0004;
      errMess = t4m.getMessage("msg0004", null);
      return false;
    }
    if (uniqueid == null || (uniqueid != null && uniqueid.length() == 0)) {
      errCode = ERROR_0005;
      errMess = t4m.getMessage("msg0005", null);
      return false;
    }

    // get connection
    boolean ownconn = false;
    if (conn == null) {
      conn = myDatabaseConnectionSet.conn();
      conn.setAutoCommit(false);
      ownconn = true;
    }



    // delete publicforeignkeys
    ArrayList report_delete = new ArrayList();
    if (publfkey4load != null && publfkey4load.length()>1) {
      String pffieldlist = "";
      String publfkey = publfkey4load;
      DatabaseDatasetLoader dsl = new DatabaseDatasetLoader();
      StringTokenizer stok = new StringTokenizer(publfkey ,";"); // public foreign keys separated by ;
      while (stok.hasMoreTokens()) { // for each public foreign key
        String xfield = stok.nextToken();
        String pfTableName = (String) publicforeignkeytable.get(xfield);
        String pfkeyfield = "";
        StringTokenizer staccess = new StringTokenizer(pfTableName ,"|");
        if (staccess.hasMoreTokens()) pfTableName = staccess.nextToken();
        if (staccess.hasMoreTokens()) pfkeyfield = staccess.nextToken();
        String sql = pfkeyfield + " = '"+uniqueid+"'";
        ArrayList keyList = dsl.getDataSet(sysUser , pfTableName , null , null , null , sql , null , "netanddecision");
        int daclen = keyList.size();
        for (int dacndx=0;dacndx<daclen;dacndx++) {
          if (false) {}
         else if (xfield.equals("idkeyword")) {
            DbAccessKeyWord pfDbAccessKeyWord = (DbAccessKeyWord) keyList.get(dacndx);
            report_delete.add("KeyWord" + "|" + pfDbAccessKeyWord.getUniqueid());
            pfDbAccessKeyWord.deleteInSink(conn);
         }

        }
      }
    }

    String sqlStatement = "DELETE FROM KeySet WHERE uniqueid='" + uniqueid + "'";
    conn.connectionlog("DbAccessKeySet","sql statement", sqlStatement );

    Statement  s = conn.createStatement();
    s.execute(sqlStatement);
    s.close();

    if (ownconn) {
      if (ok) {
        reportDelete(report_delete);
        conn.commit();
      } else {
        conn.rollback();
      }
      myDatabaseConnectionSet.connClose(conn);
    }



    errCode = MSG_0008;
    errMess = t4m.getMessage("msg0008", null);
    return ok;
  }

  /**
   * The method <CODE>reportDelete</CODE> report the deleted data.
   * @param report_delete the list of the associated sentences.
   * @exception Exception.
   * @since 1.0
   */
  private void reportDelete(ArrayList report_delete) throws Exception {
      if (!protocol) {
          return;
      }
  
      // report the deletion of all associated sentences.
      if (report_delete != null && report_delete.size() > 0) {
          int len = report_delete.size();
          for (int ndx=0;ndx<len;ndx++) {
              String sentence = (String) report_delete.get(ndx);
              String tablename = "";
              String tableuid = "";
              StringTokenizer st = new StringTokenizer(sentence, "|");
              if (st.hasMoreTokens()) {
                  tablename = st.nextToken();
              }
              if (st.hasMoreTokens()) {
                  tableuid = st.nextToken();
              }
              putProtocolToSink(tablename, tableuid);
          }
      }
  
      // report the deletion of the main sentence.
      putProtocolToSink(dbtablename, uniqueid);
  
  }

  /**
   * The method <CODE>putProtocolToSink</CODE> saves the report protocol.
   * @param tablename the name of the table.
   * @param tableuid the uniqueid of the sentence.
   * @exception Exception.
   * @since 1.0
   */
  private void putProtocolToSink(String tablename, String tableuid) throws Exception {
  
      DbAccessProtocol xprotocol = new DbAccessProtocol(new List4SysUser(null, sysUser.getUserUniqueid(),
                        sysUser.getUserUserid(), sysUser.getUserName(), sysUser.getUserLanguageCode(), 1, null, null, null,
                        sysUser.getClientUniqueid(), null, null, null, sysUser.getClientDbsystemforen4e(), null), null, "all", null, null);
  
      if (tablename.length() > 30) {
          tablename = tablename.substring(0, 30);
      }
      xprotocol.setName(tablename);
      xprotocol.setProtocoltype("dec20d6:1244d75eb11:-8000"); // delete sentence.
      xprotocol.setActiondate(new java.util.Date());
      xprotocol.setTableuid(tableuid);
      String the_user = sysUser.getUserUserid();
      if (the_user.length() > 35) {
          the_user = the_user.substring(0, 35);
      }
      xprotocol.setShorttext(the_user);
  
      // create a fingerprint of the deletion data.
      String pattern4fingerprint = xprotocol.getName() + xprotocol.getProtocoltype()
              + Long.toString(xprotocol.getActiondate().getTime()) + xprotocol.getShorttext()
              + xprotocol.getTableuid();
  
      MessageDigest md = MessageDigest.getInstance("SHA");
      byte digest[] = md.digest(pattern4fingerprint.getBytes());
      String key = "";
      int len = digest.length;
      for (int i=0;i<len;i++) {
          key += Integer.toHexString(digest[i]&0xff);
      }
      xprotocol.setText(key);
  
      xprotocol.putToSink(null);
  
  }

  /**
   * The method <CODE>initializeStandardFields</CODE> sets standard fiels to initial value.
   * @since 1.0
  */
  private void initializeStandardFields() {
    if (hasdata) { // update existing data set
      version++;
      changed = new java.util.Date();
      changedfrom = sysUser.getUserUniqueid();
      inuse = 0;
    } else { // insert new data set
      uniqueid = uniqueid==null||uniqueid.trim().length()==0?new UID().toString():uniqueid;
      version = 0;
      created = new java.util.Date();
      creator = sysUser.getUserUniqueid();
      changed = null;
      changedfrom = null;
      inuse = 0;
    }
  }

  /**
   * The method <CODE>resetFields</CODE> sets fields to initvalue.
   * @exception Exception
   * @since 1.0
  */
  private void resetFields() throws Exception {
    uniqueid = null;
    version = 0;
    created = null;
    creator = null;
    changed = null;
    changedfrom = null;
    inuse = 0;
    name = null;
    old_name = null;
    description = null;
    old_description = null;
    description2 = null;
    old_description2 = null;
    description3 = null;
    old_description3 = null;
    description4 = null;
    old_description4 = null;
    description5 = null;
    old_description5 = null;
    showatclients = 0;
    old_showatclients = 0;
    label1 = null;
    old_label1 = null;
    label2 = null;
    old_label2 = null;
    label3 = null;
    old_label3 = null;
    label4 = null;
    old_label4 = null;
    label5 = null;
    old_label5 = null;
    explanation1 = null;
    old_explanation1 = null;
    explanation2 = null;
    old_explanation2 = null;
    explanation3 = null;
    old_explanation3 = null;
    explanation4 = null;
    old_explanation4 = null;
    explanation5 = null;
    old_explanation5 = null;
    myDbAccessKeyWord = new ArrayList();
    old_myDbAccessKeyWord = null;

  }

  /**
   * The method <CODE>getDefData</CODE> returns data concerning a table field.
   * @param fieldname the name of table field
   * @param datatype type of data to return
   * @return def data
   * @exception Exception
   * @since 1.0
  */
  public String getDefData(String fieldname , String datatype) throws Exception {
    if (datatype.equals("label")) {
      if (false) {}
      else if (fieldname.equals("name")) {return getTranslationText(4);}
      else if (fieldname.equals("description")) {return getTranslationText(5);}
      else if (fieldname.equals("description2")) {return getTranslationText(5);}
      else if (fieldname.equals("description3")) {return getTranslationText(5);}
      else if (fieldname.equals("description4")) {return getTranslationText(5);}
      else if (fieldname.equals("description5")) {return getTranslationText(5);}
      else if (fieldname.equals("showatclients")) {return getTranslationText(6);}
      else if (fieldname.equals("label1")) {return getTranslationText(7);}
      else if (fieldname.equals("label2")) {return getTranslationText(8);}
      else if (fieldname.equals("label3")) {return getTranslationText(9);}
      else if (fieldname.equals("label4")) {return getTranslationText(10);}
      else if (fieldname.equals("label5")) {return getTranslationText(11);}
      else if (fieldname.equals("explanation1")) {return getTranslationText(12);}
      else if (fieldname.equals("explanation2")) {return getTranslationText(13);}
      else if (fieldname.equals("explanation3")) {return getTranslationText(14);}
      else if (fieldname.equals("explanation4")) {return getTranslationText(15);}
      else if (fieldname.equals("explanation5")) {return getTranslationText(16);}

//       return dbtablename + fieldname;
    } else if (datatype.equals("type")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "char";}
      else if (fieldname.equals("description")) {return "char";}
      else if (fieldname.equals("description2")) {return "char";}
      else if (fieldname.equals("description3")) {return "char";}
      else if (fieldname.equals("description4")) {return "char";}
      else if (fieldname.equals("description5")) {return "char";}
      else if (fieldname.equals("showatclients")) {return "flag";}
      else if (fieldname.equals("label1")) {return "char";}
      else if (fieldname.equals("label2")) {return "char";}
      else if (fieldname.equals("label3")) {return "char";}
      else if (fieldname.equals("label4")) {return "char";}
      else if (fieldname.equals("label5")) {return "char";}
      else if (fieldname.equals("explanation1")) {return "char";}
      else if (fieldname.equals("explanation2")) {return "char";}
      else if (fieldname.equals("explanation3")) {return "char";}
      else if (fieldname.equals("explanation4")) {return "char";}
      else if (fieldname.equals("explanation5")) {return "char";}
      else if (fieldname.equals("idkeyword")) {return "publicforeignkey";}

    } else if (datatype.equals("length")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "32";}
      else if (fieldname.equals("description")) {return "100";}
      else if (fieldname.equals("description2")) {return "100";}
      else if (fieldname.equals("description3")) {return "100";}
      else if (fieldname.equals("description4")) {return "100";}
      else if (fieldname.equals("description5")) {return "100";}
      else if (fieldname.equals("showatclients")) {return "1";}
      else if (fieldname.equals("label1")) {return "30";}
      else if (fieldname.equals("label2")) {return "30";}
      else if (fieldname.equals("label3")) {return "30";}
      else if (fieldname.equals("label4")) {return "30";}
      else if (fieldname.equals("label5")) {return "30";}
      else if (fieldname.equals("explanation1")) {return "255";}
      else if (fieldname.equals("explanation2")) {return "255";}
      else if (fieldname.equals("explanation3")) {return "255";}
      else if (fieldname.equals("explanation4")) {return "255";}
      else if (fieldname.equals("explanation5")) {return "255";}
      else if (fieldname.equals("idkeyword")) {return "35";}

    } else if (datatype.equals("needed")) {
      if (false) {}
      else if (fieldname.equals("name")) {return "yes";}
      else if (fieldname.equals("description")) {return "no";}
      else if (fieldname.equals("description2")) {return "no";}
      else if (fieldname.equals("description3")) {return "no";}
      else if (fieldname.equals("description4")) {return "no";}
      else if (fieldname.equals("description5")) {return "no";}
      else if (fieldname.equals("showatclients")) {return "yes";}
      else if (fieldname.equals("label1")) {return "no";}
      else if (fieldname.equals("label2")) {return "no";}
      else if (fieldname.equals("label3")) {return "no";}
      else if (fieldname.equals("label4")) {return "no";}
      else if (fieldname.equals("label5")) {return "no";}
      else if (fieldname.equals("explanation1")) {return "no";}
      else if (fieldname.equals("explanation2")) {return "no";}
      else if (fieldname.equals("explanation3")) {return "no";}
      else if (fieldname.equals("explanation4")) {return "no";}
      else if (fieldname.equals("explanation5")) {return "no";}
      else if (fieldname.equals("idkeyword")) {return "no";}

    }
    return "";
  }

  /**
   * The method <CODE>setFieldAsString</CODE> returns the field contens as a string.
   * @param fieldname the name of table field
   * @param valuexyz the value of table field
   * @exception Exception
   * @since 1.0
  */
  public void setFieldAsString(String fieldname , String valuexyz) throws Exception {
//    if (valuexyz == null) valuexyz = "0";
//    if (valuexyz.equals("null")) valuexyz = "0";
    if (valuexyz != null)  {
        valuexyz = valuexyz.trim();
        if (valuexyz.length() == 0) {
            valuexyz = null;
        }
    }
    try  {
    if (false) {}
    else if (fieldname.equals("uniqueid")) {uniqueid = valuexyz;}
    else if (fieldname.equals("version")) {version = Long.parseLong(valuexyz == null?"0":valuexyz);}
    else if (fieldname.equals("created")) {created = new java.util.Date(t4n.getString2Long(valuexyz == null?"0":valuexyz, SystemService.getLocaleDef()));}
    else if (fieldname.equals("creator")) {creator = valuexyz;}
    else if (fieldname.equals("changed")) {changed = new java.util.Date(Long.parseLong(valuexyz == null?"0":valuexyz));}
    else if (fieldname.equals("changedfrom")) {changedfrom = valuexyz;}
    else if (fieldname.equals("inuse")) {inuse = (valuexyz == null?0:Integer.parseInt(valuexyz));}
    else if (fieldname.equals("client")) {client = valuexyz;}
    else if (fieldname.equals("name")) {name = valuexyz;}
    else if (fieldname.equals("description")) {description = valuexyz;}
    else if (fieldname.equals("description2")) {description2 = valuexyz;}
    else if (fieldname.equals("description3")) {description3 = valuexyz;}
    else if (fieldname.equals("description4")) {description4 = valuexyz;}
    else if (fieldname.equals("description5")) {description5 = valuexyz;}
    else if (fieldname.equals("showatclients")) {
      if (valuexyz == null) {
        showatclients = 0;
      } else if (valuexyz.equals("0")) {
        showatclients = 0;
      } else if (valuexyz.equals("1")) {
        showatclients = 1;
      } else if (valuexyz.equals(t4m.getMessage("msg0016", null))) {
        showatclients = 0;
      } else if (valuexyz.equals(t4m.getMessage("msg0015", null))) {
        showatclients = 1;
      } else {
        showatclients = 0;
      }
    }
    else if (fieldname.equals("label1")) {label1 = valuexyz;}
    else if (fieldname.equals("label2")) {label2 = valuexyz;}
    else if (fieldname.equals("label3")) {label3 = valuexyz;}
    else if (fieldname.equals("label4")) {label4 = valuexyz;}
    else if (fieldname.equals("label5")) {label5 = valuexyz;}
    else if (fieldname.equals("explanation1")) {explanation1 = valuexyz;}
    else if (fieldname.equals("explanation2")) {explanation2 = valuexyz;}
    else if (fieldname.equals("explanation3")) {explanation3 = valuexyz;}
    else if (fieldname.equals("explanation4")) {explanation4 = valuexyz;}
    else if (fieldname.equals("explanation5")) {explanation5 = valuexyz;}

    } catch (ParseException ex) {
       errCode = ERROR_0105;
       errMess = t4m.getMessage("msg0121", getDefData(fieldname , "label"));
    } catch (Exception ex) {
       throw new Exception(ex);
    }
  }

  /**
   * The method <CODE>getBlobField</CODE> returns the field contens of blob fields.
   * @param fieldname the name of table field.
   * @return field contens.
   * @exception Exception
   * @since 1.0
  */
  public byte[] getBlobField(String fieldname) throws Exception {
    if (false) {}

    return null;
  }

  /**
   * The method <CODE>getFieldAsStringKey</CODE> returns the field contens as a string.
   * @param fieldname the name of table field.
   * @param getkey, get the key value.
   * @return field contens.
   * @exception Exception
   * @since 1.0
  */
  public String getFieldAsStringKey(String fieldname , Boolean getkey) throws Exception {
    if (false) {}
    else if (fieldname.equals("uniqueid")) {return uniqueid == null?"":uniqueid ;}
    else if (fieldname.equals("version")) {return Long.toString(version);}
    else if (fieldname.equals("created")) {return created == null?"":created.toString();}
    else if (fieldname.equals("creator")) {return creator == null?"":creator ;}
    else if (fieldname.equals("changed")) {return changed == null?"":changed.toString();}
    else if (fieldname.equals("changedfrom")) {return changedfrom == null?"":changedfrom ;}
    else if (fieldname.equals("inuse")) {return Integer.toString(inuse);}
    else if (fieldname.equals("client")) {return client == null?"":client ;}
    else if (fieldname.equals("name")) {return name == null?"":name ;}
    else if (fieldname.equals("description")) {return description == null?"":description ;}
    else if (fieldname.equals("description2")) {return description2 == null?"":description2 ;}
    else if (fieldname.equals("description3")) {return description3 == null?"":description3 ;}
    else if (fieldname.equals("description4")) {return description4 == null?"":description4 ;}
    else if (fieldname.equals("description5")) {return description5 == null?"":description5 ;}
    else if (fieldname.equals("showatclients")) {if(getkey.booleanValue()) {return Integer.toString(showatclients);} else {return showatclients == 1?t4m.getMessage("msg0015", null):t4m.getMessage("msg0016", null);}}
    else if (fieldname.equals("label1")) {return label1 == null?"":label1 ;}
    else if (fieldname.equals("label2")) {return label2 == null?"":label2 ;}
    else if (fieldname.equals("label3")) {return label3 == null?"":label3 ;}
    else if (fieldname.equals("label4")) {return label4 == null?"":label4 ;}
    else if (fieldname.equals("label5")) {return label5 == null?"":label5 ;}
    else if (fieldname.equals("explanation1")) {return explanation1 == null?"":explanation1 ;}
    else if (fieldname.equals("explanation2")) {return explanation2 == null?"":explanation2 ;}
    else if (fieldname.equals("explanation3")) {return explanation3 == null?"":explanation3 ;}
    else if (fieldname.equals("explanation4")) {return explanation4 == null?"":explanation4 ;}
    else if (fieldname.equals("explanation5")) {return explanation5 == null?"":explanation5 ;}

    return "";
  }

  /**
   * The method <CODE>hasChanged</CODE> returns the status of field change.
   * @param fieldname the name of table field
   * @return field length
   * @exception Exception
   * @since 1.0
  */
  public boolean hasChanged(String fieldname) throws Exception {
    if (false) {}
    else if (fieldname.equals("name")) {
      if (name != null || old_name != null) {
        if ((name == null && old_name != null) || (name != null && old_name == null)) {
          return true;
        } else {
          if (!name.equals(old_name)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description")) {
      if (description != null || old_description != null) {
        if ((description == null && old_description != null) || (description != null && old_description == null)) {
          return true;
        } else {
          if (!description.equals(old_description)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description2")) {
      if (description2 != null || old_description2 != null) {
        if ((description2 == null && old_description2 != null) || (description2 != null && old_description2 == null)) {
          return true;
        } else {
          if (!description2.equals(old_description2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description3")) {
      if (description3 != null || old_description3 != null) {
        if ((description3 == null && old_description3 != null) || (description3 != null && old_description3 == null)) {
          return true;
        } else {
          if (!description3.equals(old_description3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description4")) {
      if (description4 != null || old_description4 != null) {
        if ((description4 == null && old_description4 != null) || (description4 != null && old_description4 == null)) {
          return true;
        } else {
          if (!description4.equals(old_description4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("description5")) {
      if (description5 != null || old_description5 != null) {
        if ((description5 == null && old_description5 != null) || (description5 != null && old_description5 == null)) {
          return true;
        } else {
          if (!description5.equals(old_description5)) {return true;}
        }
      }
    }
    else if (fieldname.equals("showatclients")) {
      if (showatclients != old_showatclients) {
        return true;
      }
    }
    else if (fieldname.equals("label1")) {
      if (label1 != null || old_label1 != null) {
        if ((label1 == null && old_label1 != null) || (label1 != null && old_label1 == null)) {
          return true;
        } else {
          if (!label1.equals(old_label1)) {return true;}
        }
      }
    }
    else if (fieldname.equals("label2")) {
      if (label2 != null || old_label2 != null) {
        if ((label2 == null && old_label2 != null) || (label2 != null && old_label2 == null)) {
          return true;
        } else {
          if (!label2.equals(old_label2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("label3")) {
      if (label3 != null || old_label3 != null) {
        if ((label3 == null && old_label3 != null) || (label3 != null && old_label3 == null)) {
          return true;
        } else {
          if (!label3.equals(old_label3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("label4")) {
      if (label4 != null || old_label4 != null) {
        if ((label4 == null && old_label4 != null) || (label4 != null && old_label4 == null)) {
          return true;
        } else {
          if (!label4.equals(old_label4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("label5")) {
      if (label5 != null || old_label5 != null) {
        if ((label5 == null && old_label5 != null) || (label5 != null && old_label5 == null)) {
          return true;
        } else {
          if (!label5.equals(old_label5)) {return true;}
        }
      }
    }
    else if (fieldname.equals("explanation1")) {
      if (explanation1 != null || old_explanation1 != null) {
        if ((explanation1 == null && old_explanation1 != null) || (explanation1 != null && old_explanation1 == null)) {
          return true;
        } else {
          if (!explanation1.equals(old_explanation1)) {return true;}
        }
      }
    }
    else if (fieldname.equals("explanation2")) {
      if (explanation2 != null || old_explanation2 != null) {
        if ((explanation2 == null && old_explanation2 != null) || (explanation2 != null && old_explanation2 == null)) {
          return true;
        } else {
          if (!explanation2.equals(old_explanation2)) {return true;}
        }
      }
    }
    else if (fieldname.equals("explanation3")) {
      if (explanation3 != null || old_explanation3 != null) {
        if ((explanation3 == null && old_explanation3 != null) || (explanation3 != null && old_explanation3 == null)) {
          return true;
        } else {
          if (!explanation3.equals(old_explanation3)) {return true;}
        }
      }
    }
    else if (fieldname.equals("explanation4")) {
      if (explanation4 != null || old_explanation4 != null) {
        if ((explanation4 == null && old_explanation4 != null) || (explanation4 != null && old_explanation4 == null)) {
          return true;
        } else {
          if (!explanation4.equals(old_explanation4)) {return true;}
        }
      }
    }
    else if (fieldname.equals("explanation5")) {
      if (explanation5 != null || old_explanation5 != null) {
        if ((explanation5 == null && old_explanation5 != null) || (explanation5 != null && old_explanation5 == null)) {
          return true;
        } else {
          if (!explanation5.equals(old_explanation5)) {return true;}
        }
      }
    }

    return false;
  }

  /**
   * The method <CODE>getDataSet</CODE> returns a data set from table.
   * @param addsqlorder order of sql result
   * @return dataSet
   * @exception Exception
   * @since 1.0
  */
  public ArrayList getDataSet(String addsqlorder) throws Exception {
    DatabaseDatasetLoader dbl = new DatabaseDatasetLoader();
    ArrayList dataSet = dbl.getDataSet(sysUser , dbtablename , fields4load , privfkey4load , publfkey4load , sqlAdd , addsqlorder , "netanddecision");
    return dataSet;
  }

  /**
   * The method <CODE>getTranslationText</CODE> returns the translated text.
   * @param ndx the text index.
   * @return the translation.
   * @exception Exception
   * @since 1.0
  */
  public String getTranslationText(int ndx) throws Exception {
    if (false) {
    } else if (sysUser.getUserLanguageCode().equals("de")) {
      if (false) {}
      else if (ndx == 16) {return "Erkl\u00e4rung Parameter 5";}
      else if (ndx == 15) {return "Erkl\u00e4rung Parameter 4";}
      else if (ndx == 14) {return "Erkl\u00e4rung Parameter 3";}
      else if (ndx == 13) {return "Erkl\u00e4rung Parameter 2";}
      else if (ndx == 12) {return "Erkl\u00e4rung Parameter 1";}
      else if (ndx == 11) {return "Bezeichnung Parameter 5";}
      else if (ndx == 10) {return "Bezeichnung Parameter 4";}
      else if (ndx == 9) {return "Bezeichnung Parameter 3";}
      else if (ndx == 8) {return "Bezeichnung Parameter 2";}
      else if (ndx == 7) {return "Bezeichnung Parameter 1";}
      else if (ndx == 6) {return "Keyset f\u00fcr \u00fcbrige Clients";}
      else if (ndx == 5) {return "Beschreibung";}
      else if (ndx == 4) {return "Schl\u00fcsselname";}

    } else if (sysUser.getUserLanguageCode().equals("en")) {
      if (false) {}
      else if (ndx == 16) {return "Explanation Parameter 5";}
      else if (ndx == 15) {return "Explanation Parameter 4";}
      else if (ndx == 14) {return "Explanation Parameter 3";}
      else if (ndx == 13) {return "Explanation Parameter 2";}
      else if (ndx == 12) {return "Explanation Parameter 1";}
      else if (ndx == 11) {return "Description Parameter 5";}
      else if (ndx == 10) {return "Description Parameter 4";}
      else if (ndx == 9) {return "Description Parameter 3";}
      else if (ndx == 8) {return "Description Parameter 2";}
      else if (ndx == 7) {return "Description Parameter 1";}
      else if (ndx == 6) {return "Key Set for other Clients";}
      else if (ndx == 5) {return "Description";}
      else if (ndx == 4) {return "Key Name";}


    }
    return "no text available";
  }


}
