package n4e.netanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.AWTextField;
import n4e.core.screen.*;
import n4e.core.tool.*;
import n4e.netanddecision.dbaccess.DbAccessReadProject;
import n4e.netanddecision.system.Globals;
import n4e.netanddecision.system.NetAndDecision;

/**
 * The <CODE>GeneratorDataSite</CODE> class ...
 * <P><B>title: NetAndDecision</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2017 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 22.02.2017 14:27:36
 * @since 1.0
 */

public class GeneratorDataSite extends DataSite {

	private JRadioButton rbFunction1;
	private JRadioButton rbFunction2;
	private JRadioButton rbFunction3;
	private JRadioButton rbFunction4;
	private JRadioButton rbFunction5;

    private AWTextField tfAmount;

    private JButton btnGenerate;
    
    private int learn_step;
    private boolean stop;

	/**
	 * The constructor <CODE>GeneratorDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public GeneratorDataSite(NetAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_height;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_height;
			control_width = Globals.control_width;

			int panel_width = 600;
			int panel_height = 340;
			stop = true;
			
			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(panel_width, panel_height));

			createHead(pnlScreen, Globals.message.getMessage("msg0037"));

            createLabel(pnlScreen, Globals.message.getMessage("msg0070"));
            label_line += 30;
	        rbFunction1 = new JRadioButton("z = abs( 0.3 * cos( a * ( x * x + y * y )))");
	        rbFunction1.setBounds(control_column, label_line, 300, 20);
            pnlScreen.add(rbFunction1);
            rbFunction1.setSelected(true);
            label_line += 30;
	        rbFunction2 = new JRadioButton("z = abs( 0.5 * cos( a * ( x * x - y * y )))");
	        rbFunction2.setBounds(control_column, label_line, 300, 20);
            pnlScreen.add(rbFunction2);
            label_line += 30;
	        rbFunction3 = new JRadioButton("z = exp( a * ( x * x + y * y ))");
	        rbFunction3.setBounds(control_column, label_line, 300, 20);
            pnlScreen.add(rbFunction3);
            label_line += 30;
	        rbFunction4 = new JRadioButton("z = a * sin( x / b ) * sin( y / c )");
	        rbFunction4.setBounds(control_column, label_line, 300, 20);
            pnlScreen.add(rbFunction4);
            label_line += 30;
	        rbFunction5 = new JRadioButton("z = abs( a * ( x * x - y * y ))");
	        rbFunction5.setBounds(control_column, label_line, 300, 20);
            pnlScreen.add(rbFunction5);

			ButtonGroup bg = new ButtonGroup();
			bg.add(rbFunction1);
			bg.add(rbFunction2);
			bg.add(rbFunction3);
			bg.add(rbFunction4);
			bg.add(rbFunction5);

            label_line += 30;
	        createLabel(pnlScreen, Globals.message.getMessage("msg0077"));
	        tfAmount = createTextField(pnlScreen, 200, 70);
	        tfAmount.setText("10");

	        btnGenerate = createButton(pnlScreen, panel_height - 30, 570,
					DataSite.BUTTON_USE, Globals.message.getMessage("msg0071"));
			btnGenerate.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnGenerate_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});
			btnGenerate.setEnabled(false);
			
		    sclScreen = createScrollPane(pnlScreen, pnl_width - 20, pnl_height - 50);

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>functionEditable</CODE> blocks the functions, if training.
	 * @param editable false -> block.
	 * @since 1.0
	 */
	public void functionEditable(boolean editable) {
		btnGenerate.setEnabled(editable);
	}

	private double fn1(double x, double y) {
		return Math.abs(0.3 * Math.cos(0.1 * ((x*10) * (x*10) + (y*10) * (y*10))));
	}
	
	private double fn2(double x, double y) {
		return Math.abs(0.5 * Math.cos(0.05 * ((x*10) * (x*10) - (y*10) * (y*10))));
	}
	
	private double fn3(double x, double y) {
		return Math.exp(-0.05 * ((x*10) * (x*10) + (y*10) * (y*10)));
	}
	
	private double fn4(double x, double y) {
		return (0.3 * (3 * Math.sin((x*10) / 3) * Math.sin((y*10) / 3)));
	}
	
	private double fn5(double x, double y) {
		return Math.abs(0.01 * ((x*10) * (x*10) - (y*10) * (y*10)));
	}
	
	private double fn6(double x, double y) {
		return ((2*x - 2*Math.sqrt(x) + 2*y - 2*Math.sqrt(y)) * 0.9 + 0.05);
	}

		  /**
	 * The method <CODE>btnGenerate_actionPerformed</CODE> action of the btnGenerate.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnGenerate_actionPerformed(ActionEvent e) throws Exception {
		
		Globals.examples = new ArrayList<ArrayList<Number>>();

		int point_len = Integer.parseInt(tfAmount.getText());
		
		for (int i=1;i<=point_len;i++) {
	        for (int j=1;j<=point_len;j++) {
	        	double y = (1.0 / point_len) * i;
	        	double x = (1.0 / point_len) * j;
	    		ArrayList<Number> line = new ArrayList<Number>();
	    		line.add(y);
	    		line.add(x);
				if (rbFunction1.isSelected()) {
		    		line.add(fn1(x, y));
				} else if (rbFunction2.isSelected()) {
		    		line.add(fn2(x, y));
				} else if (rbFunction3.isSelected()) {
		    		line.add(fn3(x, y));
				} else if (rbFunction4.isSelected()) {
		    		line.add(fn4(x, y));
				} else if (rbFunction5.isSelected()) {
		    		line.add(fn5(x, y));
				}
				Globals.examples.add(line);
	        }
	    }
		
	}

}
