package n4e.netanddecision.screen;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import n4e.core.controls.*;
import n4e.core.screen.*;
import n4e.core.system.*;
import n4e.core.tool.*;
import n4e.netanddecision.dbaccess.DbAccessProject;
import n4e.netanddecision.dbaccess.DbAccessReadProject;
import n4e.netanddecision.system.Globals;
import n4e.netanddecision.system.NetAndDecision;

/**
 * The <CODE>ProjectDataSite</CODE> class ...
 * <P><B>title: NetAndDecision</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2014 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 18.02.2017 14:29:36
 * @since 1.0
 */

public class ProjectDataSite extends DataSite {

    private AWTextField tfName;
    private AWTextField tfDate;
    private AWTextField tfXLayer;
    private AWTextField tfHLayer;
    private AWTextField tfYLayer;
    private AWTextField tfEpsilon;
    private JCheckBox cbSaveLearn;
    private JLabel lblLearnsteps;
    private JTextArea taRemarks; 

    private JButton btnDate;
    private JButton btnNamesXLayer;
    private JButton btnNamesYLayer;
    private JButton btnNew;
    private JButton btnSave;
    private JButton btnReturn;

    private String curr_uniqueid;
    private int x_number_old;
    private int y_number_old;

	/**
	 * The constructor <CODE>ProjectDataSite</CODE> creates a new instance(object) of the class.
	 * @param frame the main window.
	 * @param pnl_width the width of the car site.
	 * @param pnl_height the height of the car site.
	 * @since 1.0
	 */
	public ProjectDataSite(NetAndDecision frame, int pnl_width, int pnl_height) {
		super(frame, Globals.fontStandard12);

		try {

			label_hight = Globals.label_height;
			label_width = Globals.label_width;
			label_line_count = 24;
			control_hight = Globals.control_height;
			control_width = Globals.control_width;

			int panel_width = 600;
			int panel_height = 340;
			
			x_number_old = 0;
			y_number_old = 0;
			
			pnlScreen = new JPanel();
			pnlScreen.setBackground(Color.WHITE);
			pnlScreen.setLayout(null);
			pnlScreen.setPreferredSize(new Dimension(panel_width, panel_height));

			createHead(pnlScreen, Globals.message.getMessage("msg0034"));

			DbAccessReadProject tab = new DbAccessReadProject(Globals.sysUser);

            createLabel(pnlScreen, tab.getDefData("name", "label"));
            tfName = createTextField(pnlScreen);

            createLabel(pnlScreen, tab.getDefData("projdate", "label"));
            tfDate = createTextField(pnlScreen);

			btnDate = createButton(pnlScreen, label_line, 410, 
					DataSite.BUTTON_TIME, Globals.message.getMessage("msg0042"));
			btnDate.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnDate_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

            createLabel(pnlScreen, tab.getDefData("xlayer", "label"));
		    tfXLayer = createTextField(pnlScreen);

			btnNamesXLayer = createButton(pnlScreen, label_line, 410, 
					DataSite.BUTTON_MATRIX, Globals.message.getMessage("msg0043"));
			btnNamesXLayer.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNamesXLayer_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createLabel(pnlScreen, tab.getDefData("hlayer", "label"));
            tfHLayer =  createTextField(pnlScreen);

            createLabel(pnlScreen, tab.getDefData("ylayer", "label"));
            tfYLayer =  createTextField(pnlScreen);

			btnNamesYLayer = createButton(pnlScreen, label_line, 410, 
					DataSite.BUTTON_MATRIX, Globals.message.getMessage("msg0044"));
			btnNamesYLayer.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNamesYLayer_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			createLabel(pnlScreen, tab.getDefData("epsilon", "label"));
            tfEpsilon =  createTextField(pnlScreen);

	        createLabel(pnlScreen, tab.getDefData("savelearn", "label"));
	        cbSaveLearn = createCheckBox(pnlScreen);

	        createLabel(pnlScreen, tab.getDefData("learnsteps", "label"));	
			lblLearnsteps = createLabelField(pnlScreen, control_column, control_width, false);

		    createLabel(pnlScreen, tab.getDefData("remarks", "label"));
			taRemarks = createTextArea(pnlScreen, 390, 70, true, AWTextAreaPopUp.NONE);

			btnNew = createButton(pnlScreen, panel_height - 30, 490, 
					DataSite.BUTTON_NEW, Globals.message.getMessage("msg0006"));
			btnNew.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnNew_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnSave = createButton(pnlScreen, panel_height - 30, 530,
					DataSite.BUTTON_SAVE, Globals.message.getMessage("msg0008"));
			btnSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnSave_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

			btnReturn = createButton(pnlScreen, panel_height - 30, 570,
					DataSite.BUTTON_BACK, Globals.message.getMessage("msg0030"));
			btnReturn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					try {
						btnReturn_actionPerformed(ev);
					} catch (Exception ex) {
						t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
					}
				}
			});

		    sclScreen = createScrollPane(pnlScreen, pnl_width - 20, pnl_height - 50);

		} catch (Exception ex) {
			t4dialog.showException(Tool4Throwable.getCallStackOut(ex));
		}
	}

	/**
	 * The method <CODE>functionEditable</CODE> blocks the functions, if training.
	 * @param editable false -> block.
	 * @since 1.0
	 */
	public void functionEditable(boolean editable) {
	    btnDate.setEnabled(editable);
	    btnNamesXLayer.setEnabled(editable);
	    btnNamesYLayer.setEnabled(editable);
		btnNew.setEnabled(editable);
	    btnSave.setEnabled(editable);
	    btnReturn.setEnabled(editable);
	}

	/**
	 * The method <CODE>btnDate_actionPerformed</CODE> action of the btnDate.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnDate_actionPerformed(ActionEvent e) throws Exception {
		DatePicker dp = new DatePicker(Globals.nad, this);
	}

	/**
	 * The method <CODE>btnNamesXLayer_actionPerformed</CODE> action of the btnNamesXLayer.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNamesXLayer_actionPerformed(ActionEvent e) throws Exception {
		sclScreen.setVisible(false);
		Globals.nad.lnds.setVarNumber(Integer.parseInt(tfXLayer.getText()), Globals.X_LAYER);
		fireSiteChangeEvent_2(curr_uniqueid);
	}
	
	/**
	 * The method <CODE>btnNamesYLayer_actionPerformed</CODE> action of the btnNamesYLayer.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNamesYLayer_actionPerformed(ActionEvent e) throws Exception {
		sclScreen.setVisible(false);
		Globals.nad.lnds.setVarNumber(Integer.parseInt(tfYLayer.getText()), Globals.Y_LAYER);
		fireSiteChangeEvent_2(curr_uniqueid);
	}

	/**
	 * The method <CODE>btnNew_actionPerformed</CODE> action of the btnNew.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnNew_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
        createNewData();
	}

	/**
	 * The method <CODE>btnSave_actionPerformed</CODE> action of the btnSave.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnSave_actionPerformed(ActionEvent e) throws Exception {

		DbAccessProject tab = new DbAccessProject(Globals.sysUser, curr_uniqueid,
				"all", null, null);

		if (tab.errCode == 0 || tab.errCode == tab.ERROR_0001 || tab.errCode == tab.ERROR_0002) {

		    int x_number = Integer.parseInt(tfXLayer.getText());
			int y_number = Integer.parseInt(tfYLayer.getText());
			
			if (x_number_old > 0 && x_number < x_number_old) {
				Globals.t4dialog.showErrorDialog(Globals.message.getMessage("msg0047"));
				return;
			}
			
			if (y_number_old > 0 && y_number < y_number_old) {
				Globals.t4dialog.showErrorDialog(Globals.message.getMessage("msg0048"));
				return;
			}
			
			tab.errCode = 0;
            tab.setFieldAsString("name", tfName.getText());
            tab.setFieldAsString("projdate", tfDate.getText());
            tab.setFieldAsString("xlayer", tfXLayer.getText());
            tab.setFieldAsString("hlayer", tfHLayer.getText());
            tab.setFieldAsString("ylayer", tfYLayer.getText());
            tab.setFieldAsString("epsilon", tfEpsilon.getText());
            tab.setLearnsteps(0);
            tab.setFieldAsString("remarks", taRemarks.getText());
            if (cbSaveLearn.isSelected()) {
            	tab.setSavelearn(1);
            } else {
            	tab.setSavelearn(0);
            }

            if (tab.errCode != 0) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			} else if (!tab.putToSink(null)) {
				t4dialog.showException(tab.errCode + "\r\n" + tab.errMess, false);
				return;
			}

			curr_uniqueid = tab.getUniqueid();
    		Globals.project_uniqueid = curr_uniqueid;

			Globals.t4base.deleteLearningCurve(curr_uniqueid);
            Globals.t4base.deleteWeights(curr_uniqueid);
			Globals.t4md.initializeNeuralNetwork(curr_uniqueid);
            
			Globals.info_message.setText(Globals.message.getMessage("msg0022"));
			createCurrentData(curr_uniqueid);

		} else {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
		}
	}

	/**
	 * The method <CODE>btnReturn_actionPerformed</CODE> action of the btnReturn.
	 * @param e the ActionEvent.
	 * @exception Exception
	 * @since 1.0
	 */
	private void btnReturn_actionPerformed(ActionEvent e) throws Exception {
		Globals.info_message.setText("");
    	sclScreen.setVisible(false);
		fireSiteChangeEvent_1(curr_uniqueid);
	}

	/**
	 * The method <CODE>setGetData</CODE> adds a new contact item.
	 * @param uniqueid the key of the new item.
	 * @exception Exception
	 * @since 1.0
	 */
	public void setGetData(String uniqueid) throws Exception {
		tfDate.setText(uniqueid);
	}

	/**
	 * The method <CODE>createNewData</CODE> resets the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createNewData() throws Exception {
        sclScreen.setVisible(true);
        curr_uniqueid = null;
        tfName.setText("");
	    tfDate.setText(Globals.t4d.getDate2String(new Date(), SystemService.getDateDef()));
        tfXLayer.setText("0");
        tfHLayer.setText("0");
        tfYLayer.setText("0");
        tfEpsilon.setText("0");
        lblLearnsteps.setText("0");
        Globals.learn_steps = 0;
	    taRemarks.setText("");
	    x_number_old = 0;
	    y_number_old = 0;
	    btnNamesXLayer.setEnabled(false);
	    btnNamesYLayer.setEnabled(false);
	    cbSaveLearn.setSelected(false);
	}

	/**
	 * The method <CODE>createCurrentData</CODE> get data for the controls.
	 * @exception Exception
	 * @since 1.0
	 */
	public void createCurrentData(String uniqueid) throws Exception {
		super.createCurrentData();

	    btnNamesXLayer.setEnabled(true);
	    btnNamesYLayer.setEnabled(true);

	    sclScreen.setVisible(true);
		curr_uniqueid = uniqueid;

	    DbAccessReadProject tab = new DbAccessReadProject(Globals.sysUser,
				uniqueid, "all", null, null);
		if (tab.errCode != 0) {
			t4dialog.showException(tab.errCode + "\r\n" + tab.errMess);
			return;
		}

		x_number_old = (int) tab.getXlayer();
		y_number_old = (int) tab.getYlayer();
		
        tfName.setText(tab.getName());
        tfDate.setText(tab.getFieldAsString("projdate"));
        tfXLayer.setText(tab.getFieldAsString("xlayer"));
        tfHLayer.setText(tab.getFieldAsString("hlayer"));
        tfYLayer.setText(tab.getFieldAsString("ylayer"));
        tfEpsilon.setText(tab.getFieldAsString("epsilon"));
        lblLearnsteps.setText(tab.getFieldAsString("learnsteps"));
        if (tab.getSavelearn() == 1) {
        	cbSaveLearn.setSelected(true);
        } else {
        	cbSaveLearn.setSelected(false);
        }
        taRemarks.setText(tab.getRemarks());

	}
}
