package n4e.netanddecision.system;

import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Properties;

import n4e.core.list.List4SysUser;
import n4e.core.system.GlobalsDialog;
import n4e.core.tool.Tool4Array;
import n4e.core.tool.Tool4Date;
import n4e.core.tool.Tool4DbDatabase;
import n4e.core.tool.Tool4DbMessages;
import n4e.core.tool.Tool4Dialog;
import n4e.core.tool.Tool4ExpertStochastic;
import n4e.core.tool.Tool4ExpertSystemDeterministic;
import n4e.core.tool.Tool4File;
import n4e.core.tool.Tool4NeuralNetwork;
import n4e.core.tool.Tool4Number;
import n4e.core.tool.Tool4String;
import n4e.core.tool.Tool4Throwable;
import n4e.netanddecision.screen.InfoBarDataSite;
import n4e.netanddecision.tool.Tool4Database;
import n4e.netanddecision.tool.Tool4MyDialog;
import n4e.netanddecision.tool.Tool4NADMessage;
import n4e.netanddecision.tool.Tool4XML;

/**
 * The <CODE>Globals</CODE> class holds global data.
 * <P><B>title: AstronomicCameraAtik</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2015 thomas kaffka, born 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 19.04.2015 10:25:42
 * @since 1.0
 */

public class Globals {

	public static final int X_LAYER = 1;
	public static final int Y_LAYER = 2;
	
    private static Properties props = null; // the properties of the sn system.
    private static File file = null; // file of properties.

    public static Font fontStandard11 = null; // the standard font.
    public static Font fontStandard12 = null; // the standard font.
    public static Font fontStandard9 = null; // the standard font.
    public static Font fontStandardBig = null; // the standard font.
    public static Font fontStandardBigBold = null; // the standard font.
    public static Font fontResult12 = null; // the result font.
    public static Font fontStandardBigBig60 = null; // the standard font.
    public static Font fontStandardBigBig40 = null; // the standard font.

    public static Color color_graphic_background; // the graphic background color.
    public static Color color_graphic_coordinate; // the color of the coordinate system.
    public static Color color_graphic_paint_point; // the graphic paint color for points.
    public static Color color_graphic_paint_line; // the graphic paint color lines.
    public static Color color_graphic_border; // the graphic border color.
    public static Color color_graphic_grid; // the graphic grid color.
    public static Color color_graphic_average; // the graphic average color.

    public static List4SysUser sysUser; // system user object.
    public static Tool4DbMessages message = null; // the messages in the specified language.

    public static String form_file_path = ""; // the path of the form transfer.
    
    public static boolean has_changed = false;
	public static boolean debug = false;
	public static int window_width;
	public static int window_height;
	public static int delay_training;
	public static int delay_weights;
	public static int delay_graphics;
	
	public static int label_height = 20;
	public static int label_width = 200;
	public static int control_height = 20;
	public static int control_width = 200;
	
	public static int learn_steps;
    public static ArrayList<ArrayList<Number>> examples;
    public static String project_uniqueid;
	
	public static NetAndDecision nad;
	
	public static InfoBarDataSite info_message;

    public static Tool4DbDatabase t4db;
	public static Tool4File t4f;
	public static Tool4Database t4base;
	public static Tool4MyDialog t4md;
	public static Tool4Date t4d;
    public static Tool4ExpertSystemDeterministic t4ex;
    public static Tool4ExpertStochastic t4exps;
    public static Tool4String t4s;
    public static Tool4Array t4a;
    public static Tool4Dialog t4dialog;
    public static Tool4Number t4n;
    public static Tool4XML t4xml;
    public static Tool4NeuralNetwork t4nn;

    /**
	 * The constructor <CODE>Globals</CODE> creates a new instance(object) of the class.
	 * @since 1.0
	 */
	public Globals() {

        try {
        	
			t4f = new Tool4File();
			t4base = new Tool4Database();
			t4md = new Tool4MyDialog();
			t4d = new Tool4Date();
			t4s = new Tool4String();
			t4a = new Tool4Array();
			t4dialog = new Tool4Dialog(null);
			t4n = new Tool4Number();
			t4xml = new Tool4XML();

			file = t4f.getConfigFile("netanddecision.config");
	        props = new Properties();
	        props.load(new FileInputStream(file));
	
	        System.out.println("*****************************");
	        System.out.println("* InitialisationLog for NAD *");
	        System.out.println("*****************************");
	
            String temp = props.getProperty("window_width");
            window_width = Integer.parseInt(temp);
            System.out.println("- window_width                = " + window_width);
            
            temp = props.getProperty("window_height");
            window_height = Integer.parseInt(temp);
            System.out.println("- window_height               = " + window_height);

            temp = props.getProperty("delay_training");
            delay_training = Integer.parseInt(temp);
            System.out.println("- delay_training              = " + delay_training);

            temp = props.getProperty("delay_weights");
            delay_weights = Integer.parseInt(temp);
            System.out.println("- delay_weights               = " + delay_weights);

            temp = props.getProperty("delay_graphics");
            delay_graphics = Integer.parseInt(temp);
            System.out.println("- delay_graphics              = " + delay_graphics);

            System.out.println("*******************************************");
	        
            fontStandard11 = new Font("Dialog", Font.PLAIN, 11);
            fontStandard12 = new Font("Dialog", Font.PLAIN, 12);
            fontStandard9 = new Font("Dialog", Font.PLAIN, 9);
			fontStandardBig = new Font("Dialog", Font.PLAIN, 12);
			fontStandardBigBold = new Font("Dialog", Font.BOLD, 12);
			fontStandardBigBig40 = new Font("Dialog", Font.PLAIN, 40);
			fontStandardBigBig60 = new Font("Dialog", Font.PLAIN, 60);
			fontResult12 = new Font("Monospaced", Font.PLAIN, 12);

			color_graphic_background = new Color(238, 238, 238);
		    color_graphic_coordinate = Color.DARK_GRAY;
		    color_graphic_paint_point = new Color(0, 82, 164);
		    color_graphic_paint_line =  new Color(68, 155, 66);
		    color_graphic_border = Color.BLACK;
		    color_graphic_grid = new Color(255, 203, 138);
		    color_graphic_average = new Color(121, 160, 31);
		    
        } catch (Exception ex) {
            System.out.println("Globals: error while initialising and getting the properties.");
            System.out.println(Tool4Throwable.getCallStackOut(ex));
		}
	}

    /**
     * The method <CODE>doAfterInitials</CODE> do initializations after instantiate.
     * @since 1.0
     */
    public static void doAfterInitials() throws Exception {
		sysUser = new List4SysUser("netanddecision", "netanddecision", 
      		  GlobalsDialog.language_code, GlobalsDialog.supported_languages);
    	t4db = new Tool4DbDatabase(sysUser);
    	t4ex = new Tool4ExpertSystemDeterministic(sysUser, "core", false);
		Tool4NADMessage t4m = new Tool4NADMessage(sysUser);
		message = t4m.getMessages();
    }
    
    /**
     * The method <CODE>saveGlobalsProperties</CODE> writes parameter settings to properties file.
     * @since 1.0
     */
    public static void saveGlobalsProperties() throws Exception {
        if (has_changed) {
            props.setProperty("window_width" , Integer.toString(window_width));
            props.setProperty("window_height" , Integer.toString(window_height));
            props.setProperty("delay_training" , Integer.toString(delay_training));
            props.setProperty("delay_weights" , Integer.toString(delay_weights));
            props.setProperty("delay_graphics" , Integer.toString(delay_graphics));
            props.store(new FileOutputStream(file) , getPropertieComment());
        }
    }
    
    /**
     * The method <CODE>getPropertieComment</CODE> gets the comments of the properties file.
     * @return the commends.
     * @exception Exception
     * @since 1.0
     */
    public static String getPropertieComment() {
        String commends = "";
        commends += "#**************************************************************************\r\n";
        commends += "#* net and decision / system parameter                                     *\r\n";
        commends += "#* author: thomas kaffka, cologne , germany                                *\r\n";
        commends += "#* version: 0.1                                                            *\r\n";
        commends += "#* date: 02/18/2017                                                        *\r\n";
        commends += "#* copyright (c) 2017 thomas kaffka . cologne . germany                    *\r\n";
        commends += "#***************************************************************************\r\n";
        return commends;
    }

}

