package n4e.netanddecision.tool;


/**
 * The <CODE>Tool4XML</CODE> class provides functions for xml processing.
 * <P><B>title: NetAndDecision</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2017 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 20.02.2017 11:06:18
 * @since 1.0
 */
public class Tool4XML {

	/**
	 * The constructor <CODE>Tool4XML</CODE> creates a new instance(object) of the class.
	 * @since 1.0
	 */
	public Tool4XML() {
	}

	/**
	 * The method <CODE>getExampleHeader</CODE> get the xml header of the example file. 
	 * @param nnetwork the name of the neural network.
	 * @param number_x the number of the x components.
	 * @param number_y the number of the y components.
	 * @return the xml listing.
	 * @since 1.0
	 */
	public String getExampleHeader(String nnetwork, int number_x, int number_y) {
        String listing = "";
        listing += "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\r\n";
        listing += "<!-- examples of the neural network: " + nnetwork + " -->\r\n";
        listing += "<!DOCTYPE NeuralNetwork [\r\n";
        listing += "  <!ELEMENT NeuralNetwork ANY>\r\n";
        listing += "  <!ATTLIST NeuralNetwork name CDATA #REQUIRED>\r\n";
        listing += "  <!ATTLIST NeuralNetwork numberx CDATA #REQUIRED>\r\n";
        listing += "  <!ATTLIST NeuralNetwork numbery CDATA #REQUIRED>\r\n";
        listing += "  <!ELEMENT ExampleX ANY>\r\n";
        listing += "  <!ATTLIST ExampleX value CDATA #REQUIRED>\r\n";
        listing += "  <!ELEMENT ExampleY ANY>\r\n";
        listing += "  <!ATTLIST ExampleY value CDATA #REQUIRED>\r\n";
        listing += "]>\r\n";
        listing += "<NeuralNetwork name=\"" + nnetwork + "\" numberx=\"" + Integer.toString(number_x) + "\" numbery=\"" + Integer.toString(number_y) + "\">\r\n"; 
        listing += "@examplelist@";
        listing += "\r\n</NeuralNetwork>\r\n";
        return listing;
	}

	/**
	 * The method <CODE>getExampleXValue</CODE> get the xml x value of the example file. 
	 * @param value the value.
	 * @return the xml listing.
	 * @since 1.0
	 */
	public String getExampleXValue(String value) {
        return "   <ExampleX value=\"" + value + "\" />\r\n";
	}
		
	/**
	 * The method <CODE>getExampleYValue</CODE> get the xml y value of the example file. 
	 * @param value the value.
	 * @return the xml listing.
	 * @since 1.0
	 */
	public String getExampleYValue(String value) {
        return "   <ExampleY value=\"" + value + "\" />\r\n";
	}
}
