package de.password.tool;

import java.awt.Image;
import java.awt.Toolkit;

import javax.swing.ImageIcon;

import n4e.core.tool.Tool4Throwable;

/**
 * The <CODE>Tool4MyDialog</CODE> class provides common dialog functions.
 * <P><B>title: AssociativeMemory</B></P>
 * <P>description: AssociativeMemory</P>
 * <P>copyright: (c) 2017 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , cologne , germany.
 * @version 08.02.2017 08:41:18
 * @since 0.1
 */

public class Tool4MyDialog {

	/**
	 * The constructor <CODE>Tool4MyDialog</CODE> creates a new instance(object) of the class.
	 * @since 1.0
	 */
	public Tool4MyDialog() {
	}

	/**
	 * The method <CODE>getImage</CODE> gets an image from the picture folder.
	 * @param picname name of the picture to get.
	 * @return image object.
	 * @exception Exception if error.
	 * @since 0.1
	 */
	public Image getImagePure(String picname) throws Exception {
		try {
			Toolkit tk = Toolkit.getDefaultToolkit();
			Image im = tk.getImage(getClass().getResource("resources/" + picname)); 
			while (!tk.prepareImage(im, -1, -1, null)) {
				try {
					Thread.sleep(200);
				} catch (Exception ex) {
					
				}
			}
			return im;
		} catch (Exception ex) {
			System.out.println("getImagePure " + Tool4Throwable.getCallStackOut(ex));
		}
		return null;
	}

}

