package de.perzeptron.system;

import java.awt.Font;

import de.perzeptron.tool.Tool4MyDialog;
import de.perzeptron.tool.Tool4PMessage;
import n4e.core.system.GlobalsDialog;
import n4e.core.tool.Tool4DbMessages;
import n4e.core.tool.Tool4Dialog;
import n4e.core.tool.Tool4Throwable;

/**
 * The <CODE>Globals</CODE> class provides global parameters.
 * <P><B>title: Perzeptron</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2017 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , cologne , germany.
 * @version 08.02.2017 12:20:57
 * @since 0.1
 */

public class Globals {

	public static final int LINES = 12; // number of connections.
	
    public static Font fontStandard11 = null; // the standard font.
    public static Font fontResult11 = null; // the result font.

    public static Tool4DbMessages message = null; // the messages in the specified language.

	public static Perzeptron p;
	
	public static Tool4MyDialog t4md;
	public static Tool4Dialog t4d;
	
    /**
	 * The constructor <CODE>Globals</CODE> creates a new instance(object) of the class.
	 * @since 0.1
	 */
	public Globals() {

        try {
        	
        	t4md = new Tool4MyDialog();
	        
            fontStandard11 = new Font("Dialog", Font.PLAIN, 11);
			fontResult11 = new Font("Monospaced", Font.PLAIN, 11);
		    
        } catch (Exception ex) {
            System.out.println("Globals: error while initialising.");
            System.out.println(Tool4Throwable.getCallStackOut(ex));
		}
	}

    /**
     * The method <CODE>doAfterInitials</CODE> do initializations after instantiate.
     * @since 0.1
     */
    public static void doAfterInitials() throws Exception {
		Tool4PMessage t4m = new Tool4PMessage(GlobalsDialog.language_code);
		message = t4m.getMessages();
    	t4d = new Tool4Dialog(p);
    }
    
}

