package n4e.rockthrow.system;

import java.awt.Font;

import n4e.core.system.GlobalsDialog;
import n4e.core.tool.Tool4DbMessages;
import n4e.core.tool.Tool4Dialog;
import n4e.core.tool.Tool4File;
import n4e.core.tool.Tool4String;
import n4e.core.tool.Tool4Throwable;
import n4e.rockthrow.tool.Tool4MyDialog;
import n4e.rockthrow.tool.Tool4RTMessage;
import n4e.rockthrow.tool.Tool4XML;

/**
 * The <CODE>Globals</CODE> class provides global parameters.
 * <P><B>title: AssociativeMemory</B></P>
 * <P>description: </P>
 * <P>copyright: (c) 2011 thomas kaffka, born at 11/08/1959 in dsseldorf - germany , all rights reserved.</P>
 * @author thomas kaffka , mba , cologne , germany.
 * @version 08.02.2017 12:20:57
 * @since 0.1
 */

public class Globals {

	public static final int LINES = 12; // number of connections.
	
    public static Font fontStandard11 = null; // the standard font.
    public static Font fontResult11 = null; // the result font.

    public static Tool4DbMessages message = null; // the messages in the specified language.

	public static RockThrow rt;
	
	public static Tool4MyDialog t4md;
	public static Tool4Dialog t4d;
	public static Tool4XML t4xml;
    public static Tool4String t4s;
    public static Tool4File t4f;
	
    /**
	 * The constructor <CODE>Globals</CODE> creates a new instance(object) of the class.
	 * @since 0.1
	 */
	public Globals() {

        try {
        	
        	t4md = new Tool4MyDialog();
        	t4xml = new Tool4XML();
			t4s = new Tool4String();
			t4f = new Tool4File();
	        
            fontStandard11 = new Font("Dialog", Font.PLAIN, 11);
			fontResult11 = new Font("Monospaced", Font.PLAIN, 11);
		    
        } catch (Exception ex) {
            System.out.println("Globals: error while initialising.");
            System.out.println(Tool4Throwable.getCallStackOut(ex));
		}
	}

    /**
     * The method <CODE>doAfterInitials</CODE> do initializations after instantiate.
     * @since 0.1
     */
    public static void doAfterInitials() throws Exception {
		Tool4RTMessage t4m = new Tool4RTMessage(GlobalsDialog.language_code);
		message = t4m.getMessages();
    	t4d = new Tool4Dialog(rt);
    }
    
}

